' Copyright (c) Microsoft Corporation. Alle Rechte vorbehalten.
Imports System
Imports System.Runtime.InteropServices

' Delegate Objekt 
Public Delegate Function Device_CallBack() As Integer


Public Class CallingVariations

    'Public Const SERVER_PORT As Long = 8000    ' COM-Server Port Standard bei W&T
    Public Const MB_ADD_OFFLINE As Integer = &HFE  ' Mod-Bus-Adresse Offline

    ' Nummer der Speichergroesse fuer Listen. Muss beim AEIII+ immer "0" sein
    ' (ist vom Timeboy uebernommen).
    ' Es sind 100kByte fuer Listen fest eingestellt.
    Public Const FIX_LISTMEMSIZENUM As Integer = 0

    ' Fehlerdefinitionen
    Public Const ERROR_NO As Integer = 0  ' Kein Fehler
    Public Const ERROR_CRC As Integer = 1  ' CRC Fehler
    Public Const ERROR_COM_INIT As Integer = 2  ' Oeffnen der Schnittstelle fehlgeschlagen
    Public Const ERROR_COM_CLOSED As Integer = 3  ' Schnittstelle ist geschlossen
    Public Const ERROR_COM As Integer = 4  ' Allgemeiner Fehler waehrend Kommunikation
    Public Const ERROR_NO_ANSWER As Integer = 5  ' Geraet antwortet nicht mehr
    Public Const ERROR_AT_SENDING As Integer = 6  ' Fehler waehrend senden eingetreten
    Public Const ERROR_AT_RECIEVING As Integer = 7  ' Fehler waehrend empfang eingetreten
    Public Const ERROR_SENDER As Integer = 8  ' Antwort von falschem Geraet oder Antwort nicht sinnvoll
    Public Const ERROR_BUS_NUM As Integer = 9  ' Keine gueltige Busnummer (1 - 31, 254)
    Public Const ERROR_CHANNEL As Integer = 10 ' Kanal nicht vorhanden oder nicht erstellbar.
    Public Const ERROR_OPEN As Integer = 11 ' Oeffnen einer Datei gescheitert
    Public Const ERROR_FORMAT As Integer = 12 ' z.B. falsches Format einer Setup-Datei
    Public Const ERROR_LIST As Integer = 13 ' Fehler bei Listendatenverarbeitung
    Public Const ERROR_FW_VERSION As Integer = 14 ' Firmwareversion nicht kompatible zu Routine
    Public Const ERROR_IS_DATA As Integer = 15 ' Es sind noch Daten im Geraet vorhanden.
    Public Const ERROR_BREAK As Integer = 16 ' Durchfuehrung wurde von Anwender abgebrochen
    Public Const ERROR_NO_RD As Integer = 17 ' Keine Datensatzbeschreibung im Kanal geladen.
    Public Const ERROR_NO_LD As Integer = 18 ' Keine Listenbeschreibung im Kanal geladen.
    Public Const ERROR_FLASH_PROG As Integer = 19 ' Fehler beim Programmieren des Flash, Firmware.
    Public Const ERROR_RANGE As Integer = 20 ' Parameter einer Funktion ausserhalb ihres Gueltigkeitsbereiches.
    Public Const ERROR_NOT_DEFINED As Integer = 21 ' Globale Variable nicht definiert.
    Public Const ERROR_NO_DATA As Integer = 22 ' Anfrage obwohl keine Daten.

    ' Aufrufvarianten der Funktionen aus der DFComDLL
    ' per Deklaration

    ' ****************************************************************************************************************************************
    ' ********************
    ' ********************
    ' Allgemeine Funktionen
    ' ********************
    ' ********************
    ' DFCComInit
    ' Declare
    Public Declare Function DFCComInit_Declare Lib "DFComDll" Alias _
    "_DFCComInit@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComInit")> _
        Public Shared Function DFCComInit_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComInit_Unicode Lib "DFComDll" Alias "_DFCComInit@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComInit_ANSI Lib "DFComDll" Alias "_DFCComInit@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComInit_Auto Lib "DFComDll" Alias "_DFCComInit@4" _
        (ByVal ComNum As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComOpenSerial
    ' Declare
    Public Declare Function DFCComOpenSerial_Declare Lib "DFComDll" Alias _
        "_DFCComOpenSerial@16" (ByVal ComNum As Integer, ByVal ComPort As String, ByVal BaudRate As Integer, ByVal TimeOut As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComOpenSerial")> _
        Public Shared Function DFCComOpenSerial_Import(ByVal ComNum As Integer, ByVal ComPort As String, ByVal BaudRate As Integer, ByVal TimeOut As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComOpenSerial_Unicode Lib "DFComDll" Alias "_DFCComOpenSerial@16" _
        (ByVal ComNum As Integer, ByVal ComPort As String, ByVal BaudRate As Integer, ByVal TimeOut As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComOpenSerial_ANSI Lib "DFComDll" Alias "_DFCComOpenSerial@16" _
        (ByVal ComNum As Integer, ByVal ComPort As String, ByVal BaudRate As Integer, ByVal TimeOut As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComOpenSerial_Auto Lib "DFComDll" Alias "_DFCComOpenSerial@16" _
        (ByVal ComNum As Integer, ByVal ComPort As String, ByVal BaudRate As Integer, ByVal TimeOut As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComOpen
    ' Declare
    Public Declare Function DFCComOpen_Declare Lib "DFComDll" Alias _
    "_DFCComOpen@8" (ByVal ComNum As Integer, ByVal Host As String) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComOpen")> _
        Public Shared Function DFCComOpen_Import(ByVal ComNum As Integer, ByVal Host As String) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComOpen_Unicode Lib "DFComDll" Alias "_DFCComOpen@8" _
        (ByVal ComNum As Integer, ByVal Host As String) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComOpen_ANSI Lib "DFComDll" Alias "_DFCComOpen@8" _
        (ByVal ComNum As Integer, ByVal Host As String) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComOpen_Auto Lib "DFComDll" Alias "_DFCComOpen@8" _
        (ByVal ComNum As Integer, ByVal Host As String) As Integer

    ' ********************
    ' ********************
    ' DFCSetOptionFirmware
    ' Declare
    Public Declare Function DFCSetOptionFirmware_Declare Lib "DFComDll" Alias "_DFCSetOptionFirmware@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Mask As Integer, ByVal Opt As Integer, ByRef err As Integer) As Integer


    Public Declare Function DFCGetOptionFirmware_Declare Lib "DFComDll" Alias "_DFCGetOptionFirmware@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef Mask As Integer, ByRef Opt As Integer, ByRef err As Integer) As Integer



    ' ********************
    ' ********************
    ' Aktive Verbindung
    ' Declare
    Public Declare Function DFCStartActiveConnection_Declare Lib "DFComDll" Alias "_DFCStartActiveConnection@36" _
        (ByVal IP As String, ByVal Port As Integer, ByVal DeviceID As Integer, ByVal Timeout As Integer, ByVal AliveTO As Integer, ByVal maxConects As Integer, ByVal InfoFlag As Integer, ByVal reserved As Integer, ByRef err As Integer) As Integer

    Public Declare Function DFCStopActiveConnection_Declare Lib "DFComDll" Alias "_DFCStopActiveConnection@4" _
        (ByRef err As Integer) As Integer

    Public Declare Function DFCGetFirstActiveChannelID_Declare Lib "DFComDll" Alias "_DFCGetFirstActiveChannelID@0" () As Integer

    Public Declare Function DFCGetNextActiveChannelID_Declare Lib "DFComDll" Alias "_DFCGetNextActiveChannelID@4" (ByVal Prev As Integer) As Integer

    Public Declare Function DFCGetInfoActiveChannel_Declare Lib "DFComDll" Alias "_DFCGetInfoActiveChannel@12" _
        (ByVal ComNum As Integer, ByVal Info As String, ByRef lenght As Integer) As Integer

    Public Declare Function DFCSetRecordAvailable_Declare Lib "DFComDll" Alias "_DFCSetRecordAvailable@4" _
        (ByVal SetEnable As Integer) As Integer

    Public Declare Function DFCRecordAvailable_Declare Lib "DFComDll" Alias "_DFCRecordAvailable@20" _
        (ByRef ComNum As Integer, ByRef Device As Integer, ByVal InfoString As String, ByRef InfoLength As Integer, ByRef nError As Integer) As Integer

    Public Declare Function DFCBindDeviceToChannel_Declare Lib "DFComDll" Alias "_DFCBindDeviceToChannel@20" _
        (ByVal ComNum As Integer, ByVal DeviceType As Integer, ByVal DeviceSerial As Integer, ByVal DeviceIP As String, ByRef nError As Integer) As Integer






    ' ********************
    ' ********************
    ' DFCComOpenSocket
    ' Declare
    Public Declare Function DFCComOpenSocket_Declare Lib "DFComDll" Alias _
    "_DFCComOpenSocket@16" (ByVal ComNum As Integer, ByVal RemoteIP As String, ByVal PortNum As Integer, ByVal TimeOut As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComOpenSocket")> _
        Public Shared Function DFCComOpenSocket_Import(ByVal ComNum As Integer, ByVal RemoteIP As String, ByVal PortNum As Integer, ByVal TimeOut As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComOpenSocket_Unicode Lib "DFComDll" Alias "_DFCComOpenSocket@16" _
        (ByVal ComNum As Integer, ByVal RemoteIP As String, ByVal PortNum As Integer, ByVal TimeOut As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComOpenSocket_ANSI Lib "DFComDll" Alias "_DFCComOpenSocket@16" _
        (ByVal ComNum As Integer, ByVal RemoteIP As String, ByVal PortNum As Integer, ByVal TimeOut As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComOpenSocket_Auto Lib "DFComDll" Alias "_DFCComOpenSocket@16" _
        (ByVal ComNum As Integer, ByVal RemoteIP As String, ByVal PortNum As Integer, ByVal TimeOut As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComOpenIV
    ' Declare
    Public Declare Function DFCComOpenIV_Declare Lib "DFComDll" Alias _
    "_DFCComOpenIV@24" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ComType As Integer, ByVal szComString As String, ByVal ComValue As Integer, ByVal ComTimeOut As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCComOpenIV")> _
        Public Shared Function DFCComOpenIV_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ComType As Integer, ByVal szComString As String, ByVal ComValue As Integer, ByVal ComTimeOut As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComOpenIV_Unicode Lib "DFComDll" Alias "_DFCComOpenIV@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ComType As Integer, ByVal szComString As String, ByVal ComValue As Integer, ByVal ComTimeOut As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComOpenIV_ANSI Lib "DFComDll" Alias "_DFCComOpenIV@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ComType As Integer, ByVal szComString As String, ByVal ComValue As Integer, ByVal ComTimeOut As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComOpenIV_Auto Lib "DFComDll" Alias "_DFCComOpenIV@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ComType As Integer, ByVal szComString As String, ByVal ComValue As Integer, ByVal ComTimeOut As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComClose
    ' Declare
    Public Declare Function DFCComClose_Declare Lib "DFComDll" Alias _
    "_DFCComClose@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComClose")> _
        Public Shared Function DFCComClose_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComClose_Unicode Lib "DFComDll" Alias "_DFCComClose@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComClose_ANSI Lib "DFComDll" Alias "_DFCComClose@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComClose_Auto Lib "DFComDll" Alias "_DFCComClose@4" _
        (ByVal ComNum As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCCheckAE
    ' Declare
    Public Declare Function DFCCheckAE_Declare Lib "DFComDll" Alias _
    "_DFCCheckAE@8" (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCCheckAE")> _
        Public Shared Function DFCCheckAE_Import(ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCCheckAE_Unicode Lib "DFComDll" Alias "_DFCCheckAE@8" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCCheckAE_ANSI Lib "DFComDll" Alias "_DFCCheckAE@8" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCCheckAE_Auto Lib "DFComDll" Alias "_DFCCheckAE@8" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCCheckDevice
    ' Declare
    Public Declare Function DFCCheckDevice_Declare Lib "DFComDll" Alias _
    "_DFCCheckDevice@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByVal PollRetry As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCCheckDevice")> _
        Public Shared Function DFCCheckDevice_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByVal PollRetry As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCCheckDevice_Unicode Lib "DFComDll" Alias "_DFCCheckDevice@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByVal PollRetry As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCCheckDevice_ANSI Lib "DFComDll" Alias "_DFCCheckDevice@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByVal PollRetry As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCCheckDevice_Auto Lib "DFComDll" Alias "_DFCCheckDevice@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByVal PollRetry As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComSetTime
    ' Declare
    Public Declare Function DFCComSetTime_Declare Lib "DFComDll" Alias _
    "_DFCComSetTime@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComSetTime")> _
        Public Shared Function DFCComSetTime_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComSetTime_Unicode Lib "DFComDll" Alias "_DFCComSetTime@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComSetTime_ANSI Lib "DFComDll" Alias "_DFCComSetTime@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComSetTime_Auto Lib "DFComDll" Alias "_DFCComSetTime@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer

    ' ********************
    ' ********************
    ' DFCComGetTime
    ' Declare
    Public Declare Function DFCComGetTime_Declare Lib "DFComDll" Alias _
    "_DFCComGetTime@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComGetTime")> _
        Public Shared Function DFCComGetTime_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComGetTime_Unicode Lib "DFComDll" Alias "_DFCComGetTime@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComGetTime_ANSI Lib "DFComDll" Alias "_DFCComGetTime@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComGetTime_Auto Lib "DFComDll" Alias "_DFCComGetTime@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String) As Integer

    ' ********************
    ' ********************
    ' DFCComSendMessage
    ' Declare
    Public Declare Function DFCComSendMessage_Declare Lib "DFComDll" Alias _
    "_DFCComSendMessage@28" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String, ByVal DelayTime As String, ByVal Action As String, ByVal Audio As String, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComSendMessage")> _
        Public Shared Function DFCComSendMessage_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String, ByVal DelayTime As String, ByVal Action As String, ByVal Audio As String, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComSendMessage_Unicode Lib "DFComDll" Alias "_DFCComSendMessage@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String, ByVal DelayTime As String, ByVal Action As String, ByVal Audio As String, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComSendMessage_ANSI Lib "DFComDll" Alias "_DFCComSendMessage@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String, ByVal DelayTime As String, ByVal Action As String, ByVal Audio As String, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComSendMessage_Auto Lib "DFComDll" Alias "_DFCComSendMessage@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DateTime As String, ByVal DelayTime As String, ByVal Action As String, ByVal Audio As String, ByVal Message As String, ByVal MsgLength As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComSendInfotext
    ' Declare
    Public Declare Function DFCComSendInfotext_Declare Lib "DFComDll" Alias _
    "_DFCComSendInfotext@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCComSendInfotext")> _
        Public Shared Function DFCComSendInfotext_Import(ByVal ComNum As Integer, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComSendInfotext_Unicode Lib "DFComDll" Alias "_DFCComSendInfotext@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComSendInfotext_ANSI Lib "DFComDll" Alias "_DFCComSendInfotext@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Message As String, ByVal MsgLength As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComSendInfotext_Auto Lib "DFComDll" Alias "_DFCComSendInfotext@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Message As String, ByVal MsgLength As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCGetSerial
    ' Seriennummer Lesen
    ' Declare
    Public Declare Function DFCGetSerial_Declare Lib "DFComDll" Alias _
    "_DFCGetSeriennummer@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByRef Serial As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCGetSeriennummer")> _
        Public Shared Function DFCGetSerial_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByRef Serial As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetSerial_Unicode Lib "DFComDll" Alias "_DFCGetSeriennummer@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByRef Serial As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetSerial_ANSI Lib "DFComDll" Alias "_DFCGetSeriennummer@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByRef Serial As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetSerial_Auto Lib "DFComDll" Alias "_DFCGetSeriennummer@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer, ByRef Serial As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCSetLogOn
    ' Declare
    Public Declare Function DFCSetLogOn_Declare Lib "DFComDll" Alias _
    "_DFCSetLogOn@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSetLogOn@4")> _
        Public Shared Function DFCSetLogOn_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetLogOn_Unicode Lib "DFComDll" Alias "_DFCSetLogOn@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetLogOn_ANSI Lib "DFComDll" Alias "_DFCSetLogOn@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetLogOn_Auto Lib "DFComDll" Alias "_DFCSetLogOn@4" _
        (ByVal ComNum As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCSetLogOff
    ' Declare
    Public Declare Function DFCSetLogOff_Declare Lib "DFComDll" Alias _
    "_DFCSetLogOff@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSetLogOff@4")> _
        Public Shared Function DFCSetLogOff_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetLogOff_Unicode Lib "DFComDll" Alias "_DFCSetLogOff@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetLogOff_ANSI Lib "DFComDll" Alias "_DFCSetLogOff@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetLogOff_Auto Lib "DFComDll" Alias "_DFCSetLogOff@4" _
        (ByVal ComNum As Integer) As Integer



    ' **********************************************************************************************
    ' **********************************************************************************************
    ' ********************
    ' ********************
    ' DFCSetCallBack
    ' Declare
    Public Declare Function DFCSetCallBack_Declare Lib "DFComDll" Alias _
    "_DFCSetCallBack@8" (ByVal ComNum As Integer, ByVal pCallBack As Device_CallBack) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCSetCallBack")> _
        Public Shared Function DFCSetCallBack_Import(ByVal ComNum As Integer, ByVal pCallBack As Device_CallBack) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetCallBack_Unicode Lib "DFComDll" Alias "_DFCSetCallBack@8" _
        (ByVal ComNum As Integer, ByVal pCallBack As Device_CallBack) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetCallBack_ANSI Lib "DFComDll" Alias "_DFCSetCallBack@8" _
        (ByVal ComNum As Integer, ByVal pCallBack As Device_CallBack) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetCallBack_Auto Lib "DFComDll" Alias "_DFCSetCallBack@8" _
        (ByVal ComNum As Integer, ByVal pCallBack As Device_CallBack) As Integer


    ' ********************
    ' ********************
    ' DFCSetLogFileName
    ' Declare
    Public Declare Function DFCSetLogFileName_Declare Lib "DFComDll" Alias _
    "_DFCSetLogFileName@8" (ByVal ComNum As Integer, ByVal LogFile As String) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSetLogFileName@8")> _
        Public Shared Function DFCSetLogFileName_Import(ByVal ComNum As Integer, ByVal LogFile As String) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetLogFileName_Unicode Lib "DFComDll" Alias "_DFCSetLogFileName@8" _
        (ByVal ComNum As Integer, ByVal LogFile As String) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetLogFileName_ANSI Lib "DFComDll" Alias "_DFCSetLogFileName@8" _
        (ByVal ComNum As Integer, ByVal LogFile As String) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetLogFileName_Auto Lib "DFComDll" Alias "_DFCSetLogFileName@8" _
        (ByVal ComNum As Integer, ByVal LogFile As String) As Integer



    ' ********************
    ' ********************
    ' DFCGetErrorText
    ' Declare
    Public Declare Function DFCGetErrorText_Declare Lib "DFComDll" Alias _
    "_DFCGetErrorText@20" (ByVal ComNum As Integer, ByVal nError As Integer, ByVal Language As Integer, ByVal szError As String, ByVal StringLength As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetErrorText@20")> _
        Public Shared Function DFCGetErrorText_Import(ByVal ComNum As Integer, ByVal nError As Integer, ByVal Language As Integer, ByVal szError As String, ByVal StringLength As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetErrorText_Unicode Lib "DFComDll" Alias "_DFCGetErrorText@20" _
        (ByVal ComNum As Integer, ByVal nError As Integer, ByVal Language As Integer, ByVal szError As String, ByVal StringLength As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetErrorText_ANSI Lib "DFComDll" Alias "_DFCGetErrorText@20" _
        (ByVal ComNum As Integer, ByVal nError As Integer, ByVal Language As Integer, ByVal szError As String, ByVal StringLength As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetErrorText_Auto Lib "DFComDll" Alias "_DFCGetErrorText@20" _
        (ByVal ComNum As Integer, ByVal nError As Integer, ByVal Language As Integer, ByVal szError As String, ByVal StringLength As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCSetGlobVar
    ' Declare
    Public Declare Function DFCSetGlobVar_Declare Lib "DFComDll" Alias _
    "_DFCSetGlobVar@24" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSetGlobVar@24")> _
        Public Shared Function DFCSetGlobVar_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetGlobVar_Unicode Lib "DFComDll" Alias "_DFCSetGlobVar@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetGlobVar_ANSI Lib "DFComDll" Alias "_DFCSetGlobVar@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetGlobVar_Auto Lib "DFComDll" Alias "_DFCSetGlobVar@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCGetGlobVar
    ' Declare
    Public Declare Function DFCGetGlobVar_Declare Lib "DFComDll" Alias _
    "_DFCGetGlobVar@28" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetGlobVar@28")> _
        Public Shared Function DFCGetGlobVar_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetGlobVar_Unicode Lib "DFComDll" Alias "_DFCGetGlobVar@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetGlobVar_ANSI Lib "DFComDll" Alias "_DFCGetGlobVar@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetGlobVar_Auto Lib "DFComDll" Alias "_DFCGetGlobVar@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal GVName As String, ByVal GVTyp As Integer, ByVal GVValue As String, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCCloseRelay
    ' Declare
    Public Declare Function DFCCloseRelay_Declare Lib "DFComDll" Alias _
    "_DFCCloseRelay@20" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByVal RelTime As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCCloseRelay@20")> _
        Public Shared Function DFCCloseRelay_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByVal RelTime As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCCloseRelay_Unicode Lib "DFComDll" Alias "_DFCCloseRelay@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByVal RelTime As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCCloseRelay_ANSI Lib "DFComDll" Alias "_DFCCloseRelay@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByVal RelTime As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCCloseRelay_Auto Lib "DFComDll" Alias "_DFCCloseRelay@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByVal RelTime As Integer, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCGetRelayState
    ' Declare
    Public Declare Function DFCGetRelayState_Declare Lib "DFComDll" Alias _
    "_DFCGetRelayState@24" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef RelState As Integer, ByRef RelTime As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetRelayState@24")> _
        Public Shared Function DFCGetRelayState_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef RelState As Integer, ByRef RelTime As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetRelayState_Unicode Lib "DFComDll" Alias "_DFCGetRelayState@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef RelState As Integer, ByRef RelTime As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetRelayState_ANSI Lib "DFComDll" Alias "_DFCGetRelayState@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef RelState As Integer, ByRef RelTime As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetRelayState_Auto Lib "DFComDll" Alias "_DFCGetRelayState@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef RelState As Integer, ByRef RelTime As Integer, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCOpenRelay
    ' Declare
    Public Declare Function DFCOpenRelay_Declare Lib "DFComDll" Alias _
    "_DFCOpenRelay@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCOpenRelay@16")> _
        Public Shared Function DFCOpenRelay_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCOpenRelay_Unicode Lib "DFComDll" Alias "_DFCOpenRelay@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCOpenRelay_ANSI Lib "DFComDll" Alias "_DFCOpenRelay@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCOpenRelay_Auto Lib "DFComDll" Alias "_DFCOpenRelay@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal RelNum As Integer, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCGetDevicePollRetry
    ' Declare
    Public Declare Function DFCGetDevicePollRetry_Declare Lib "DFComDll" Alias _
    "_DFCGetDevicePollRetry@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetDevicePollRetry@4")> _
        Public Shared Function DFCGetDevicePollRetry_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetDevicePollRetry_Unicode Lib "DFComDll" Alias "_DFCGetDevicePollRetry@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetDevicePollRetry_ANSI Lib "DFComDll" Alias "_DFCGetDevicePollRetry@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetDevicePollRetry_Auto Lib "DFComDll" Alias "_DFCGetDevicePollRetry@4" _
        (ByVal ComNum As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCWrite
    ' Declare
    Public Declare Function DFCWrite_Declare Lib "DFComDll" Alias _
    "_DFCWrite@20" (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef writeLength As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCWrite@20")> _
        Public Shared Function DFCWrite_Import(ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef writeLength As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCWrite_Unicode Lib "DFComDll" Alias "_DFCWrite@20" _
        (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef writeLength As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCWrite_ANSI Lib "DFComDll" Alias "_DFCWrite@20" _
        (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef writeLength As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCWrite_Auto Lib "DFComDll" Alias "_DFCWrite@20" _
        (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef writeLength As Integer, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCRead
    ' Declare
    Public Declare Function DFCRead_Declare Lib "DFComDll" Alias _
    "_DFCRead@20" (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef readLength As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCRead@20")> _
        Public Shared Function DFCRead_Import(ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef readLength As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCRead_Unicode Lib "DFComDll" Alias "_DFCRead@20" _
        (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef readLength As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCRead_ANSI Lib "DFComDll" Alias "_DFCRead@20" _
        (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef readLength As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCRead_Auto Lib "DFComDll" Alias "_DFCRead@20" _
        (ByVal ComNum As Integer, ByVal szBuff As String, ByVal bufLength As Integer, ByRef readLength As Integer, ByRef nError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCUpload
    ' Declare
    Public Declare Function DFCUpload_Declare Lib "DFComDll" Alias _
    "_DFCUpload@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="DFCUpload")> _
        Public Shared Function DFCUpload_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCUpload_Unicode Lib "DFComDll" Alias "_DFCUpload@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCUpload_ANSI Lib "DFComDll" Alias "_DFCUpload@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCUpload_Auto Lib "DFComDll" Alias "_DFCUpload@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCUploadModule
    ' Declare
    Public Declare Function DFCUploadModule_Declare Lib "DFComDll" Alias _
    "_DFCUploadModule@20" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nTyp As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCGetVersionFirmware
    ' Declare
    Public Declare Function DFCGetVersionFirmware_Declare Lib "DFComDll" Alias _
    "_DFCGetVersionFirmware@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetVersionFirmware@16")> _
        Public Shared Function DFCGetVersionFirmware_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetVersionFirmware_Unicode Lib "DFComDll" Alias "_DFCGetVersionFirmware@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetVersionFirmware_ANSI Lib "DFComDll" Alias "_DFCGetVersionFirmware@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetVersionFirmware_Auto Lib "DFComDll" Alias "_DFCGetVersionFirmware@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal Firmware As String, ByRef ComError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCGetInfo
    ' Declare
    Public Declare Function DFCGetInfo_Declare Lib "DFComDll" Alias _
    "_DFCGetInfo@28" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ModName As String, ByVal ModParam As String, ByVal ModInfo As String, ByVal bufLength As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetInfo@28")> _
        Public Shared Function DFCGetInfo_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ModName As String, ByVal ModParam As String, ByVal ModInfo As String, ByVal bufLength As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetInfo_Unicode Lib "DFComDll" Alias "_DFCGetInfo@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ModName As String, ByVal ModParam As String, ByVal ModInfo As String, ByVal bufLength As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetInfo_ANSI Lib "DFComDll" Alias "_DFCGetInfo@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ModName As String, ByVal ModParam As String, ByVal ModInfo As String, ByVal bufLength As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetInfo_Auto Lib "DFComDll" Alias "_DFCGetInfo@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ModName As String, ByVal ModParam As String, ByVal ModInfo As String, ByVal bufLength As Integer, ByRef nError As Integer) As Integer



    ' ****************************************************************************************************************************************
    ' ********************
    ' ********************
    ' Funktionen fr Setup
    ' ********************
    ' ********************
    ' DFCSetupLaden
    ' Declare
    Public Declare Function DFCSetupLaden_Declare Lib "DFComDll" Alias _
    "_DFCSetupLaden@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSetupLaden@16")> _
        Public Shared Function DFCSetupLaden_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetupLaden_Unicode Lib "DFComDll" Alias "_DFCSetupLaden@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetupLaden_ANSI Lib "DFComDll" Alias "_DFCSetupLaden@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetupLaden_Auto Lib "DFComDll" Alias "_DFCSetupLaden@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCDownload
    ' Declare
    Public Declare Function DFCDownload_Declare Lib "DFComDll" Alias _
    "_DFCDownload@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCDownload@16")> _
        Public Shared Function DFCDownload_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCDownload_Unicode Lib "DFComDll" Alias "_DFCDownload@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCDownload_ANSI Lib "DFComDll" Alias "_DFCDownload@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCDownload_Auto Lib "DFComDll" Alias "_DFCDownload@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal SetupFile As String, ByRef nError As Integer) As Integer


    ' ****************************************************************************************************************************************
    ' ********************
    ' ********************
    ' Funktionen fr Listen, sowie Zutrittslisten (Version 2)
    ' ********************
    ' ********************
    ' DFCOpenTable
    ' Declare
    Public Declare Function DFCOpenTable_Declare Lib "DFComDll" Alias _
    "_DFCOpenTable@28" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ListName As String, ByVal nOption As Integer, ByRef nHandle As Integer, ByVal rff As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCOpenTable@28")> _
        Public Shared Function DFCOpenTable_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ListName As String, ByVal nOption As Integer, ByRef nHandle As Integer, ByVal rff As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCOpenTable_Unicode Lib "DFComDll" Alias "_DFCOpenTable@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ListName As String, ByVal nOption As Integer, ByRef nHandle As Integer, ByVal rff As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCOpenTable_ANSI Lib "DFComDll" Alias "_DFCOpenTable@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ListName As String, ByVal nOption As Integer, ByRef nHandle As Integer, ByVal rff As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCOpenTable_Auto Lib "DFComDll" Alias "_DFCOpenTable@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal ListName As String, ByVal nOption As Integer, ByRef nHandle As Integer, ByVal rff As String, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCCloseTable
    ' Declare
    Public Declare Function DFCCloseTable_Declare Lib "DFComDll" Alias _
    "_DFCCloseTable@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCCloseTable@16")> _
        Public Shared Function DFCCloseTable_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCCloseTable_Unicode Lib "DFComDll" Alias "_DFCCloseTable@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCCloseTable_ANSI Lib "DFComDll" Alias "_DFCCloseTable@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCCloseTable_Auto Lib "DFComDll" Alias "_DFCCloseTable@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCSetFilter
    ' Declare
    Public Declare Function DFCSetFilter_Declare Lib "DFComDll" Alias _
    "_DFCSetFilter@20" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="")> _
        Public Shared Function DFCSetFilter_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetFilter_Unicode Lib "DFComDll" Alias "_DFCSetFilter@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetFilter_ANSI Lib "DFComDll" Alias "_DFCSetFilter@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetFilter_Auto Lib "DFComDll" Alias "_DFCSetFilter@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCGetFilter
    ' Declare
    Public Declare Function DFCGetFilter_Declare Lib "DFComDll" Alias _
    "_DFCGetFilter@24" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nLength As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetFilter@24")> _
        Public Shared Function DFCGetFilter_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nLength As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetFilter_Unicode Lib "DFComDll" Alias "_DFCGetFilter@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nLength As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetFilter_ANSI Lib "DFComDll" Alias "_DFCGetFilter@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nLength As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetFilter_Auto Lib "DFComDll" Alias "_DFCGetFilter@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal Filter As String, ByRef nLength As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCClearFilter
    ' Declare
    Public Declare Function DFCClearFilter_Declare Lib "DFComDll" Alias _
    "_DFCClearFilter@16" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCClearFilter@16")> _
        Public Shared Function DFCClearFilter_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCClearFilter_Unicode Lib "DFComDll" Alias "_DFCClearFilter@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCClearFilter_ANSI Lib "DFComDll" Alias "_DFCClearFilter@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCClearFilter_Auto Lib "DFComDll" Alias "_DFCClearFilter@16" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCSkip
    ' Declare
    Public Declare Function DFCSkip_Declare Lib "DFComDll" Alias _
    "_DFCSkip@24" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal nOffset As Integer, ByVal nOrigin As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSkip@24")> _
        Public Shared Function DFCSkip_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal nOffset As Integer, ByVal nOrigin As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSkip_Unicode Lib "DFComDll" Alias "_DFCSkip@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal nOffset As Integer, ByVal nOrigin As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSkip_ANSI Lib "DFComDll" Alias "_DFCSkip@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal nOffset As Integer, ByVal nOrigin As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSkip_Auto Lib "DFComDll" Alias "_DFCSkip@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal nOffset As Integer, ByVal nOrigin As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCSetField
    ' Declare
    Public Declare Function DFCSetField_Declare Lib "DFComDll" Alias _
    "_DFCSetField@24" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCSetField@24")> _
        Public Shared Function DFCSetField_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCSetField_Unicode Lib "DFComDll" Alias "_DFCSetField@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCSetField_ANSI Lib "DFComDll" Alias "_DFCSetField@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCSetField_Auto Lib "DFComDll" Alias "_DFCSetField@24" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCGetField
    ' Declare
    Public Declare Function DFCGetField_Declare Lib "DFComDll" Alias _
    "_DFCGetField@28" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef ValueLength As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCGetField@28")> _
        Public Shared Function DFCGetField_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef ValueLength As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCGetField_Unicode Lib "DFComDll" Alias "_DFCGetField@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef ValueLength As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCGetField_ANSI Lib "DFComDll" Alias "_DFCGetField@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef ValueLength As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCGetField_Auto Lib "DFComDll" Alias "_DFCGetField@28" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal nHandle As Integer, ByVal FieldName As String, ByVal FieldValue As String, ByRef ValueLength As Integer, ByRef nError As Integer) As Integer




    ' ****************************************************************************************************************************************
    ' ********************
    ' ********************
    ' Funktionen fr Daten
    ' ********************
    ' ********************
    ' DFCComClearData
    ' Declare
    Public Declare Function DFCComClearData_Declare Lib "DFComDll" Alias _
    "_DFCComClearData@8" (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCComClearData@8")> _
        Public Shared Function DFCComClearData_Import(ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComClearData_Unicode Lib "DFComDll" Alias "_DFCComClearData@8" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComClearData_ANSI Lib "DFComDll" Alias "_DFCComClearData@8" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComClearData_Auto Lib "DFComDll" Alias "_DFCComClearData@8" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComCollectData
    ' Declare
    Public Declare Function DFCComCollectData_Declare Lib "DFComDll" Alias _
    "_DFCComCollectData@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCComCollectData@12")> _
        Public Shared Function DFCComCollectData_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComCollectData_Unicode Lib "DFComDll" Alias "_DFCComCollectData@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComCollectData_ANSI Lib "DFComDll" Alias "_DFCComCollectData@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComCollectData_Auto Lib "DFComDll" Alias "_DFCComCollectData@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCComGetDatensatz
    ' Declare
    Public Declare Function DFCComGetDatensatz_Declare Lib "DFComDll" Alias _
    "_DFCComGetDatensatz@16" (ByVal ComNum As Integer, ByVal Buffer As String, ByRef DataLength As Integer, ByRef ComError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCComGetDatensatz@16")> _
        Public Shared Function DFCComGetDatensatz_Import(ByVal ComNum As Integer, ByVal Buffer As String, ByRef DataLength As Integer, ByRef ComError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCComGetDatensatz_Unicode Lib "DFComDll" Alias "_DFCComGetDatensatz@16" _
        (ByVal ComNum As Integer, ByVal Buffer As String, ByRef DataLength As Integer, ByRef ComError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCComGetDatensatz_ANSI Lib "DFComDll" Alias "_DFCComGetDatensatz@16" _
        (ByVal ComNum As Integer, ByVal Buffer As String, ByRef DataLength As Integer, ByRef ComError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCComGetDatensatz_Auto Lib "DFComDll" Alias "_DFCComGetDatensatz@16" _
        (ByVal ComNum As Integer, ByVal Buffer As String, ByRef DataLength As Integer, ByRef ComError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCLoadDatensatzbeschreibung
    ' Declare
    Public Declare Function DFCLoadDatensatzbeschreibung_Declare Lib "DFComDll" Alias _
    "_DFCLoadDatensatzbeschreibung@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCLoadDatensatzbeschreibung@12")> _
        Public Shared Function DFCLoadDatensatzbeschreibung_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCLoadDatensatzbeschreibung_Unicode Lib "DFComDll" Alias "_DFCLoadDatensatzbeschreibung@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCLoadDatensatzbeschreibung_ANSI Lib "DFComDll" Alias "_DFCLoadDatensatzbeschreibung@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCLoadDatensatzbeschreibung_Auto Lib "DFComDll" Alias "_DFCLoadDatensatzbeschreibung@124" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef ComError As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCDatBCnt
    ' Declare
    Public Declare Function DFCDatBCnt_Declare Lib "DFComDll" Alias _
    "_DFCDatBCnt@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCDatBCnt@4")> _
        Public Shared Function DFCDatBCnt_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCDatBCnt_Unicode Lib "DFComDll" Alias "_DFCDatBCnt@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCDatBCnt_ANSI Lib "DFComDll" Alias "_DFCDatBCnt@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCDatBCnt_Auto Lib "DFComDll" Alias "_DFCDatBCnt@4" _
        (ByVal ComNum As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCDatBDatensatz
    ' Declare
    Public Declare Function DFCDatBDatensatz_Declare Lib "DFComDll" Alias _
    "_DFCDatBDatensatz@16" (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal DataName As String, ByRef DataAnz As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCDatBDatensatz@16")> _
        Public Shared Function DFCDatBDatensatz_Import(ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal DataName As String, ByRef DataAnz As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCDatBDatensatz_Unicode Lib "DFComDll" Alias "_DFCDatBDatensatz@16" _
        (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal DataName As String, ByRef DataAnz As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCDatBDatensatz_ANSI Lib "DFComDll" Alias "_DFCDatBDatensatz@16" _
        (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal DataName As String, ByRef DataAnz As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCDatBDatensatz_Auto Lib "DFComDll" Alias "_DFCDatBDatensatz@16" _
        (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal DataName As String, ByRef DataAnz As Integer) As Integer

    ' ********************
    ' ********************
    ' DFCDatBFeld
    ' Declare
    Public Declare Function DFCDatBFeld_Declare Lib "DFComDll" Alias _
    "_DFCDatBFeld@24" (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCDatBFeld@24")> _
        Public Shared Function DFCDatBFeld_Import(ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCDatBFeld_Unicode Lib "DFComDll" Alias "_DFCDatBFeld@24" _
        (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCDatBFeld_ANSI Lib "DFComDll" Alias "_DFCDatBFeld@24" _
        (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCDatBFeld_Auto Lib "DFComDll" Alias "_DFCDatBFeld@24" _
        (ByVal ComNum As Integer, ByVal DataNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCReadRecord
    Public Declare Function DFCReadRecord_Declare Lib "DFComDll" Alias _
    "_DFCReadRecord@20" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DSBuf As String, ByRef DSLength As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCReadRecord@20")> _
        Public Shared Function DFCReadRecord_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DSBuf As String, ByRef DSLength As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCReadRecord_Unicode Lib "DFComDll" Alias "_DFCReadRecord@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DSBuf As String, ByRef DSLength As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCReadRecord_ANSI Lib "DFComDll" Alias "_DFCReadRecord@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DSBuf As String, ByRef DSLength As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCReadRecord_Auto Lib "DFComDll" Alias "_DFCReadRecord@20" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal DSBuf As String, ByRef DSLength As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCQuitRecord
    Public Declare Function DFCQuitRecord_Declare Lib "DFComDll" Alias _
    "_DFCQuitRecord@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCQuitRecord@12")> _
        Public Shared Function DFCQuitRecord_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCQuitRecord_Unicode Lib "DFComDll" Alias "_DFCQuitRecord@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCQuitRecord_ANSI Lib "DFComDll" Alias "_DFCQuitRecord@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCQuitRecord_Auto Lib "DFComDll" Alias "_DFCQuitRecord@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer


    ' ****************************************************************************************************************************************
    ' ********************
    ' ********************
    ' Funktionen fr Listen
    ' ********************
    ' ********************
    ' DFCMakeListe
    ' Declare
    Public Declare Function DFCMakeListe_Declare Lib "DFComDll" Alias _
    "_DFCMakeListe@24" (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal LineCount As Integer, ByVal ListSize As Integer, ByVal ListBuf As String, ByVal ListMemSize As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCMakeListe@24")> _
        Public Shared Function DFCMakeListe_Import(ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal LineCount As Integer, ByVal ListSize As Integer, ByVal ListBuf As String, ByVal ListMemSize As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCMakeListe_Unicode Lib "DFComDll" Alias "_DFCMakeListe@24" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal LineCount As Integer, ByVal ListSize As Integer, ByVal ListBuf As String, ByVal ListMemSize As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCMakeListe_ANSI Lib "DFComDll" Alias "_DFCMakeListe@24" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal LineCount As Integer, ByVal ListSize As Integer, ByVal ListBuf As String, ByVal ListMemSize As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCMakeListe_Auto Lib "DFComDll" Alias "_DFCMakeListe@24" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal LineCount As Integer, ByVal ListSize As Integer, ByVal ListBuf As String, ByVal ListMemSize As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCLoadListen
    ' Declare
    Public Declare Function DFCLoadListen_Declare Lib "DFComDll" Alias _
    "_DFCLoadListen@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCLoadListen@12")> _
        Public Shared Function DFCLoadListen_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCLoadListen_Unicode Lib "DFComDll" Alias "_DFCLoadListen@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCLoadListen_ANSI Lib "DFComDll" Alias "_DFCLoadListen@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCLoadListen_Auto Lib "DFComDll" Alias "_DFCLoadListen@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCClrListenBuffer
    ' Declare
    Public Declare Function DFCClrListenBuffer_Declare Lib "DFComDll" Alias _
    "_DFCClrListenBuffer@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCClrListenBuffer@4")> _
        Public Shared Function DFCClrListenBuffer_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCClrListenBuffer_Unicode Lib "DFComDll" Alias "_DFCClrListenBuffer@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCClrListenBuffer_ANSI Lib "DFComDll" Alias "_DFCClrListenBuffer@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCClrListenBuffer_Auto Lib "DFComDll" Alias "_DFCClrListenBuffer@4" _
        (ByVal ComNum As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCLoadListenbeschreibung
    ' Declare
    Public Declare Function DFCLoadListenbeschreibung_Declare Lib "DFComDll" Alias _
    "_DFCLoadListenbeschreibung@12" (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCLoadListenbeschreibung@12")> _
        Public Shared Function DFCLoadListenbeschreibung_Import(ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCLoadListenbeschreibung_Unicode Lib "DFComDll" Alias "_DFCLoadListenbeschreibung@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCLoadListenbeschreibung_ANSI Lib "DFComDll" Alias "_DFCLoadListenbeschreibung@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCLoadListenbeschreibung_Auto Lib "DFComDll" Alias "_DFCLoadListenbeschreibung@12" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer, ByRef nError As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCListBCnt
    ' Declare
    Public Declare Function DFCListBCnt_Declare Lib "DFComDll" Alias _
    "_DFCListBCnt@4" (ByVal ComNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCListBCnt@4")> _
        Public Shared Function DFCListBCnt_Import(ByVal ComNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCListBCnt_Unicode Lib "DFComDll" Alias "_DFCListBCnt@4" _
        (ByVal ComNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCListBCnt_ANSI Lib "DFComDll" Alias "_DFCListBCnt@4" _
        (ByVal ComNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCListBCnt_Auto Lib "DFComDll" Alias "_DFCListBCnt@4" _
        (ByVal ComNum As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCListBDatensatz
    ' Declare
    Public Declare Function DFCListBDatensatz_Declare Lib "DFComDll" Alias _
    "_DFCListBDatensatz@20" (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal ListName As String, ByRef ListCount As Integer, ByRef ListTyp As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCListBDatensatz@20")> _
        Public Shared Function DFCListBDatensatz_Import(ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal ListName As String, ByRef ListCount As Integer, ByRef ListTyp As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCListBDatensatz_Unicode Lib "DFComDll" Alias "_DFCListBDatensatz@20" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal ListName As String, ByRef ListCount As Integer, ByRef ListTyp As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCListBDatensatz_ANSI Lib "DFComDll" Alias "_DFCListBDatensatz@20" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal ListName As String, ByRef ListCount As Integer, ByRef ListTyp As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCListBDatensatz_Auto Lib "DFComDll" Alias "_DFCListBDatensatz@20" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal ListName As String, ByRef ListCount As Integer, ByRef ListTyp As Integer) As Integer


    ' ********************
    ' ********************
    ' DFCListBFeld
    ' Declare
    Public Declare Function DFCListBFeld_Declare Lib "DFComDll" Alias _
    "_DFCListBFeld@24" (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="_DFCListBFeld@24")> _
        Public Shared Function DFCListBFeld_Import(ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function DFCListBFeld_Unicode Lib "DFComDll" Alias "_DFCListBFeld@24" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function DFCListBFeld_ANSI Lib "DFComDll" Alias "_DFCListBFeld@24" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function DFCListBFeld_Auto Lib "DFComDll" Alias "_DFCListBFeld@24" _
        (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal FieldNum As Integer, ByVal FieldName As String, ByRef FieldTyp As Integer, ByRef FieldLength As Integer) As Integer



    ' ********************
    ' ********************
    ' Zutrittskontrolle Version II
    ' Declare
    Public Declare Function DFCMakeEntrance2List_Declare Lib "DFComDll" Alias "_DFCMakeEntrance2List@24" _
     (ByVal ComNum As Integer, ByVal ListNum As Integer, ByVal ListCount As Integer, ByVal ListSize As Integer, ByVal ListBuffer As String, ByRef nError As Integer) As Integer

    Public Declare Function DFCEntrance2OnlineAction_Declare Lib "DFComDll" Alias "_DFCEntrance2OnlineAction@28" _
     (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal TM As String, ByVal Mask As Integer, ByVal Type As Integer, ByVal Duration As Integer, ByRef nError As Integer) As Integer

    Public Declare Function DFCEntrance2Identification_Declare Lib "DFComDll" Alias "_DFCEntrance2Identification@32" _
     (ByVal ComNum As Integer, ByVal BusNum As Integer, ByVal TM As String, ByVal ID As String, ByVal PIN As String, ByVal State As String, ByRef nLen As Integer, ByRef nError As Integer) As Integer



    ' ********************
    ' ********************
    ' XXXXXXXXXXXXXXXXXX
    ' Declare
    Public Declare Function _Declare Lib "DFComDll" Alias _
    "" (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' Import
    <DllImport("DFComDll.dll", EntryPoint:="")> _
        Public Shared Function _Import(ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    End Function
    ' Unicode
    Public Declare Unicode Function _Unicode Lib "DFComDll" Alias "" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' ANSI
    Public Declare Ansi Function _ANSI Lib "DFComDll" Alias "" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer
    ' Auto festlegen
    Public Declare Auto Function _Auto Lib "DFComDll" Alias "" _
        (ByVal ComNum As Integer, ByVal BusNum As Integer) As Integer





















End Class
