
Imports System
Imports System.Net
Imports System.Threading
Imports System.ComponentModel

Public Class Schnittstelle

    Private FormLoaded As Boolean = False
    Private COM_Interface As New Rs232()
    Private sLokal_IP As String = "127.0.0.1"
    Private bNetPresent As Boolean = False
    Private bModemReset As Boolean = False
    Dim m_nCommType As Integer
    '   Dim m_ret As Long

    Private Sub Form_Load_Schnittstelle(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        RichDataBox.Text = ""
        ' Hier wird ein wenig mit dem Cursor handiert, um zu zeigen das sich noch was tut
        Windows.Forms.Cursor.Current = Cursors.AppStarting

        ' Allen verfgbaren COM Ports ermitteln und in die Combobox schreiben
        GetCOMPortInfo()
        ' Es besteht noch keine aktive Verbindung 
        m_nConnectState = 0
        ' Kommunikationsart auf RS232 stellen
        If (m_bCOM_Avalible = True) Then
            CheckedChanged_rbCOM(sender, e)
            m_nCommType = 1
            cbComPort.SelectedIndex() = 0
        Else
            m_nCommType = 2
            cbComPort.SelectedIndex() = 1
        End If

        ' Eintrge der einzelnen Comboboxen selektieren
        cbModemTyp.SelectedIndex() = 0
        cbBaudRate.SelectedIndex() = 1
        cbTimeout.SelectedIndex() = 3

        ' Hier prfen wir, ob Windows Management Instrumentation verfgbar ist
        If WMI_Avail() Then
            getWMI_Info()
            If (cbLocalIP.Items.Count > 0) Then
                cbLocalIP.SelectedIndex() = 0
                cbSubnet.SelectedIndex() = 0
                TargetIP.Text = cbLocalIP.Text.ToString.Substring(0, cbLocalIP.Text.LastIndexOf(".") + 1) & "1"
            End If
        Else
            ' Wenn nicht, dann setzen wir die TCP/IP Einstellungen auf 0.0.0.0
            cbLocalIP.Items.Insert(0, "0.0.0.0")
            cbSubnet.Items.Insert(0, "0.0.0.0")
        End If

        FormLoaded = True

    End Sub

    ' Prfen, ob WMI untersttzt wird
    ' Das brauchen wir zur Netzwerkanalyse
    Public Function WMI_Avail() As Boolean

        Dim WMI As Object

        On Error Resume Next
        ' Hier holen wir uns das WMI Objekt
        WMI = GetObject("winmgmts:")

        ' Wenn was schief geht dann Error zurckgeben
        WMI_Avail = (Err.Number = 0)

    End Function

    Private Sub getWMI_Info()

        Dim oAdapters As Object
        Dim oAdapter As Object
        Dim pos As Integer = 0
        Dim exist As Boolean = False

        On Error GoTo Fehler_WMI

        ' Hier holen wir uns die aktuellen Informationen zur TCP/IP Umgebung
        oAdapters = GetObject("winmgmts:").execquery( _
          "SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = True")

        For Each oAdapter In oAdapters
            With oAdapter
                If Not (Join(.IPAddress) = "0.0.0.0") Then
                    For i As Integer = 0 To (cbLocalIP.Items.Count - 1)
                        If Not (String.Compare(Join(.IPAddress), cbLocalIP.Items.Item(i).ToString)) Then
                            exist = True
                            Exit For
                        End If
                    Next
                    If Not exist Then
                        cbLocalIP.Items.Insert(pos, Join(.IPAddress))
                        cbSubnet.Items.Insert(pos, Join(.IPSubnet))
                        pos += 1
                    End If
                End If
            End With
        Next
        Exit Sub

Fehler_WMI:
        MsgBox("WMI - Fehler: " & Err.Number & vbTab & Err.Description, vbCritical)
        Resume Next
    End Sub

    Private Sub GetCOMPortInfo()

        Dim i As Integer
        Dim pos As Integer
        pos = 0

        For i = 1 To 10
            ' Hier prfen wir, welche COM-Ports auf dem lokalen Rechner verfgbar sind.
            If IsPortAvailable(i) Then
                ' Nur wenn auch wirklich ein COM-Port verfgbar ist
                m_bCOM_Avalible = True
                ' Hier schreiben wir die verfgbaren Ports in die Combobox.
                cbComPort.Items.Insert(pos, "COM" + i.ToString())
                pos += 1
            End If
        Next
    End Sub

    Private Function IsPortAvailable(ByVal ComPort As Integer) As Boolean

        Try
            COM_Interface.Open(ComPort, 115200, 8, Rs232.DataParity.Parity_None, _
                Rs232.DataStopBit.StopBit_1, 4096)
            ' If it makes it to here, then the Comm Port is available.
            COM_Interface.Close()
            Return True
        Catch
            ' If it gets here, then the attempt to open the Comm Port
            '   was unsuccessful.
            Return False
        End Try

    End Function

    Private Sub Write_Message(ByVal message As String)

        ' Hier wird das Feedback fr den Anwender aufbereitet
        message = message.ToString().Replace(Chr(13), " ")
        message = message.ToString().Replace(Chr(10), " ")
        ' Und hier ausgegeben
        RichDataBox.AppendText(message.ToString().TrimStart())
        RichDataBox.AppendText(vbCrLf)

    End Sub

    Private Sub Click_Connection(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Connection.Click

        Dim charSeparators() As Char = {";"c}
        '        Dim nInitLength As Integer
        '        nInitLength = szInit.Length()
        '        Dim szResult As String()
        Dim nWriteLength As Integer
        Dim nReadLength As Integer
        Dim nError As Integer
        Dim nTry As Integer
        nTry = 1
        Dim szBuf As String
        Dim szBuff As String
        Dim cBufLength(25) As Char
        szBuf = New String(cBufLength)
        Dim nToRead As Integer
        Dim nToWrite As Integer
        Dim bEcho As Boolean
        bEcho = True
        Dim szComError As String
        Dim cErrorLength(255) As Char
        szComError = New String(cErrorLength)
        Dim szLinkTyp As String
        Dim MsgTitle As String
        Dim MsgStyle As MsgBoxStyle
        MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
        MsgTitle = ""
        szLinkTyp = ""

        If (Connection.Text = "Whlen") Then

            m_nChannelID = 1
            ' Beim MC35i Terminal ist die Frage, ob eine PIN gestzt werden muss?
            If (txModemPin.Text.Length > 0L) Then
                '  Muss noch erweitert werden!
            End If

            If (txRufnummer.Text.ToString = "") Then
                MsgBox("Sie mssen eine Rufnummer eingeben!")
            Else
                szBuff = "atd" & txRufnummer.Text.ToString & vbCrLf
                nToWrite = szBuff.Length
                nWriteLength = 0
                nTry = 1

                If (CallingVariations.DFCWrite_Declare(m_nChannelID, szBuff, nToWrite, nWriteLength, nError) = 0) Then
                    CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                nError, 0, szComError, szComError.Length())

                    szLinkTyp = "DLL Link Typ = Declare"
                    Get_Error_Information(szLinkTyp, nError, szComError, MsgStyle, MsgTitle)
                Else
                    ' Kurzes Feedback
                    RichDataBox.AppendText("Senden von ATD0xyz...: DFCWrite()")
                    RichDataBox.AppendText(vbCrLf)
                    Do While nTry
                        nReadLength = 0
                        nToRead = 12
                        If (CallingVariations.DFCRead_Declare(m_nChannelID, szBuf, nToRead, nReadLength, nError) = 0) Then
                            If InStr(szBuf, "CONNECT") Then
                                RichDataBox.AppendText("Verbindung erfolgreich hergestellt.")
                                RichDataBox.AppendText(vbCrLf)
                                RichDataBox.ScrollToCaret()
                                Connection.Text = "Trennen"
                                Exit Sub
                            End If

                            If InStr(szBuf, "BUSSY") Then
                                RichDataBox.AppendText("Gegenstelle besetzt.")
                                RichDataBox.AppendText(vbCrLf)
                                RichDataBox.ScrollToCaret()
                                Exit Sub
                            End If

                            If InStr(szBuf, "NO CARRIER") Then
                                RichDataBox.AppendText("Kein Trgersignal.")
                                RichDataBox.AppendText(vbCrLf)
                                RichDataBox.ScrollToCaret()
                                Exit Sub
                            End If

                            If InStr(szBuf, "ERROR") Then
                                RichDataBox.AppendText("Fehler bei Verbindungsaufbau.")
                                RichDataBox.AppendText(vbCrLf)
                                RichDataBox.ScrollToCaret()
                                Exit Sub
                            End If
                        Else
                            nTry = 0
                        End If
                    Loop
                    ' Kurzes Feedback
                    RichDataBox.AppendText("Lesen der Antwort auf AT-Kommando: " & szBuff & "mit der Funktion DFCRead()")
                    RichDataBox.AppendText(vbCrLf)
                    RichDataBox.ScrollToCaret()
                End If

            End If
        Else
            Thread.Sleep(1000)

            ' in den Kommandmode wechseln
            szBuff = "+++"
            nToWrite = szBuff.Length
            nWriteLength = 0
            nError = 0
            nTry = 2
            If (CallingVariations.DFCWrite_Declare(m_nChannelID, szBuff, nToWrite, nWriteLength, nError) = 0) Then
                RichDataBox.AppendText("Modem in den Commandmode setzten mit 1s Pause +++ 1s Pause.")
                RichDataBox.AppendText(vbCrLf)
                RichDataBox.ScrollToCaret()
                Exit Sub
            End If

            Thread.Sleep(1000)

            Do While nTry
                If (CallingVariations.DFCRead_Declare(m_nChannelID, szBuf, nToRead, nReadLength, nError) = 0) Then
                    nTry -= 1
                Else
                    nTry = 0
                End If
            Loop

            ' Verbindung trennen
            szBuff = "ath"
            nToWrite = szBuff.Length
            nWriteLength = 0
            nError = 0
            nTry = 2
            If (CallingVariations.DFCWrite_Declare(m_nChannelID, szBuff, nToWrite, nWriteLength, nError) = 0) Then
                RichDataBox.AppendText("Bestehenden Verbindung trennen mit ath.")
                RichDataBox.AppendText(vbCrLf)
                RichDataBox.ScrollToCaret()
                Exit Sub
            End If

            Thread.Sleep(1000)

            Do While nTry
                If (CallingVariations.DFCRead_Declare(m_nChannelID, szBuf, nToRead, nReadLength, nError) = 0) Then
                    nTry -= 1
                Else
                    nTry = 0
                End If
            Loop

            Connection.Text = "Whlen"
        End If

    End Sub

    Private Sub Connect_by_Type(ByVal pState As Integer)

        Dim nResult As Integer
        Dim nComError As Integer
        Dim szComError As String
        Dim cErrorLength(255) As Char
        szComError = New String(cErrorLength)
        Dim szLinkTyp As String
        Dim MsgTitle As String
        Dim MsgStyle As MsgBoxStyle
        MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
        MsgTitle = ""
        szLinkTyp = ""
        m_nLinkDLLType = 1

        ''Dim dllArgs As New TransferDLLParams
        ''dllArgs.nChannelID = Convert.ToInt32(txChannelID.Text.ToString)
        ''dllArgs.nDeviceID = Convert.ToInt32(txBusNr.Text.ToString)
        ''dllArgs.nComType = 1
        ''dllArgs.sComString = cbComPort.Text.ToString
        ''dllArgs.nComBaud = Convert.ToInt32(cbBaudRate.Text.ToString)
        ''dllArgs.nComTimeout = Convert.ToInt32(cbTimeout.Text.ToString)
        ''dllArgs.sFirmware = "04.01.04.51.hex"
        ''dllArgs.nReturn = 0
        ''dllArgs.nErrorCode = 0

        Select Case pState
            Case 1 ' COM
                Select Case m_nLinkDLLType
                    Case 1 ' Declare
                        If (m_nConnectState = 0) Then
                            If (CallingVariations.DFCComOpenIV_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                            Convert.ToInt32(txBusNr.Text.ToString), _
                                                            1, _
                                                            cbComPort.Text.ToString, _
                                                            Convert.ToInt32(cbBaudRate.Text.ToString), _
                                                            Convert.ToInt32(cbTimeout.Text.ToString)) = 1) Then
                                ' Kurzes Feedback
                                RichDataBox.AppendText("Kommunikationskanal ffnen: DFCComOpenIV()")
                                RichDataBox.AppendText(vbCrLf)
                                If (CallingVariations.DFCCheckDevice_Declare(Convert.ToInt32(txChannelID.Text.ToString), 254, nComError, 3) = 1) Then
                                    DFComDLLSample.txtSampleState.Text = "Connect: " & cbComPort.Text.ToString & ", Channel = " _
                                                                & txChannelID.Text.ToString & ", Bus-Nr = " & txBusNr.Text.ToString _
                                                                & ", Baud = " & cbBaudRate.Text.ToString & ", Timeout = " _
                                                                & cbTimeout.Text.ToString & ", Ping = OK"

                                    m_nConnectState = 1
                                    Open_Close.Text = "Close"
                                    DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                    DFComDLLSample.txtSampleState.ForeColor = Color.Green
                                    ' Kurzes Feedback
                                    RichDataBox.AppendText("Erreichbarkeit des Terminals prfen: DFCCheckDevice()")
                                    RichDataBox.AppendText(vbCrLf)

                                Else
                                    CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                    CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                                nComError, 0, szComError, szComError.Length())

                                    MsgTitle = "Fehler bei Verbindungsaufbau ber RS232!"
                                    szLinkTyp = "DLL Link Typ = Declare"
                                    Get_Error_Information(szLinkTyp, nComError, szComError, MsgStyle, MsgTitle)
                                End If
                            Else
                                MessageBox.Show("Schnittstelle konnte nicht geffnet werden!")
                            End If
                        Else
                            CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                            m_nConnectState = 0
                            Open_Close.Text = "Open"
                            DFComDLLSample.txtSampleState.Text = "Connect: Es besteht keine aktive Verbindung!"
                            DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                            DFComDLLSample.txtSampleState.ForeColor = Color.Red
                            ' Kurzes Feedback
                            RichDataBox.AppendText("Kommunikationskanal schlieen: DFCComClose()")
                            RichDataBox.AppendText(vbCrLf)
                        End If
                    Case 2 ' Import
                    Case 3 ' Unicode
                    Case 4 ' ANSI
                        If (m_nConnectState = 0) Then
                            If (CallingVariations.DFCComOpenIV_ANSI(Convert.ToInt32(txChannelID.Text.ToString), _
                                                            Convert.ToInt32(txBusNr.Text.ToString), _
                                                            1, _
                                                            cbComPort.Text.ToString, _
                                                            Convert.ToInt32(cbBaudRate.Text.ToString), _
                                                            Convert.ToInt32(cbTimeout.Text.ToString)) = 1) Then
                                ' Kurzes Feedback
                                RichDataBox.AppendText("Kommunikationskanal ffnen: DFCComOpenIV()")
                                RichDataBox.AppendText(vbCrLf)
                                If (CallingVariations.DFCCheckDevice_ANSI(Convert.ToInt32(txChannelID.Text.ToString), 254, nComError, 3) = 1) Then
                                    DFComDLLSample.txtSampleState.Text = "Connect: " & cbComPort.Text.ToString & ", Channel = " _
                                                                & txChannelID.Text.ToString & ", Bus-Nr = " & txBusNr.Text.ToString _
                                                                & ", Baud = " & cbBaudRate.Text.ToString & ", Timeout = " _
                                                                & cbTimeout.Text.ToString & ", Ping = OK"

                                    m_nConnectState = 1
                                    Open_Close.Text = "Close"
                                    DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                    DFComDLLSample.txtSampleState.ForeColor = Color.Green
                                    ' Kurzes Feedback
                                    RichDataBox.AppendText("Erreichbarkeit des Terminals prfen: DFCCheckDevice()")
                                    RichDataBox.AppendText(vbCrLf)
                                Else
                                    CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                    CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                                nComError, 0, szComError, szComError.Length())

                                    MsgTitle = "Fehler bei Verbindungsaufbau ber RS232!"
                                    szLinkTyp = "DLL Link Typ = ANSI"
                                    Get_Error_Information(szLinkTyp, nComError, szComError, MsgStyle, MsgTitle)
                                End If
                            Else
                                MessageBox.Show("Schnittstelle konnte nicht geffnet werden!")
                            End If
                        Else
                            CallingVariations.DFCComClose_ANSI(Convert.ToInt32(txChannelID.Text.ToString))
                            m_nConnectState = 0
                            Open_Close.Text = "Open"
                            DFComDLLSample.txtSampleState.Text = "Connect: Es besteht keine aktive Verbindung!"
                            DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                            DFComDLLSample.txtSampleState.ForeColor = Color.Red
                            ' Kurzes Feedback
                            RichDataBox.AppendText("Kommunikationskanal schlieen: DFCComClose()")
                            RichDataBox.AppendText(vbCrLf)
                        End If
                    Case 5 ' Auto
                End Select
            Case 2 ' TCP/IP

                Dim IP_Konflikt As Boolean = False
                '                Dim SubnetFlag As Integer
                '                Dim MIndex As Integer
                Dim MStart As Integer
                '                Dim MEnd As Integer
                '               Dim LIndex As Integer
                Dim LStart As Integer
                '               Dim LEnd As Integer
                '               Dim TIndex As Integer
                Dim TStart As Integer
                '               Dim TEnd As Integer

                MStart = 0
                LStart = 0
                TStart = 0

                IP_Konflikt = False

                If (IP_Konflikt = 0) Then
                    Select Case m_nLinkDLLType
                        Case 1 ' Declare
                            If (m_nConnectState = 0) Then
                                If (CallingVariations.DFCComOpenIV_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                Convert.ToInt32(txChannelID.Text.ToString), _
                                                                3, _
                                                                TargetIP.Text.ToString, _
                                                                Convert.ToInt32(TCPPort.Text.ToString), _
                                                                Convert.ToInt32(cbTimeout.Text.ToString)) = 1) Then
                                    ' Kurzes Feedback
                                    RichDataBox.AppendText("Kommunikationskanal ffnen: DFCComOpenIV()")
                                    RichDataBox.AppendText(vbCrLf)
                                    If (CallingVariations.DFCCheckDevice_Declare(Convert.ToInt32(txChannelID.Text.ToString), 254, nComError, 3) = 1) Then
                                        DFComDLLSample.txtSampleState.Text = "Connect: " & TargetIP.Text.ToString & ", Channel = " _
                                                                    & txChannelID.Text.ToString & ", Bus-Nr = " & txBusNr.Text.ToString _
                                                                    & ", Port = " & TCPPort.Text.ToString & ", Timeout = " _
                                                                    & cbTimeout.Text.ToString & ", Ping = OK"
                                        m_nConnectState = 1
                                        Open_Close.Text = "Close"
                                        DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                        DFComDLLSample.txtSampleState.ForeColor = Color.Green
                                        ' Kurzes Feedback
                                        RichDataBox.AppendText("Erreichbarkeit des Terminals prfen: DFCCheckDevice()")
                                        RichDataBox.AppendText(vbCrLf)
                                    Else
                                        CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                        CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                                    nComError, 0, szComError, szComError.Length())

                                        MsgTitle = "Fehler bei Verbindungsaufbau ber TCP/IP!"
                                        szLinkTyp = "DLL Link Typ = Declare"
                                        Get_Error_Information(szLinkTyp, nComError, szComError, MsgStyle, MsgTitle)
                                    End If
                                Else
                                    MessageBox.Show("Schnittstelle konnte nicht geffnet werden!")
                                End If
                            Else
                                CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                m_nConnectState = 0
                                Open_Close.Text = "Open"
                                DFComDLLSample.txtSampleState.Text = "Connect: Es besteht keine aktive Verbindung!"
                                DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                DFComDLLSample.txtSampleState.ForeColor = Color.Red
                                ' Kurzes Feedback
                                RichDataBox.AppendText("Kommunikationskanal schlieen: DFCComClose()")
                                RichDataBox.AppendText(vbCrLf)
                            End If
                        Case 2
                        Case 3
                        Case 4 ' ANSI
                            If (m_nConnectState = 0) Then
                                If (CallingVariations.DFCComOpenIV_ANSI(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                Convert.ToInt32(txChannelID.Text.ToString), _
                                                                3, _
                                                                TargetIP.Text.ToString, _
                                                                Convert.ToInt32(TCPPort.Text.ToString), _
                                                                Convert.ToInt32(cbTimeout.Text.ToString)) = 1) Then
                                    ' Kurzes Feedback
                                    RichDataBox.AppendText("Kommunikationskanal ffnen: DFCComOpenIV()")
                                    RichDataBox.AppendText(vbCrLf)
                                    If (CallingVariations.DFCCheckDevice_Declare(Convert.ToInt32(txChannelID.Text.ToString), 254, nComError, 3) = 1) Then
                                        DFComDLLSample.txtSampleState.Text = "Connect: " & TargetIP.Text.ToString & ", Channel = " _
                                                                    & txChannelID.Text.ToString & ", Bus-Nr = " & txBusNr.Text.ToString _
                                                                    & ", Port = " & TCPPort.Text.ToString & ", Timeout = " _
                                                                    & cbTimeout.Text.ToString & ", Ping = OK"
                                        m_nConnectState = 1
                                        Open_Close.Text = "Close"
                                        DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                        DFComDLLSample.txtSampleState.ForeColor = Color.Green
                                        ' Kurzes Feedback
                                        RichDataBox.AppendText("Erreichbarkeit des Terminals prfen: DFCCheckDevice()")
                                        RichDataBox.AppendText(vbCrLf)
                                    Else
                                        CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                        CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                                    nComError, 0, szComError, szComError.Length())

                                        MsgTitle = "Fehler bei Verbindungsaufbau ber TCP/IP!"
                                        szLinkTyp = "DLL Link Typ = ANSI"
                                        Get_Error_Information(szLinkTyp, nComError, szComError, MsgStyle, MsgTitle)
                                    End If
                                Else
                                    MessageBox.Show("Schnittstelle konnte nicht geffnet werden!")
                                End If
                            Else
                                CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                m_nConnectState = 0
                                Open_Close.Text = "Open"
                                DFComDLLSample.txtSampleState.Text = "Connect: Es besteht keine aktive Verbindung!"
                                DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                DFComDLLSample.txtSampleState.ForeColor = Color.Red
                                ' Kurzes Feedback
                                RichDataBox.AppendText("Kommunikationskanal schlieen: DFCComClose()")
                                RichDataBox.AppendText(vbCrLf)
                            End If
                        Case 5
                    End Select
                Else

                End If
            Case 3 ' Modem
                Select Case m_nLinkDLLType
                    Case 1 ' Declare
                        nResult = 0
                        ' Schnittstelle ffnen
                        If (m_nConnectState = 0) Then
                            If (CallingVariations.DFCComOpenIV_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                            Convert.ToInt32(txChannelID.Text.ToString), _
                                                            1, _
                                                            cbComPort.Text.ToString, _
                                                            Convert.ToInt32(cbBaudRate.Text.ToString), _
                                                            Convert.ToInt32(cbTimeout.Text.ToString)) = 1) Then
                                ' Kurzes Feedback
                                RichDataBox.AppendText("Kommunikationskanal ffnen: DFCComOpenIV()")
                                RichDataBox.AppendText(vbCrLf)

                                DFComDLLSample.txtSampleState.Text = "Connect: " & cbComPort.Text.ToString & ", Channel = " _
                                                                & txChannelID.Text.ToString & ", Bus-Nr = " & txBusNr.Text.ToString _
                                                                & ", Baud = " & cbBaudRate.Text.ToString & ", Timeout = " _
                                                                & cbTimeout.Text.ToString

                                m_nConnectState = 1
                                Open_Close.Text = "Close"
                                Connection.Enabled = True
                                DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                DFComDLLSample.txtSampleState.ForeColor = Color.Green

                                ' Modem initialisieren
                                Do_Init_Modem(Convert.ToInt32(txChannelID.Text.ToString), txModemInit.Text.ToString(), nResult)
                                If (nResult = 1 And bModemReset = True) Then
                                    Do_Init_Modem(Convert.ToInt32(txChannelID.Text.ToString), "at&f#at&f#at&f", nResult)
                                End If

                                If (nResult = 0) Then

                                Else

                                End If
                            Else
                                CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                            nComError, 0, szComError, szComError.Length())

                                MsgTitle = "Fehler bei Verbindungsaufbau ber Modem!"
                                szLinkTyp = "DLL Link Typ = Declare"
                                Get_Error_Information(szLinkTyp, nComError, szComError, MsgStyle, MsgTitle)
                            End If
                        Else
                            CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                            m_nConnectState = 0
                            Open_Close.Text = "Open"
                            Connection.Enabled = False
                            DFComDLLSample.txtSampleState.Text = "Connect: Es besteht keine aktive Verbindung!"
                            DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                            DFComDLLSample.txtSampleState.ForeColor = Color.Red
                            ' Kurzes Feedback
                            RichDataBox.AppendText("Kommunikationskanal schlieen: DFCComClose()")
                            RichDataBox.AppendText(vbCrLf)
                        End If
                    Case 2
                    Case 3
                    Case 4 ' ANSI
                        If (m_nConnectState = 0) Then
                            If (CallingVariations.DFCComOpenIV_ANSI(Convert.ToInt32(txChannelID.Text.ToString), _
                                                            Convert.ToInt32(txChannelID.Text.ToString), _
                                                            1, _
                                                            cbComPort.Text.ToString, _
                                                            Convert.ToInt32(cbBaudRate.Text.ToString), _
                                                            Convert.ToInt32(cbTimeout.Text.ToString)) = 1) Then
                                If (CallingVariations.DFCCheckDevice_Declare(Convert.ToInt32(txChannelID.Text.ToString), 254, nComError, 3) = 1) Then
                                    DFComDLLSample.txtSampleState.Text = "Connect: " & cbComPort.Text.ToString & ", Channel = " _
                                                                & txChannelID.Text.ToString & ", Bus-Nr = " & txBusNr.Text.ToString _
                                                                & ", Baud = " & cbBaudRate.Text.ToString & ", Timeout = " _
                                                                & cbTimeout.Text.ToString

                                    m_nConnectState = 1
                                    Open_Close.Text = "Close"
                                    Connection.Enabled = True
                                    DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                                    DFComDLLSample.txtSampleState.ForeColor = Color.Green
                                Else
                                    CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                                    CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                                                nComError, 0, szComError, szComError.Length())

                                    MsgTitle = "Fehler bei Verbindungsaufbau ber Modem!"
                                    szLinkTyp = "DLL Link Typ = ANSI"
                                    Get_Error_Information(szLinkTyp, nComError, szComError, MsgStyle, MsgTitle)
                                End If
                            Else
                                MessageBox.Show("Schnittstelle konnte nicht geffnet werden!")
                            End If
                        Else
                            CallingVariations.DFCComClose_Declare(Convert.ToInt32(txChannelID.Text.ToString))
                            m_nConnectState = 0
                            Open_Close.Text = "Open"
                            Connection.Enabled = False
                            DFComDLLSample.txtSampleState.Text = "Connect: Es besteht keine aktive Verbindung!"
                            DFComDLLSample.txtSampleState.Font = New Font("Sans Serif", 8, FontStyle.Bold)
                            DFComDLLSample.txtSampleState.ForeColor = Color.Red
                            ' Kurzes Feedback
                            RichDataBox.AppendText("Kommunikationskanal schlieen: DFCComClose()")
                            RichDataBox.AppendText(vbCrLf)
                        End If
                    Case 5
                End Select
        End Select

        '        CallingVariations.DFCSetCallBack_Declare(Convert.ToInt32(txChannelID.Text.ToString), AddressOf DeviceInfo_CallBack)

    End Sub

    Private Sub CheckedChanged_rbCOM(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbCOM.CheckedChanged
        m_nCommType = 1
        Connection.Text = "Whlen"
        Connection.Enabled = False
        LabelComPort.Enabled = True
        cbComPort.Enabled = True
        LabelBaud.Enabled = True
        cbBaudRate.Enabled = True
        LabelTimeout.Enabled = True
        cbTimeout.Enabled = True
        LabelLocalIP.Enabled = False
        cbLocalIP.Enabled = False
        Subnet.Enabled = False
        cbSubnet.Enabled = False
        LabelTargetIP.Enabled = False
        LabelModemTyp.Enabled = False
        cbModemTyp.Enabled = False
        TargetIP.Enabled = False
        LabelTCPPort.Enabled = False
        TCPPort.Enabled = False
        LabelModemInit.Enabled = False
        txModemInit.Enabled = False
        ModemInit.Enabled = False
        LabelModemPin.Enabled = False
        txModemPin.Enabled = False
        LabelRufnummer.Enabled = False
        txRufnummer.Enabled = False

        Get_Modem_InitString(m_nCommType)

    End Sub

    Private Sub CheckedChanged_rbTCP(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbTCP.CheckedChanged
        m_nCommType = 2
        Connection.Text = "Whlen"
        Connection.Enabled = False
        LabelComPort.Enabled = False
        cbComPort.Enabled = False
        LabelBaud.Enabled = False
        cbBaudRate.Enabled = False
        LabelTimeout.Enabled = True
        cbTimeout.Enabled = True
        LabelLocalIP.Enabled = True
        cbLocalIP.Enabled = True
        Subnet.Enabled = True
        cbSubnet.Enabled = False
        LabelTargetIP.Enabled = True
        LabelModemTyp.Enabled = False
        cbModemTyp.Enabled = False
        TargetIP.Enabled = True
        LabelTCPPort.Enabled = True
        TCPPort.Enabled = True
        LabelModemInit.Enabled = False
        txModemInit.Enabled = False
        ModemInit.Enabled = False
        LabelModemPin.Enabled = False
        txModemPin.Enabled = False
        LabelRufnummer.Enabled = False
        txRufnummer.Enabled = False

        TargetIP.Focus()
        TargetIP.Select(12, 2)

        Get_Modem_InitString(m_nCommType)
        cbTimeout.SelectedIndex() = 8

    End Sub

    Private Sub CheckedChanged_rbModem(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbModem.CheckedChanged
        m_nCommType = 3
        Connection.Text = "Whlen"
        Connection.Enabled = False
        LabelComPort.Enabled = True
        cbComPort.Enabled = True
        LabelBaud.Enabled = True
        cbBaudRate.Enabled = True
        LabelTimeout.Enabled = True
        cbTimeout.Enabled = True
        LabelLocalIP.Enabled = False
        cbLocalIP.Enabled = False
        Subnet.Enabled = False
        cbSubnet.Enabled = False
        LabelModemTyp.Enabled = True
        cbModemTyp.Enabled = True
        LabelTargetIP.Enabled = False
        TargetIP.Enabled = False
        LabelTCPPort.Enabled = False
        TCPPort.Enabled = False
        LabelModemInit.Enabled = True
        txModemInit.Enabled = True
        ModemInit.Enabled = True
        LabelModemPin.Enabled = True
        txModemPin.Enabled = True
        LabelRufnummer.Enabled = True
        txRufnummer.Enabled = True

        Get_Modem_InitString(m_nCommType)

    End Sub

    Private Sub Click_LabelBusNr(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LabelBusNr.Click

    End Sub
    Private Sub Click_LabelTargetIP(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LabelTargetIP.Click

    End Sub

    Private Sub Get_Modem_InitString(ByVal CommTyp As Integer)
        Select Case CommTyp
            Case 1
                txModemInit.Text = ""
            Case 2
                txModemInit.Text = ""
            Case 3
                Select Case cbModemTyp.SelectedIndex()
                    Case 0 ' 
                        txModemInit.Text = "at&f;ate0;at&c0;at&d0;ats0=1;ats7=60;atx3;at&w;att"
                    Case 1 ' 
                        txModemInit.Text = "at&f;ate0;atl1;atx3;at&c0;at&d0;ats0=8;ats14=8;ats46=6;at&w"
                    Case 2 ' 
                        txModemInit.Text = "at&f;ate0;at&c0;at&d0;ats0=1;ats7=60;atx3;at+csns=4;at&w"
                    Case 3 ' ISDN - FritzKarte
                        txModemInit.Text = "at&f;ate0;ats31=2;ats51=0;ats35=9600"
                End Select
        End Select
    End Sub

    Private Sub SelectedIndexChanged_cbModemTyp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbModemTyp.SelectedIndexChanged

        Get_Modem_InitString(m_nCommType)

    End Sub

    Private Sub Get_Error_Information(ByVal szLinkTyp As String, ByVal nComError As Integer, ByVal szComError As String, ByVal MsgStyle As MsgBoxStyle, ByVal szMsgTitle As String)

        MsgBox("Es ist folgender Fehler aufgetreten!" _
        & vbCrLf & szLinkTyp _
        & vbCrLf & "Error-Code = " & nComError _
        & vbCrLf & vbCrLf _
        & "Beschreibung:" _
        & vbCrLf _
        & szComError, MsgStyle, szMsgTitle)

    End Sub

    Private Sub Do_Init_Modem(ByVal ComNum As Integer, ByVal szInit As String, ByRef nResult As Integer)

        Dim charSeparators() As Char = {";"c}
        Dim nInitLength As Integer
        nInitLength = szInit.Length()
        Dim szResult As String()
        Dim nWriteLength As Integer
        Dim nReadLength As Integer
        Dim nError As Integer
        Dim nTry As Integer
        nTry = 1
        Dim szBuf As String
        Dim szBuff As String
        Dim cBufLength(25) As Char
        szBuf = New String(cBufLength)
        Dim nToRead As Integer
        Dim nToWrite As Integer
        Dim bEcho As Boolean
        bEcho = True
        Dim szComError As String
        Dim cErrorLength(255) As Char
        szComError = New String(cErrorLength)
        Dim szLinkTyp As String
        Dim MsgTitle As String
        Dim MsgStyle As MsgBoxStyle
        MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
        MsgTitle = ""
        szLinkTyp = ""

        ' Init-String aufbereiten
        szResult = szInit.Split(charSeparators, StringSplitOptions.RemoveEmptyEntries)
        ' Wie viele Kommandos mssen verarbeitet werden?
        nInitLength = szResult.Length() - 1

        For i As Integer = 0 To nInitLength
            ' Prfen, ob das Echo deaktiviert wurde
            If (szResult.GetValue(i) = "ate0") Then
                bEcho = False
            End If
            ' In Abhngigkeit vom Echo werden die Anzahl der zu lesenden Zeichen festgelegt
            If (bEcho) Then
                nToRead = szResult.GetValue(i).ToString().Length()
                nToRead = nToRead + 8
                ''Else
                ''    nToRead = szResult.GetValue(i).ToString().Length()
            End If

            szBuff = szResult.GetValue(i).ToString() + vbCr
            'szBuff = szResult.GetValue(i).ToString() + vbCrLf
            nToWrite = szResult.GetValue(i).ToString().Length() + 1
            'nToWrite = szResult.GetValue(i).ToString().Length() + 2
            nWriteLength = 0
            nTry = 1

            If (CallingVariations.DFCWrite_Declare(ComNum, szBuff, nToWrite, nWriteLength, nError) = 0) Then
                CallingVariations.DFCGetErrorText_Declare(Convert.ToInt32(txChannelID.Text.ToString), _
                                                            nError, 0, szComError, szComError.Length())

                MsgTitle = "Fehler beim Schreiben des AT-Kommandos!" & szResult.GetValue(i).ToString()
                szLinkTyp = "DLL Link Typ = Declare"
                Get_Error_Information(szLinkTyp, nError, szComError, MsgStyle, MsgTitle)
                Exit For
            Else
                ' Kurzes Feedback
                RichDataBox.AppendText("Senden von AT-Kommandos: DFCWrite()")
                RichDataBox.AppendText(vbCrLf)
                Do While nTry
                    nReadLength = 0
                    '*******
                    ''nTry = 3
                    ''nToRead = 12
                    '*******
                    If (CallingVariations.DFCRead_Declare(ComNum, szBuf, nToRead, nReadLength, nError) = 0) Then
                        If (nReadLength > 0) Then
                            Write_Message(szBuf.ToString().Substring(0, nReadLength))
                            nTry = 0
                        Else
                            bModemReset = True
                            nResult = 1
                            Exit For
                        End If
                    Else
                        ''nTry -= 1
                        Write_Message(szBuf.ToString().Substring(0, nReadLength))
                        szBuf.CopyTo(0, szBuf, 0, szBuf.Length())
                        nTry = 0
                    End If
                Loop
                ' Kurzes Feedback
                RichDataBox.AppendText("Lesen der Antwort auf AT-Kommando: " & szBuff & "mit der Funktion DFCRead()")
                RichDataBox.AppendText(vbCrLf)
                RichDataBox.ScrollToCaret()
            End If

            If Not (bEcho) Then
                nToRead = 6
            End If
        Next i

    End Sub

    Private Sub Click_ModemInit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ModemInit.Click
        Dim nResult As Integer

        ' Hier sollte die Initialisierung durchgefhrt werden
        RichDataBox.Text = ""
        If (m_nConnectState = 0) Then
            Connect_by_Type(m_nCommType)
        Else
            ' Modem initialisieren
            Do_Init_Modem(Convert.ToInt32(txChannelID.Text.ToString), txModemInit.Text.ToString(), nResult)
        End If
    End Sub

    Private Sub Open_Close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Open_Close.Click
        If (Open_Close.Text = "Open") Then
            RichDataBox.Text = ""
            Connect_by_Type(m_nCommType)
        Else
            If (m_nCommType = 3) Then
                RichDataBox.Text = ""
                Connect_by_Type(m_nCommType)
            Else
                Connect_by_Type(m_nCommType)
            End If

        End If
    End Sub

    Private Sub cbLocalIP_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbLocalIP.SelectedIndexChanged
        Dim index As Integer = -1
        index = cbLocalIP.SelectedIndex
        cbSubnet.SelectedIndex = index
        TargetIP.Text = cbLocalIP.Text.ToString.Substring(0, cbLocalIP.Text.LastIndexOf(".") + 1) & "1"
    End Sub
    Private Sub cbSubnet_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSubnet.SelectedIndexChanged

    End Sub
End Class



