Public Class ListenLaden

    Private Sub ListenLaden_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load, MyBase.Activated, MyBase.Shown
        ' Wir bernehmen den Listenpfad
        txListPath.Text = m_sListPath
        txReadList.Text = m_sSaveListPath

    End Sub

    Private Sub btListenLaden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btListenLaden.Click

        ' Vorbereitung fr anzuzeigende Messageboxen
        Dim style As MsgBoxStyle
        Dim style2 As MsgBoxStyle
        style = MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly
        style2 = MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNo

        Dim sListBuffer As String = ""
        Dim sFieldValues As String()

        Dim nComError As Integer
        Dim szComError As String
        Dim nTransferError As Integer = 0
        Dim nSelection As Integer = 0
        Dim cErrorLength(255) As Char
        szComError = New String(cErrorLength)
        Dim szLinkTyp As String
        Dim MsgTitle As String
        Dim MsgStyle As MsgBoxStyle
        MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
        MsgTitle = ""
        szLinkTyp = ""
        RichDataBox.Text = ""

        ' Zuerst alles aufrumen
        RichDataBox.Clear()

        Dim iDFComResult As Integer ' Rckgabewert der DFComDLL Funktionsaufrufe

        Dim LDName As String ' Name eine Listenbeschreibung
        Dim LDField As String ' Name eines Feldes
        Dim length(33) As Char
        LDName = New String(length) ' Bereitstellung des Speichers
        LDField = New String(length) ' Bereitstellung des Speichers

        '********************************************************************************
        ' Hier werden die Listendefinitionen ausgelesen und in den Strukturen gespeichert
        GetListDefinition(RichDataBox)

        ' Nur zur Abgrenzung des Feedbacks in der Ausgabe eine Leerzeile einfgen
        RichDataBox.AppendText(vbCrLf)

        ' Jetzt knnen die Listen erzeugt werden
        ' Aber zuerst den DLL-Cach aufrumen
        Select Case m_nLinkDLLType
            Case 1 ' Declare
                CallingVariations.DFCClrListenBuffer_Declare(1)
            Case 2 ' Import
            Case 3 ' Unicode
            Case 4 ' ANSI 
                CallingVariations.DFCClrListenBuffer_ANSI(1)
            Case 5 ' Auto
        End Select

        ' Dialog zur Auswahl der zu bertragenden Listen ffnen
        ' Dieser Dialog speichert auch gleich den Pfad zu den einzelnen Listen
        If (Dlg_Listenauswahl.ShowDialog = Windows.Forms.DialogResult.OK) Then

            ' Hier die Listen bernehmen
            For i As Integer = 0 To Dlg_Listenauswahl.ctListView.Items.Count - 1
                ' Hier werden nur die Listen verarbeitet, die auch ausgewhlt wurden
                If (Dlg_Listenauswahl.ctListView.Items(i).Checked) Then

                    nSelection = nSelection + 1
                    Dim found As Boolean = False
                    Dim index As Integer = 0
                    Do
                        ' Hier ermitteln wir den Index fr den Zugriff auf die Metadeten der Listendefinitionen in der Speicherstruktur
                        If (String.Compare(Dlg_Listenauswahl.ctListView.Items(i).Text.ToString.Substring(0, Dlg_Listenauswahl.ctListView.Items(i).Text.ToString.Length() - 4), _
                                            STL(index).LiName.ToString.Substring(0, STL(index).LiName.ToString.IndexOf(Chr(0)))) = 0) Then
                            found = True
                        Else
                            index = index + 1
                        End If
                    Loop Until found = True

                    ' Zu jeder Liste die bertragen werden soll, mssen wir die Gre (Anzahl Zeilen) ermitteln.
                    Dim LineCount As Integer = 0
                    Dim bListFormat As Boolean = False

                    ' Hier erzeugen wir eine Instance von StreamReader zum Lesen (Zeilen zhlen) aus einer Datei
                    Using sr As IO.StreamReader = New IO.StreamReader(STL(index).LiPath.ToString, System.Text.Encoding.Default)
                        Dim line As String
                        Dim sTempFields As String()
                        ' Hier lesen wir Zeilenweise den Inhalt der Datei
                        ' Wir geben gleich noch ein Feedback, was wir schreiben werden
                        RichDataBox.AppendText(STL(index).LiName.ToString)
                        RichDataBox.AppendText(vbCrLf)
                        RichDataBox.AppendText("Gelesene Daten:")
                        RichDataBox.AppendText(vbCrLf)
                        Do
                            line = sr.ReadLine()
                            If Not (line Is Nothing) Then
                                ' Hier prfen wir, ob die Anzahl der gelesenen Felder mit der Listendefinition des Setups bereinstimmt
                                Dim charSeparators() As Char = {vbTab}
                                sTempFields = line.Split(charSeparators, StringSplitOptions.RemoveEmptyEntries)

                                If (sTempFields.Length() < STL(index).LiFieldCount) OrElse _
                                    (sTempFields.Length() > STL(index).LiFieldCount) Then
                                    MsgBox("Formatfehler: " & STL(index).LiName.ToString.Substring(0, STL(index).LiName.ToString.Length() - 2), MsgBoxStyle.Exclamation, "Formatfehler")
                                    RichDataBox.AppendText("Formatfehler: Liste - " & STL(index).LiName.ToString)
                                    RichDataBox.AppendText(" konnte nicht geschrieben werden!")
                                    RichDataBox.AppendText(vbCrLf)
                                    nTransferError = nTransferError + 1
                                    Exit Do
                                Else
                                    bListFormat = True
                                End If

                                If Not (line Is Nothing) Then
                                    ' Wenn wir das an der ersten Position finden, ist es ein Kommentar,
                                    ' der wird nicht mit bertragen, also auch nicht gezhlt.
                                    If Not (line(0) = ";") Then
                                        LineCount = LineCount + 1
                                        RichDataBox.AppendText(line.ToString)
                                        RichDataBox.AppendText(vbCrLf)
                                    End If
                                End If
                            End If

                        Loop Until line Is Nothing
                        sr.Close()
                    End Using

                    ' Hier noch an die richtige Stelle Scrollen
                    RichDataBox.AppendText(vbCrLf)
                    RichDataBox.ScrollToCaret()
                    sListBuffer = ""

                    If (bListFormat) Then

                        ' Jetzt knnen wir die zu bertragende Gre der Liste berechnen
                        Dim ListSize As Integer
                        ListSize = LineCount * STL(index).LiLength

                        ' Hier allokieren wir den Speicher fr die Liste
                        Dim cListSize(ListSize) As Char

                        '****************************************************************
                        ' Jetzt mssen die Listendaten in den bereitgestellten Buffer geschrieben werden
                        Using sr As IO.StreamReader = New IO.StreamReader(STL(index).LiPath.ToString, System.Text.Encoding.Default)

                            Dim line As String
                            ' Hier lesen wir Zeilenweise den Inhalt der Datei
                            ' Wir geben gleich noch ein Feedback, was wir schreiben werden
                            RichDataBox.AppendText(STL(index).LiName.ToString)
                            RichDataBox.AppendText(vbCrLf)
                            RichDataBox.AppendText("Geschriebene Daten:")
                            RichDataBox.AppendText(vbCrLf)
                            Do
                                line = sr.ReadLine()
                                If Not (line Is Nothing) Then
                                    ' Wenn wir das an der ersten Position finden, ist es ein Kommentar,
                                    ' der wird nicht mit bertragen, also auch nicht gezhlt.
                                    If Not (line(0) = ";") Then
                                        ' hier zerlegen wir jede Zeile in die ihre Felder
                                        Dim charSeparators() As Char = {vbTab}
                                        sFieldValues = line.Split(charSeparators, StringSplitOptions.RemoveEmptyEntries)

                                        For column As Integer = 0 To STL(index).LiFieldCount - 1
                                            sListBuffer = String.Concat(sListBuffer, sFieldValues.GetValue(column).ToString())  '(line.ToString.Substring(startpos, endpos))

                                            If (sFieldValues.GetValue(column).ToString().Length() < STL(index).LiFields(column).FiLength) Then
                                                sListBuffer = String.Concat(sListBuffer, New String(Chr(0), (STL(index).LiFields(column).FiLength - sFieldValues.GetValue(column).ToString().Length())))
                                            End If
                                            ' Kurzes Feedback
                                            RichDataBox.AppendText(sFieldValues.GetValue(column).ToString)
                                            RichDataBox.AppendText(vbTab)

                                        Next
                                        RichDataBox.AppendText(vbCrLf)

                                    End If

                                End If

                            Loop Until line Is Nothing
                            sr.Close()
                            RichDataBox.AppendText(vbCrLf)
                            sListBuffer = String.Concat(sListBuffer, New String(Chr(0), 1))

                            ' Nur wenn die Liste auch vollstndig verarbeitet werden konnte, wird der DLL-Buffer erstellt
                            Select Case m_nLinkDLLType
                                Case 1 ' Declare
                                    iDFComResult = CallingVariations.DFCMakeListe_Declare(1, index, LineCount, ListSize, sListBuffer, 0)
                                Case 2 ' Import
                                Case 3 ' Unicode
                                Case 4 ' ANSI 
                                    iDFComResult = CallingVariations.DFCMakeListe_Declare(1, index, LineCount, ListSize, sListBuffer, 0)
                            End Select

                            If (iDFComResult = 0) Then
                                MsgBox("Fehler bei DFCMakeListe" & m_sLinkDLLType, MsgBoxStyle.Exclamation, "Fehler bei DFCMakeListe")
                            End If

                        End Using
                        '*******************************************************************
                    End If ' Dieser Zweig wurde nur dann abgearbeitet, wenn das Listenformat mit der Defninition im Setup bereinstimmt 

                End If

            Next

            ' Jetzt kanns aber nun wirklich mit der bertragung losgehen
            Select Case m_nLinkDLLType
                Case 1 ' Declare
                    iDFComResult = CallingVariations.DFCLoadListen_Declare(1, 254, nComError)
                Case 2 ' Import
                Case 3 ' Unicode
                Case 4 ' ANSI 
                    iDFComResult = CallingVariations.DFCLoadListen_ANSI(1, 254, nComError)
            End Select

            If (iDFComResult = 0) Then
                '  MsgBox("error", MsgBoxStyle.Exclamation, "Fehler bei Listenbertragung")
                CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCLoadListen", m_sLinkDLLType, "")
            Else
                If (nTransferError = 0) Then
                    RichDataBox.AppendText(vbCrLf)
                    RichDataBox.AppendText("Die Listen wurden erfolgreich ins Gert bertragen!")
                    RichDataBox.AppendText(vbCrLf)
                    RichDataBox.ScrollToCaret()
                Else
                    RichDataBox.AppendText(vbCrLf)
                    RichDataBox.AppendText(nTransferError.ToString & " von " & nSelection.ToString & " Listen konnten nicht auf das Gert bertragen werden!")
                    RichDataBox.AppendText(vbCrLf)
                    RichDataBox.ScrollToCaret()
                End If
            End If

        End If ' Dlg-Listenpfad

    End Sub

    Public Function LoadListen()

        Dim l_iItemCount As Integer
        Dim l_iItem As Integer = 0

        ' Dim length(Dlg_Listenauswahl.m_ListCount) As Char
        Dim l_ListFile() As String
        ReDim l_ListFile(Dlg_Listenauswahl.m_ListCount)

        '       If (Dlg_Listenauswahl.DialogResult = Windows.Forms.DialogResult.OK) Then
        l_iItemCount = Dlg_Listenauswahl.ctListView.Items.Count
        For i As Integer = 0 To l_iItemCount - 1
            If (Dlg_Listenauswahl.ctListView.Items(i).Checked) Then
                ' Hier stellen wir die zu bertragenden Listen zusammen
                l_ListFile(l_iItem) = Dlg_Listenauswahl.ctListView.Items(i).SubItems(0).ToString
                l_iItem = l_iItem + 1
            End If
        Next

        ' Hier ermitteln wir die Listendefinitionen aller Listen im Gert
        ' Zuerst alles aufrumen
        RichDataBox.Clear()

        Dim LDName As String ' Name eine Listenbeschreibung
        Dim LDField As String ' Name eines Feldes
        Dim length(33) As Char
        LDName = New String(length) ' Bereitstellung des Speichers
        LDField = New String(length) ' Bereitstellung des Speichers

        ' Nun werden die Listen bertragen
        For list As Integer = 0 To l_iItemCount - 1
            ' Die Metadaten der zu bertragenden Liste ermitteln
            For listdefs As Integer = 0 To GlobalDefs.LDCount - 1
                ' if(l_ListFile(list) = 

            Next

        Next

        Return 0

    End Function


    Private Sub btListenLesen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btListenLesen.Click


        ' In diesem Verzeichnis werden die gelesene Listendaten gesichert
        Dim szCurrentDir As String
        ' Default Speicherort ist immer das Programmverzeichnis
        szCurrentDir = System.Environment.CurrentDirectory.ToString
        ' Default werden die Daten immer im ASCII *.txt Format abgelegt
        Dim szExtention As String
        szExtention = ".txt"
        ' Name der Datensatzbeschreibung
        Dim szFileName As String

        If (ListPathDlg.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            szCurrentDir = ListPathDlg.SelectedPath.ToString
            txReadList.Text = szCurrentDir
            txReadList.Update()
            m_sSaveListPath = szCurrentDir

            ' Vorbereitung fr anzuzeigende Messageboxen
            Dim style As MsgBoxStyle
            Dim style2 As MsgBoxStyle
            '   Dim response As MsgBoxResult
            style = MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly
            style2 = MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNo

            Dim nComError As Integer
            Dim szComError As String
            Dim cErrorLength(255) As Char
            szComError = New String(cErrorLength)
            Dim szLinkTyp As String
            Dim MsgTitle As String
            Dim MsgStyle As MsgBoxStyle
            MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
            MsgTitle = ""
            szLinkTyp = ""
            RichDataBox.Text = ""

            ' Zuerst alles aufrumen
            RichDataBox.Clear()

            Dim iDFComResult As Integer ' Rckgabewert der DFComDLL Funktionsaufrufe

            Dim LDName As String ' Name eine Listenbeschreibung
            Dim LDField As String ' Name eines Feldes
            Dim length(33) As Char
            LDName = New String(length) ' Bereitstellung des Speichers
            LDField = New String(length) ' Bereitstellung des Speichers

            '********************************************************************************
            ' Hier werden die Listendefinitionen ausgelesen und in den Strukturen gespeichert
            GetListDefinition(RichDataBox)

            ' Nur zur Abgrenzung des Feedbacks in der Ausgabe eine Leerzeile einfgen
            RichDataBox.AppendText(vbCrLf)

            '********************************************************************************
            ' Jetzt knnen die Listen aus dem Gert gelesen werden
            Dim l_nListHandle As Integer
            Dim l_sListName As String
            '        Dim l_sErrorInfo As String
            Dim l_sFieldValue As String
            Dim l_nValueLength As Integer

            ' Wir haben jetzt alle Daten, die wir bentigen und knnen jetzt die Listendaten aus dem Gert lesen
            For listcount As Integer = 0 To GlobalDefs.LDCount - 1
                ' Handle auf eine Liste ermitteln
                l_sListName = "LIST." & STL(listcount).LiName
                Select Case m_nLinkDLLType
                    Case 1 ' Declare
                        iDFComResult = CallingVariations.DFCOpenTable_Declare(1, 254, l_sListName, 0, l_nListHandle, "", nComError)
                    Case 2 ' Import
                    Case 3 ' Unicode
                    Case 4 ' ANSI 
                        iDFComResult = CallingVariations.DFCOpenTable_ANSI(1, 254, l_sListName, 0, l_nListHandle, "", nComError)
                    Case 5 ' Auto
                End Select
                ' Hier wird der Pfad fr die Dateiablage der Listen zusammengestellt!
                Dim sFileTime As String
                sFileTime = DateTime.Now.Year.ToString & "." & _
                            DateTime.Now.Month.ToString & "." & _
                            DateTime.Now.Day.ToString & "_" & _
                            DateTime.Now.Hour.ToString & "_" & _
                            DateTime.Now.Minute.ToString & "_" & _
                            DateTime.Now.Second.ToString()


                Dim pos As Integer
                pos = STL(listcount).LiName.IndexOf(Chr(0))
                szFileName = STL(listcount).LiName.Substring(0, pos)
                szFileName = szCurrentDir & "\" & szFileName & "_" & sFileTime & ".txt"

                ' Wenn die Datei fr entsprechend der Datensatzbeschreibung
                ' fr die Daten noch nicht existiert, dann erstellen
                ' Schreibobjekt erzeugen
                Dim objStreamWriter As System.IO.StreamWriter


                If (iDFComResult = 1) Then

                    If (nComError = 0) Then

                        ' *****************************************************
                        ' ***!!! Eine bestehende Datei wird berschieben !!!***
                        ' *****************************************************
                        ' Wenn die Datei nicht existiert, wird sie erzeugt
                        objStreamWriter = New System.IO.StreamWriter(szFileName, False, System.Text.Encoding.Default)

                        RichDataBox.AppendText("Liste: ")
                        RichDataBox.AppendText(STL(listcount).LiName)
                        RichDataBox.AppendText(vbCrLf)
                        ' Eine Liste ist offen und der Datensatzzeiger steht auf Position 0 = erster Datensatz

                        Dim szDatensatz As String
                        szDatensatz = Space(255)
                        Trim(szDatensatz)
                        objStreamWriter.Write(";")
                        For fieldcount As Integer = 0 To STL(listcount).LiFieldCount - 1
                            ' Einmal alle Feldbezeichner in die Datei als Spaltenberschrift schreiben
                            RichDataBox.AppendText(STL(listcount).LiFields(fieldcount).FiName)
                            RichDataBox.AppendText(vbTab)
                            objStreamWriter.Write(STL(listcount).LiFields(fieldcount).FiName.ToString.Substring(0, STL(listcount).LiFields(fieldcount).FiName.ToString.IndexOf(Chr(0))))
                            objStreamWriter.Write(vbTab)
                        Next

                        ' Hier die Daten in die Datei schreiben
                        objStreamWriter.Write(vbCrLf)
                        RichDataBox.AppendText(vbCrLf)

                        Do While iDFComResult = 1

                            For fieldcount As Integer = 0 To STL(listcount).LiFieldCount - 1
                                ' Jetzt lesen wir die Fehlder der Reihenach aus
                                l_sFieldValue = StrDup(STL(listcount).LiFields(fieldcount).FiLength, Chr(0))

                                iDFComResult = CallingVariations.DFCGetField_Declare(1, 254, l_nListHandle, STL(listcount).LiFields(fieldcount).FiName, l_sFieldValue, l_nValueLength, nComError)
                                If (iDFComResult = 1) Then
                                    RichDataBox.AppendText(l_sFieldValue)
                                    RichDataBox.AppendText(vbTab)
                                    If (l_nValueLength = 0) Then
                                        l_sFieldValue = " " & Chr(0)
                                    End If
                                    If (l_sFieldValue.IndexOf(Chr(0)) = -1) Then
                                        objStreamWriter.Write(l_sFieldValue)
                                    Else
                                        objStreamWriter.Write(Microsoft.VisualBasic.Left(l_sFieldValue, l_sFieldValue.IndexOf(Chr(0))))
                                    End If
                                    objStreamWriter.Write(vbTab)
                                Else

                                End If
                            Next
                            ' Hier die Daten in die Datei schreiben
                            objStreamWriter.Write(vbCrLf)
                            RichDataBox.AppendText(vbCrLf)
                            RichDataBox.ScrollToCaret()

                            iDFComResult = CallingVariations.DFCSkip_Declare(1, 254, l_nListHandle, 1, 1, nComError)
                        Loop

                        objStreamWriter.Close()

                    End If

                Else
                    ' Der Rckgabewert von DFCUpload_... ist 0.
                    ' Hier geben wir den aufgetretenen Fehler aus
                    ' Wir suchen nach der ersten Position der Endekennung
                    ' Dim pos As Integer
                    '' ''pos = STL(listcount).LiName.IndexOf(Chr(0))
                    '' ''l_sErrorInfo = "Liste " & STL(listcount).LiName.Substring(0, pos)
                    '' ''CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCUpload", m_sLinkDLLType, l_sErrorInfo)
                End If
                ' Wenn wir die Daten geschrieben haben, dann die Datei noch schlieen

                RichDataBox.AppendText(vbCrLf)
                ' Jede geffnete Liste muss auch wieder geschlossen werden
                CallingVariations.DFCCloseTable_Declare(1, 254, l_nListHandle, nComError)

            Next

        End If

    End Sub

End Class