{----------------------------------------------------------------------------------------------------------------------}
{ DATAFOX GMBH (2005) 36124 Eichenzell, Sachsenhausen 3-7, www.datafox.de                                              }                        
{----------------------------------------------------------------------------------------------------------------------}
{    statische Einbindung der PZE-IV-DLL DFComDLL.dll                                                                  }
{                                                                                                                      }
{   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                            }
{    Autor          :  Jens Leuthold  (JML)                                                                            }
{   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                            }
{    Erstellt am    :  3.02.2005                                                                                       }
{    Erstellt mit   :  Borland Delphi 7 Architect                                                                      }
{   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                            }
{    Unit           :  LinkSDFComDLL.pas                                                                               }
{    Version        :  1.20                                                                                            }
{    DLL-Version    :  2.0.20.0                                                                                        }
{    DLL-Build-Date :  08.10.2004                                                                                      }
{                                                                                                                      }
{ ---------------------------------------------------------------------------------------------------------------------}
{    Art der Auflistung                       : Alphabetische Sortierung (aufsteigend)                                 }
{    Verwendete Anzeigebreite                 : 120 Zeichen                                                            }
{                                                                                                                      }
{**********************************************************************************************************************}
{ Hinweis:                                                                                                             }
{**********************************************************************************************************************}
{ (unsigned char *Buf)  wurde in  (Buf: PChar) umgesetzt                                                               }
{                                                                                                                      }
{       alternativ (var Buf: Char)                                                                                     }
{**********************************************************************************************************************}

unit LinkSDFComDLL;

interface

uses Windows, SysUtils;

{ ---------------------------------------------------------------------------------------------------------------------}
{ TFieldType - Datentyp des Feldes wie im Setup definiert:                                                             }
{    ftUnsingnetInt=1      fest  4 Byte                                                                                }
{    ftDateTime=2          fest  7 Byte (yyyy,mm,dd-h:m:s)                                                             }
{    ftAsciiInt=3          max  20 Byte (es sind jedoch nur Ziffern erlaubt)                                           }
{    ftAsciiChar=4         max  20 Byte (Alpha-Numerisch ASCII)                                                        }
{    ftDate=5              fest  4 Byte (yyyy,mm,dd)                                                                   }
{    ftTime=6              fest  3 Byte (hh:mm:ss)                                                                     }
{ ---------------------------------------------------------------------------------------------------------------------}
type
  TFieldType = (ftUnsingnetInt=1, ftDateTime=2, ftAsciiInt=3, ftAsciiChar=4, ftDate=5, ftTime=6 );

//----------------------------------------------------------------------
type
PDSFieldRec = ^TDSFieldRec;
TDSFieldRec = record
  Name         :   array [0..16] of Char;
  TypeCode     :   Integer;
  TypeString   :   array [0..50] of Char;
  Length       :   Integer;
  LengthNoTern :   Integer;
  Number       :   Integer;
  ParentNumber :   Integer;
end;

//----------------------------------------------------------------------


type
  TCBFunction = function(): Integer; stdcall;

const
  // Funktionsergebnisse:
  PZEDLL_ERROR          =   0;
  PZEDLL_OK             =   1;


  function  DFCComOpen(iChannelNum: Integer; szHost: PChar):Integer; stdcall;
  function  DFCComOpenIV(iChannelNum, iBusNum, iType:Integer; szComString:String; iComValue, iComTimeOut:Integer):Integer; stdcall;
  procedure DFCComClose(iChannelNum:Integer); stdcall;
  function  DFCComOpenSocket(iChannelNum: Integer; szRemoteIP: PChar; iPortNum: Integer; iTimeOut: Integer):Integer; stdcall;
  function  DFCGetComPort(iChannelNum: Integer):LongInt; stdcall;
  function  DFCSetCallBack(iChannelNum: Integer; CBFunction: TCBFunction):Integer; stdcall;
  function  DFCComSendMessage(iChannelNum: Integer; iBusNum: Integer;  ucDelayTime: Byte; ucAction: Byte; ucAudio: Byte; szMessage: PChar; iLength: Integer): Integer; stdcall;
  function  DFCCheckDevice(iChannelNum, iBusNum: Integer; piError: PInteger; iDevicePollRetry: Integer):Integer; stdcall;
  function  DFCComSetTime(iChannelNum,iBusNum:Integer; pucDateTime:  PChar): Integer; stdcall;
  function  DFCSetupLaden(iChannelNum, iBusNum:Integer; szFileName: PChar; piError:PInteger):Integer; stdcall;
  function  DFCGetVersionFirmware(iChannelNum: Integer; iBusNum: Integer; szVersion: PChar; piError: PInteger):Integer; stdcall;
  function  DFCGetSeriennummer(iChannelNum: Integer; iBusNum: Integer; piError: PInteger; piSerialNum: PInteger):Integer; stdcall;


  function  DFCComCollectData(iChannelNum, iBusNum:Integer; piError:PInteger):Integer; stdcall;
  function  DFCComGetDatensatz(iChannelNum:Integer; pucBuf: PChar; piLength, piError: PInteger):Integer; stdcall;
  function  DFCLoadDatensatzbeschreibung(iChannelNum, iBusNum:Integer; piError:PInteger):Integer; stdcall;
  function  DFCDatBCnt(iChannelNum:Integer):Integer; stdcall;
  function  DFCDatBFeld(iChannelNum, iDataNum, iField :Integer; szName:PChar; piType, piLength: PInteger):Integer; stdcall;
  function  DFCDatBDatensatz(iChannelNum, iDataNum:Integer; szName:PChar; piFieldCount: PInteger):Integer;stdcall;
  //Listen...
  function  DFCMakeListe(iChannelNum, iListNum, iLineCount, iListSize:Integer; pucBuf:PChar; iListMemSizeNum:Integer):Integer;stdcall;
  function  DFCListBFeld(iChannelNum, iDataNum, iField:Integer; szName:PChar; piType, piLength:PInteger):Integer;stdcall;
  function  DFCListBDatensatz(iChannelNum, iDataNum:Integer; szName:PChar; piFieldCount, piVar:PInteger):Integer;stdcall;
  function  DFCLoadListenbeschreibung(iChannelNum, iBusNum:Integer; piError:PInteger):Integer;stdcall;
  procedure DFCClrListenBuffer(iChannelNum:Integer);stdcall;
  function  DFCListBCnt(iChannelNum:Integer):Integer;stdcall;
  function  DFCLoadListen(iChannelNum, iBusNum:Integer; piError:PInteger):Integer;stdcall;
  // Zutritt Version 2
  function  DFCMakeEntrance2List(iChannelNum, iListNum, iLineCount, iListSize:Integer; pucBuf:PChar; piError:PInteger):Integer;stdcall;
  function  DFCLoadEntrance2List(iChannelNum, iBusNum, iListNum:Integer; piError:PInteger):Integer;stdcall;
  function  DFCClearEntrance2ListBuffer(iChannelNum, iListNum:Integer):Integer;stdcall;


implementation


  Const PZE_DLL='DFComDLL.dll';
  //Connect
  function  DFCComOpen; external PZE_DLL name '_DFCComOpen@8';
  function  DFCComOpenIV; external PZE_DLL name '_DFCComOpenIV@24';
  procedure DFCComClose; external PZE_DLL name '_DFCComClose@4';
  function  DFCComOpenSocket; external PZE_DLL name '_DFCComOpenSocket@16';
  function  DFCGetComPort; external PZE_DLL name '_DFCGetComPort@4';
  function  DFCComSendMessage; external PZE_DLL name '_DFCComSendMessage@28';
  function  DFCCheckDevice; external PZE_DLL name '_DFCCheckDevice@16';
  function  DFCSetCallBack; external PZE_DLL name '_DFCSetCallBack@8';
  function  DFCGetVersionFirmware; external PZE_DLL name '_DFCGetVersionFirmware@16';
  function  DFCGetSeriennummer; external PZE_DLL name '_DFCGetSeriennummer@16';

  // Setup
  function  DFCComSetTime; external PZE_DLL name '_DFCComSetTime@12';
  function  DFCSetupLaden; external PZE_DLL name '_DFCSetupLaden@16';
  //Daten holen
  function  DFCComCollectData; external PZE_DLL name '_DFCComCollectData@12';
  function  DFCComGetDatensatz; external PZE_DLL name '_DFCComGetDatensatz@16';
  function  DFCLoadDatensatzbeschreibung; external PZE_DLL name '_DFCLoadDatensatzbeschreibung@12';
  function  DFCDatBCnt; external PZE_DLL name '_DFCDatBCnt@4';
  function  DFCDatBFeld; external PZE_DLL name '_DFCDatBFeld@24';
  //Listen
  function  DFCMakeListe; external PZE_DLL name '_DFCMakeListe@24';
  function  DFCListBFeld; external PZE_DLL name '_DFCListBFeld@24';
  function  DFCListBDatensatz; external PZE_DLL name '_DFCListBDatensatz@20';
  function  DFCDatBDatensatz; external PZE_DLL name '_DFCDatBDatensatz@16';
  function  DFCLoadListenbeschreibung; external PZE_DLL name '_DFCLoadListenbeschreibung@12';
  procedure DFCClrListenBuffer; external PZE_DLL name '_DFCClrListenBuffer@4';
  function  DFCListBCnt; external PZE_DLL name '_DFCListBCnt@4';
  function  DFCLoadListen; external PZE_DLL name '_DFCLoadListen@12';
  //Zutritt Version 2
  function  DFCMakeEntrance2List; external PZE_DLL name '_DFCMakeEntrance2List@24';
  function  DFCLoadEntrance2List; external PZE_DLL name '_DFCLoadEntrance2List@16';
  function  DFCClearEntrance2ListBuffer; external PZE_DLL name '_DFCClearEntrance2ListBuffer@8';

end.
