// DatafoxCommIV.cpp : Definiert die Initialisierungsroutinen fr die DLL.
//

#include "stdafx.h"
#include "DatafoxCommIV.h"
#include "AEComm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: Wenn diese DLL dynamisch mit MFC-DLLs verknpft ist,
//		muss fr alle aus dieser DLL exportierten Funktionen, die in
//		MFC aufgerufen werden, das AFX_MANAGE_STATE-Makro
//		am Anfang der Funktion hinzugefgt werden.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen angezeigt wird. Dies bedeutet,
//		dass es als erste Anweisung innerhalb der 
//		Funktion angezeigt werden muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe Technische Hinweise fr MFC 33 und 58 fr weitere
//		Details.
//

// CDatafoxCommIVApp
#ifdef _WIN32
BEGIN_MESSAGE_MAP(CDatafoxCommIVApp, CWinApp)
END_MESSAGE_MAP()
#endif

// CDatafoxCommIVApp-Erstellung

CDatafoxCommIVApp *CDatafoxCommIVApp::m_this = NULL;

CDatafoxCommIVApp::CDatafoxCommIVApp()
{
	m_this = this;
#ifdef WIN32
	// Members Initialisieren

	// Haupttask 
	m_workerThread[0] = NULL;
	m_workerThread[1] = NULL;

	// Sockets initialisieren
	m_listenSocket = INVALID_SOCKET;

	// Verarbeitung von Datensatzmeldungen auf "nicht gesetzt" setzen.
	m_notifyRecord = -1;

	// Signal ob das Binden eines Kanals waehrend der Laufzeit erfolgt ist.
	m_bindSignal = 0;
#endif
}


// Das einzige CDatafoxCommIVApp-Objekt

CDatafoxCommIVApp theApp;


// CDatafoxCommIVApp-Initialisierung

#ifdef _WIN32
/**
* @brief Initialisieren der Anwendung.
*/
BOOL CDatafoxCommIVApp::InitInstance()
{
	// Benutzung der Socket - Funktionalitaet initialisieren
	WSADATA WindowsData;
	WORD    Version;

	Version = MAKEWORD(2, 2);
	WSAStartup(Version, &WindowsData);

#ifdef _DEBUG
	//	StartNotify();
#endif
	return CWinApp::InitInstance();
}
#endif

#ifdef _WIN32
/**
* @brief Anwendung auf beenden vorbereiten.
*/
int CDatafoxCommIVApp::ExitInstance() 
{

	// Aktive Verbindung beenden
	StopActiveConnection();
	//	EndNotify();

	// Socket - Funktionalitaet exit
	WSACleanup();

	return CWinApp::ExitInstance();
}
#endif

/**
* @brief Sicherstellen das die Anfrage und das Kanalobjekt in Ordnung ist.
*
bool CDatafoxCommIVApp::AEChannelRequest(short channelID)
{
// Kanalbereich pruefen und evntl. erstellen des nicht vorhandenen Kanalobjektes.
if ((channelID < 0) || (channelID >= MAX_CHANNEL)) {

// Bereich falsch
return false;
}

// Kanalobjekt bereits vorhanden?
if (m_channelArray[channelID] != NULL) {

return true;
}

// Kanalobjekt erzeugen
m_channelArray[channelID] = new CAEChannel((unsigned char)channelID);

return true;
}
*/
/**
* @brief Erhalt eines Kanalobjekts oder NULL bei Bereichsueberschreitung sowie Fehler.
*/
CAEChannel *CDatafoxCommIVApp::GetAEChannel(int &channelID)
{
	if (AEChannelRequest(channelID)) {

#ifdef _WIN32
		// CallBack fuer Notify uebergeben
		m_channelArray[channelID]->SetCBNotifyRecord(CBNotifyRecord);
#endif
		return m_channelArray[channelID];
	}

	return NULL;
}

//#ifdef WIN32
/**
* @brief Sicherstellen das die Anfrage und das Kanalobjekt in Ordnung ist.
*/
bool CDatafoxCommIVApp::AEChannelRequest(int &channelID)
{
	// Kanalbereich pruefen und evntl. erstellen des nicht vorhandenen Kanalobjektes.
	if ((channelID != -1) && (channelID < 0 || channelID >= MAX_CHANNEL)) {

		// Bereich falsch
		return false;
	}

	if (channelID == -1) {
		// Freies suchen
		for (channelID=ACTIVE_CHANNEL_LOWER_BOUND; channelID < ACTIVE_CHANNEL_UPPER_BOUND; channelID++) {

			if  (m_channelArray[channelID] == NULL) {

				break;
			}
#ifdef _WIN32
			else if (m_channelArray[channelID]->GetActiveState() == is_free) {

				return true;
			}
#endif
		}

		if (channelID == ACTIVE_CHANNEL_UPPER_BOUND) {

			// Alle Kanalklassen sind vergeben!
			channelID = -1;
			return false;
		}
	} else {

		// Kanalobjekt bereits vorhanden?
		if (m_channelArray[channelID] != NULL) {

			return true;
		}
	}


	// Kanalobjekt erzeugen
	m_channelArray[channelID] = new CAEChannel(channelID);

	return true;
}

#ifdef _WIN32
/**
 * @brief Ermitteln an welche Kanalnummer dieser Kanal gebunden werden soll.
 */
int CDatafoxCommIVApp::ShouldBoundTo(CAEChannel *channel)
{
	CAEChannel *checkChannel;
	int channelID;
	for (channelID=1; channelID < ACTIVE_CHANNEL_LOWER_BOUND; channelID++) {

		checkChannel = m_channelArray[channelID];
		if (checkChannel != NULL && checkChannel->IsBind()) {

			// Soll der Geraetetyp + serial passen oder passt die IP.
			if ((channel->m_channel4.m_hwInfo.typeDevice == checkChannel->m_bindInfo.typeDevice && channel->m_channel4.m_serial == checkChannel->m_bindInfo.serial) || 
				(strlen((char*)checkChannel->m_bindInfo.ip) && strlen((char*)channel->m_channel4.m_tcpipInfo.ip) && strcmp((char*)checkChannel->m_bindInfo.ip, (char*)channel->m_channel4.m_tcpipInfo.ip) == 0)) {

				break;
			}
		}
	}

	return (channelID == ACTIVE_CHANNEL_LOWER_BOUND) ? 0 : channelID;
}

/**
 * @brief Ermitteln an welche Kanalnummer dieser Kanal gebunden werden soll.
 */
bool CDatafoxCommIVApp::ChannelSwitch(int channelIDFrom, int channelIDTo)
{
	// Kanalbereiche pruefen.
	if (channelIDFrom < 0 || channelIDFrom >= MAX_CHANNEL ||
		channelIDTo < 1 || channelIDTo > ACTIVE_CHANNEL_LOWER_BOUND || 
		channelIDFrom == channelIDTo) {
		
		// Bereich falsch
		return false;
	}

	CAEChannel *channelFrom = m_channelArray[channelIDFrom];
	CAEChannel *channelTo = m_channelArray[channelIDTo];
	// Objekte sicherstellen
	if (channelFrom == NULL) {

		return false;
	}

	// Quellkanal aus Array entkoppeln
	m_channelArray[channelIDFrom] = NULL;

	// Zielkanal ggf. schliessen
	if (channelTo != NULL) {

		// Bindinfo uebernehmen
		channelFrom->m_bindInfo = channelTo->m_bindInfo;
		// Verbindungen Beenden
		channelTo->Close();
	}

	// Kanal wechseln
	return SetAEChannel(channelIDTo, channelFrom);
}

/**
 * @brief Zuweisen eines Kanalobjektes an das Array.
 */
bool CDatafoxCommIVApp::SetAEChannel(int channelID, CAEChannel *channel)
{
	// Kanalbereich pruefen.
	if (channelID < 1 || channelID > ACTIVE_CHANNEL_LOWER_BOUND) {
		
		// Bereich falsch
		return false;
	}

	// Kanalobjekt bereits vorhanden?
	if (m_channelArray[channelID] != NULL) {
	
		// Loeschen.
		delete m_channelArray[channelID];
		m_channelArray[channelID] = NULL;
	}

	// Kanalobjekt erzeugen
	m_channelArray[channelID] = channel;

	// Daten zuweisen
	channel->SetChannelID(channelID);

	return true;
}

int CDatafoxCommIVApp::StartActiveConnection(char *ip, int port, int deviceID, int timeout, int aliveTO, int maxConnections, int infoFlags, int reserved, int *piError)
{
	// Nicht bereits aktiv?
	if (m_workerThread[0] != NULL) {

		*piError = IV_ERROR_AC_STARTED;
		return 0;
	}

	strcpy(m_listenThreadData.ip, ip);
	m_listenThreadData.port = port;
	m_listenThreadData.deviceID = deviceID;
	m_listenThreadData.timeout = timeout;
	m_listenThreadData.aliveTO = aliveTO;
	m_listenThreadData.maxConnections = maxConnections;
	m_listenThreadData.infoFlags = infoFlags;

	// Hauptthread starten; Dieser besorgt die Verbindunsannahme.
	if (m_workerThread[0] == NULL) {

		int i;
		DWORD threadID;
		m_initSignal[0] = -1; // Initialisierungssignal auf undefiniert setzen
		m_workerThread[0] = ::CreateThread(NULL, 0, ListenThread, this, 0, &threadID);

		// Hochlauf des Workers pruefen
		for (i=0; (m_workerThread[0] != NULL) && (m_initSignal[0] == -1) && (i < 100); i++) {

			Sleep(100);
		}
		// Wurde ein Fehler ausgeloest.
		if (m_initSignal[0] != IV_ERROR_SUCCESS) {

			// Grundlegender Initialiserungsfehler?
			if (m_initSignal[0] == -1) {

				*piError = IV_ERROR_AC_LISTENER;
			} else {

				// Fehler von Workerthread 1:1 weitergeben.
				*piError = m_initSignal[0];
			}

			// Hartes Beenden, wenn Thread noch exisitiert.
			if (m_workerThread[0] != NULL) {

				::CloseHandle(m_workerThread[0]);
				m_workerThread[0] = NULL;
			}

			return 0;
		}
	}

	return (m_workerThread[0] != NULL);
}

int CDatafoxCommIVApp::StopActiveConnection()
{
	// Hauptthread deaktivieren, wenn aktiv
	if (m_workerThread[0] != NULL) {

		// WorkerThread fuer Socket beenden.
		m_endSignal[0] = TRUE;

		// Thread umschalten
		Sleep(10);

		// Thread Beendigung abwarten (ListenThread stellt m_endSignal auf FALSE)
		int i;
		for (i=0; (i < 100) && m_endSignal[0]; i++) {

			Sleep(50);
		}

		::CloseHandle(m_workerThread[0]);
		m_workerThread[0] = NULL;

		// Warteschlange loeschen
		if (IsNotifyRecord()) {

			while (m_queue.size()) {

				// Eintrag verwerfen
				m_queue.pop();
			}
		}

		TRACE("Listener end by %i\n", i);
	}

	return !m_endSignal[0];
}

int CDatafoxCommIVApp::SetRecordAvailable(int enable)
{
	// Wert bernehmen
	m_notifyRecord = (enable == 0) ? 0 : 1;
	// Warteschlange loeschen?
	if (m_notifyRecord == 0) {

		while (m_queue.size()) {

			// Eintrag verwerfen
			m_queue.pop();
		}
	}

	return TRUE;
}

int CDatafoxCommIVApp::SetNotifySoftware(int type, char *ip, int port, int retry, int delay, int state)
{
	switch(type) {
	case IV_VALUE_NOTIFY_RECORD:
		if (state) {
			if (!StartNotify()) return IV_ERROR_FAIL;
		} else {
			if (!EndNotify()) return IV_ERROR_FAIL;
		}
		break;
	default:
		return IV_ERROR_FAIL;
	}

	return IV_ERROR_SUCCESS;
}

int CDatafoxCommIVApp::StartNotify()
{
	// Benachrichtigungsthread starten; Dieser besorgt die Nachrichtenverteilung.
	if (m_workerThread[1] == NULL) {

		DWORD threadID;
		m_workerThread[1] = ::CreateThread(NULL, 0, NotifyThread, this, 0, &threadID);
	}

	return (m_workerThread[1] != NULL);
}

int CDatafoxCommIVApp::EndNotify()
{
	// Benachrichtigungsthread deaktivieren, wenn aktiv
	if (m_workerThread[1] != NULL) {

		// WorkerThread fuer Benachrichtigung beenden.
		m_endSignal[1] = TRUE;

		// Thread umschalten
		Sleep(10);

		// Thread Beendigung abwarten
		int i;
		for (i=0; (i < 100) && m_endSignal[1]; i++) {

			Sleep(50);
		}

		CloseHandle(m_workerThread[1]);
		m_workerThread[1] = NULL;

		TRACE("Notifyer end by %i\n", i);
	}

	return !m_endSignal[1];
}

unsigned long WINAPI CDatafoxCommIVApp::ListenThread(LPVOID lpParam)
{
	// Muss einen Parameter uebergeben bekommen vom Type CDatafoxCommIVApp.
	if (lpParam == NULL) {

		return 0;
	}

	// Referenz auf den uebergebenen Parameter
	CDatafoxCommIVApp &own = *(CDatafoxCommIVApp*)lpParam;

	// Hauptschleife ausfuehren?
	int run = FALSE;

	int rc;
	int channelID;

	SOCKADDR_IN sa;
	struct timeval seltime;
	fd_set readfds;

	CAEChannel *channelConnect = NULL;
	CChannel4 *channel4Connect = NULL;

	// Locales Channel-Objekt fuer Trace usw..
	channelID = MAX_CHANNEL-1;
	CChannel4 &channel = own.GetAEChannel(channelID)->m_channel4;

	// Zustandsstatus fuer Listen - Socket
	own.m_listenThreadState = DOWN;

	// Timeout fuer Verbindungsanfragen. 
	//Achtung: Nicht auf 0 da sonst der Thread blockiert wrde!
	seltime.tv_sec  = 1;
	seltime.tv_usec = 0;

	// Sockethandle reservieren
	own.m_listenSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(own.m_listenSocket != INVALID_SOCKET) {

		memset(&sa, 0, sizeof(sa));

		sa.sin_family = AF_INET;
		sa.sin_port = htons(own.m_listenThreadData.port);
		sa.sin_addr.S_un.S_addr = inet_addr(own.m_listenThreadData.ip);

		// Socket mit lokalem Port verbinden.
		if(bind(own.m_listenSocket, (SOCKADDR *)&sa, sizeof(sa)) == SOCKET_ERROR) {

			if(WSAGetLastError() == WSAEADDRINUSE) {

				channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ bind fail (%i) Die gewhlte Portnummer ist in Gebrauch (%i) ]\n", __FILE__, __LINE__, WSAGetLastError(), own.m_listenThreadData.port);
				// Initialisierungsfehler setzten
				own.m_initSignal[0] = IV_ERROR_AC_PORTINUSE;
			} else {

				channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ bind fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
				// Initialisierungsfehler setzten
				own.m_initSignal[0] = IV_ERROR_AC_LISTENER;
			}

			if (closesocket(own.m_listenSocket) == SOCKET_ERROR) {

				channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ closesocket fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
				// Initialisierungsfehler setzten
				own.m_initSignal[0] = IV_ERROR_AC_LISTENER;
			}
			own.m_listenSocket = INVALID_SOCKET;
		} else {

			// Mit Reset - Status beginnen
			run = TRUE;
			own.m_listenThreadState = RESET;
			// Initialisierung erfolgreich
			own.m_initSignal[0] = IV_ERROR_SUCCESS;
		}
	} else {

		channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ socket fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
		// Initialisierungsfehler setzten
		own.m_initSignal[0] = IV_ERROR_AC_LISTENER;
	}

	// Hauptschleife des Worker
	while (run) {

		// Beendigungssignal abfragen
		if (own.m_endSignal[0]) {

			// Listensocket herunterfahren
			if (own.m_listenSocket != INVALID_SOCKET) {

				if (own.m_listenThreadState != DOWN) {

					// Anstehende Verbindungsgesuche verwerfen
					if(listen(own.m_listenSocket, 1) == SOCKET_ERROR) { 

						channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ listen fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
					}
				}
				// Listensocket schliessen
				if (closesocket(own.m_listenSocket) == SOCKET_ERROR) {

					channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ closesocket fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
				}
				own.m_listenSocket = INVALID_SOCKET;

				// Eventuelle Verbindungen beenden
				for (int i=MAX_CHANNEL-1; i > 0; i--) {
					if ((own.m_channelArray[i] != NULL) && (own.m_channelArray[i]->IsActive())) {

						own.m_channelArray[i]->DirectClose();
					}
				}
			}

			// Zustand setzen
			own.m_listenThreadState = DOWN;

			// Hauptschleife verlassen
			run = FALSE;
			continue;
		}

		// Je nach Zustand den Listen-Socket verwalten
		switch(own.m_listenThreadState) {
		case DOWN: 
			// Aufgrund eines Fehlers abgeschaltet
			break;

		case RESET: // Verwirft eventuell anstehende Verbindungsanforderungen,
			// durch (oder) Erzeugung Listensocket.
			if(listen(own.m_listenSocket, 1) == SOCKET_ERROR) { 

				channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ listen fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());

				own.m_listenThreadState = DOWN;
				channel.Trace("%s(%i):INFO(1): CDatafoxCommIVApp::ListenThread [ State change to down... ]\n", __FILE__, __LINE__);
			} else {

				own.m_listenThreadState = LISTENING;
				channel.Trace("%s(%i):INFO(1): CDatafoxCommIVApp::ListenThread [ State change to listening... ]\n", __FILE__, __LINE__);
			}
			break;

		case LISTENING: // Wartet auf Connect. Im "listening" - Zustand.

			FD_ZERO((fd_set FAR *) &readfds);
			FD_SET(own.m_listenSocket, (fd_set FAR *) &readfds);

			if ((rc = select(FD_SETSIZE,
				(fd_set FAR *)&readfds, (fd_set FAR *) 0, (fd_set FAR *) 0,
				(const struct timeval FAR *)&seltime)) == SOCKET_ERROR) {

					channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ select fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
			} else if (rc) {

				// Verbindungsanforderung auf Listensocket im naechsten
				// Druchlauf verarbeiten.
				own.m_listenThreadState = ACCEPTING;
				channel.Trace("%s(%i):INFO(1): CAECommProjectApp::ListenThread [ State change to accepting... ]\n", __FILE__, __LINE__);
			} 

			// Bindpruefung wenn noetig durchfuehren
			if (own.m_bindSignal) {

				int i, x;

				// Alle Aktiven Kanaele pruefen
				for (i=ACTIVE_CHANNEL_LOWER_BOUND; i < ACTIVE_CHANNEL_UPPER_BOUND; i++) {
					
					if (own.m_channelArray[i] != NULL && own.m_channelArray[i]->IsActive()) {
						
						// Pruefen ob der Kanal an eine andere channelID gebunden werden soll.
						if (x = own.ShouldBoundTo(own.m_channelArray[i])) {

							channel.Trace("%s(%i):INFO(1): CAECommProjectApp::ListenThread [ Global channel switch %i to %i ]\n", __FILE__, __LINE__, own.m_channelArray[i]->m_channel4.GetID(), x);
							own.ChannelSwitch(own.m_channelArray[i]->m_channel4.GetID(), x);
						}
					}
				}

				// Zuruecksetzen
				own.m_bindSignal = 0;
			}
			break;

		case ACCEPTING: { // Verbindungsanforderung verarbeiten

			// Anzahl aktiver Verbindungen ermitteln
			int i, x, connected = 0;
			for (i=0; i < ACTIVE_CHANNEL_UPPER_BOUND; i++) {
				
				if ((own.m_channelArray[i] != NULL) && (own.m_channelArray[i]->IsActive())) {

					connected++;
				}
			}

			// Maximale Anzahl Verbinungen noch nicht erreicht?
			if (connected < own.m_listenThreadData.maxConnections) {

				channelID = -1;
				channelConnect = own.GetAEChannel(channelID);
				if (channelConnect) {
				
					channelConnect->Reset();
					channel4Connect = &channelConnect->m_channel4;
				} else {

					channel4Connect = NULL;
				}
			} else {

				channelConnect = NULL;
				channel4Connect = NULL;
			}

			channel.Trace("%s(%i):INFO(1): CDatafoxCommIVApp::ListenThread [ Try connect to (%i) ]\n", __FILE__, __LINE__, channelID);

			if ((channel4Connect == NULL) || !channel4Connect->Connect(&own.m_listenSocket, channelID, own.m_listenThreadData.deviceID, own.m_listenThreadData.timeout, own.m_listenThreadData.aliveTO)) {

				// Wenn alle Kanalobjekte vergeben wurden
				// oder ein Fehler bei der Erstellung auftrat, dann
				// Verbindungsanforderung verwerfen.
//				if (closesocket(accept(own.m_listenSocket, NULL, NULL)) == SOCKET_ERROR) {

//					channel.Trace("%s(%i):INFO(1): CDatafoxCommIVApp::ListenThread [ closesocket fail (%i) ]\n", __FILE__, __LINE__, WSAGetLastError());
//				}

				own.m_listenThreadState = RESET;
				channel.Trace("%s(%i):INFO(1): CDatafoxCommIVApp::ListenThread [ State change to reset... ]\n", __FILE__, __LINE__);
				continue;
			}

			// Zuletzt verbundener Kanal pruefen ob alle benoetigten Daten vorliegen
			for (i=0; (channelConnect->GetActiveState() < is_usable) && (i < 100); i++) {

				Sleep(10);
			}

			// Wenn der Kanal jetz noch nicht verwendbar ist, dann schliessen
			if (channelConnect->GetActiveState() < is_usable) {

				channelConnect->DirectClose();
				channel.Trace("%s(%i):ERROR(1): CDatafoxCommIVApp::ListenThread [ not use able ]\n", __FILE__, __LINE__);
			} else {

				// Neue Verbindung erfolgreich entgegengenommen, Bindpruefung durchfuehren.
				channelConnect->SetActiveState(is_binding);
				channel.Trace("%s(%i):INFO(1): CAECommProjectApp::ListenThread [ SetActiveState(%i) is_binding ]\n", __FILE__, __LINE__, channelConnect->m_channel4.GetID());

				// Pruefen ob der Kanal an eine andere channelID gebunden werden soll.
				if (x = own.ShouldBoundTo(channelConnect)) {

					channel.Trace("%s(%i):INFO(1): CAECommProjectApp::ListenThread [ Local channel switch %i to %i ]\n", __FILE__, __LINE__, channelConnect->m_channel4.GetID(), x);
					own.ChannelSwitch(channelConnect->m_channel4.GetID(), x);
				}

				// Pruefung durchlaufen, ggf. umgemappt.
				channelConnect->SetActiveState(is_active);
				channel.Trace("%s(%i):INFO(1): CAECommProjectApp::ListenThread [ SetActiveState(%i) is_active ]\n", __FILE__, __LINE__, channelConnect->m_channel4.GetID());
			}

			// Verbindungsanfrage verarbeitet
			own.m_listenThreadState = LISTENING;
			channel.Trace("%s(%i):INFO(1): CDatafoxCommIVApp::ListenThread [ State change to listening... ]\n", __FILE__, __LINE__);
			break;}
		}
	}

	// Threadzeiger ruecksetzen
	own.m_workerThread[0] = NULL;

	// Thread Beendigung ruecksetzen
	own.m_endSignal[0] = FALSE;

	return 0;
}

unsigned long WINAPI CDatafoxCommIVApp::NotifyThread(LPVOID lpParam)
{
	// Muss einen Parameter uebergeben bekommen vom Type CDatafoxCommIVApp.
	if (lpParam == NULL) {

		return 0;
	}

	// Referenz auf den uebergebenen Parameter
	CDatafoxCommIVApp &own = *(CDatafoxCommIVApp*)lpParam;

	// Hauptschleife ausfuehren?
	int run = TRUE;

	// Hauptschleife des Worker
	while (run) {

		// Beendigungssignal abfragen
		if (own.m_endSignal[1]) {

			// Hauptschleife verlassen
			run = FALSE;
			continue;
		}

		int channelID, deviceID, infoStringLength;
		char infoString[64];
		infoStringLength = sizeof(infoString);
		if (own.RecordAvailable(&channelID, &deviceID, infoString, &infoStringLength) == IV_ERROR_SUCCESS) {

			// Use introspection API to look up the supported methods
			XmlRpc::XmlRpcClient c(own.m_notifyThreadData.ip, own.m_notifyThreadData.port);
			XmlRpc::XmlRpcValue params, result;
			params[0] = channelID;
			params[1] = deviceID;
			params[2] = infoString;

			if (c.execute("DFCRecordAvailable", params, result)) {

				TRACE("DFCRecordAvailable: %i\n", int(result));
			}
		}

		Sleep(500);
	}

	// Threadzeiger ruecksetzen
	own.m_workerThread[1] = NULL;

	// Thread Beendigung ruecksetzen
	own.m_endSignal[1] = FALSE;

	return 0;
}

#endif
