#include "StdAfx.h"
#include "DataFlash.h"

CDataFlash::CDataFlash()
{
	m_mem = new unsigned char[DATAFLASH_SIZE];
	m_memUse = new unsigned long[DATAFLASH_SIZE / 32];
	Reset();
}

CDataFlash::~CDataFlash()
{
	delete[] m_mem;
	delete[] m_memUse;
}

void CDataFlash::Reset()
{
	// Basisadresse auf 0 setzen
	m_baseAddress = 0;
	// Speicher initialisieren
	memset(m_mem, 0xFF, DATAFLASH_SIZE);
	memset(m_memUse, 0, (DATAFLASH_SIZE / 32) * sizeof(unsigned long));
}

void CDataFlash::SetMemUsebit(unsigned long address)
{
	address -= m_baseAddress;
	m_memUse[address / 32] |= (1 << (address % 32));
}

unsigned char CDataFlash::GetMemUsebit(unsigned long address)
{
	address -= m_baseAddress;
	return (m_memUse[address / 32] & (1 << (address % 32))) ? 1 : 0;
}

unsigned long CDataFlash::GetMemFirstAddress()
{
	unsigned long address, firstAddress =  m_baseAddress;
	for (address=0; address < DATAFLASH_SIZE; address++) {

		if (GetMemUsebit(address + m_baseAddress)) {

			firstAddress = address + m_baseAddress;
			break;
		}
	}

	return firstAddress;
}

unsigned long CDataFlash::GetMemLastAddress()
{
	unsigned long address, lastAddress = m_baseAddress;
	for (address=0; address < DATAFLASH_SIZE; address++) {

		if (GetMemUsebit(address + m_baseAddress)) {

			lastAddress = address + m_baseAddress;
		}
	}

	return lastAddress;
}
