// DFItemInputChain.cpp: Implementierung der Klasse CDFItemInputChain.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DFItemInputChain.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemInputChain::CDFItemInputChain(NodeTypeID _type) : CDFItemBase(_type)
{
	// Member initialisieren
	m_ulFlashOffset = 0;
}

CDFItemInputChain::~CDFItemInputChain()
{

}

int CDFItemInputChain::Modify(CModifyData &modifyData)
{
	int i;
	unsigned long offs = modifyData.offsFlash, offsChilds;
	CDFItemBase *item;
	
	// Daten von Bedien - Struktur uebernehmen
	TBedien &bedien = *(TBedien*)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
	ChangeOrderLong((unsigned char*)&bedien.P);
	offs += sizeof(TBedien);
	
	// Offset abziehen, da Erweitertes - Flash hinter Setupdaten.
	bedien.P -= m_ulFlashOffset;
	
	// Daten von DatensatzEinlesen - Struktur uebernehmen
	TBDatensatzEinlesen &datensatzEinlesen = *(TBDatensatzEinlesen*)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
	ChangeOrderLong((unsigned char*)&datensatzEinlesen.P);
	offs += sizeof(TBDatensatzEinlesen);
	
	// Offset abziehen, da Erweitertes - Flash hinter Setupdaten.
	datensatzEinlesen.P -= m_ulFlashOffset;
	
	// Namen aendern?
	strcpy(datensatzEinlesen.Name, LookupReplace(modifyData, datensatzEinlesen.Name).c_str());
	
	// Daten aller Eintraege einlesen
	for (i=0; i < (int)datensatzEinlesen.Felder; i++) {
		
		offsChilds = datensatzEinlesen.P + i * sizeof(unsigned long);	// Pointer des Eintrags berechnen
		
		offsChilds = *(unsigned long*)&modifyData.file->m_flash[offsChilds - FLASH_KONFIG_START];
		ChangeOrderLong((unsigned char*)&offsChilds);
		// Bei ExtendedFlash mit Offset		
		offsChilds -= m_ulFlashOffset;
		
		item = new CDFItemInputChainField();
		LinkEndChild(item);
		modifyData.offsFlash = offsChilds;
		item->Modify(modifyData);
	}

	// Adressen zurueckkonvertieren
	ChangeOrderLong((unsigned char*)&bedien.P);
	ChangeOrderLong((unsigned char*)&datensatzEinlesen.P);
	
	return TRUE;
}
