// DFItemInputChainField.cpp: Implementierung der Klasse CDFItemInputChainField.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DFItemInputChainField.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemInputChainField::CDFItemInputChainField(NodeTypeID _type) : CDFItemBase(_type)
{

}

CDFItemInputChainField::~CDFItemInputChainField()
{

}

int CDFItemInputChainField::Modify(CModifyData &modifyData)
{
	// Daten von FeldEinlesen einlesen
	TBFeldEinlesen &feldEinlesen = *(TBFeldEinlesen*)&modifyData.file->m_flash[modifyData.offsFlash - FLASH_KONFIG_START];
	TBExBestaetigung exBestaetigung;
	TBExNumFeld exNumFeld;
	TBExListAuswahl exListAuswahl;	

	// Name aendern?
	strcpy(feldEinlesen.Name, LookupReplace(modifyData, feldEinlesen.Name).c_str());
	
	// Daten fuer union je nach "Einlesemethode"
	switch(feldEinlesen.Typ) {

	case TBFE_NORM:
	case TBFE_GET_TIME:
	case TBFE_KONSTANTE:
	case TBFE_COPY_GV_TO_FIELD:
	case TBFE_TIMEBOY_COPY_GV_TO_FIELD:
	case TBFE_SERIENNUMMER:
	case TBFE_ANALOG_WERT:
	case TBFE_ANALOG_STATUS:
	case TBFE_DIGITAL_WERT:
	case TBFE_ZAEHLER_WERT:
	case TBFE_FUNC:
	case TBFE_SPS_WERT:
	case TBFE_ENTRANCE_ZM_NUM:
	case TBFE_ENTRANCE_READER_NUM:
	case TBFE_ENTRANCE_PNR:
	case TBFE_ENTRANCE_STATUS:
	case TBFE_DEBUG:
	case TBFE_GPRS_ALIVE_COUNTER:
	case TBFE_FIRMWARE_VERSION:
	case TBFE_ONLINE_STATUS:
	case TBFE_SUMMER_WINTER_STATUS:
	case TBFE_GPS_RECORD_FIX:
	case TBFE_GPS_RECORD_VARIABLE:
	case TBFE_ENTRANCE2_IDENTIFICATION:
	case TBFE_COPY_FIELD_TO_GV:
	case TBFE_TIMEBOY_COPY_FIELD_TO_GV:
	case TBFE_FINGERPRINT_SCANN:
	case TBFE_FINGERPRINT_CARD:
	case TBFE_FINGERPRINT_TEACH:
	case TBFE_FINGERPRINT_IDENTIFICATION:
	case TBFE_FINGERPRINT_VERIFICATION:
	case TBFE_FINGERPRINT_DELETE:
	case TBFE_OPERATION:
	case TBFE_SWITCH_RELAY:
	case TBFE_SWITCH_LED:
	case TBFE_TIMER:
	case TBFE_TRANSPONDER_WRITE:
	case TBFE_GPS_DISTANCE:

		exNumFeld = feldEinlesen.Ex.NumFeld;

		break;
	
	case TBFE_LIST_SELECT_GET:
	case TBFE_LIST_SELECT_SET:

		exListAuswahl = feldEinlesen.Ex.ListAuswahl;
		break;
	
	case TBFE_BESTAETIGUNG:

		exBestaetigung = feldEinlesen.Ex.Bestaetigung;
		break;
	
	default:
		ASSERT(FALSE);
	}


	return TRUE;
}
