/**
 * @file  DFFileDeviceText.h
 * @brief Schnittstelle fuer die Klasse CDFFileDeviceText.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILEDEVICETEXT_H_
#define _DFFILEDEVICETEXT_H_

// Basisklasse 
#include "DFFileIntelHex.h"

// Strukturdefinitionen
#include "../Common/PZEMAIV.h"
// CRC berechnungsroutinen
#include "../Common/CRC.h"

#pragma warning(disable : 4996)

class CDFFileDeviceText : public CDFFileIntelHex
{
public:
	CDFFileDeviceText();
	virtual ~CDFFileDeviceText();

	void Reset();
	inline unsigned long GetSizeData() { return m_sizeData; };

	int Load(char *fileName);
	int Save(char *fileName, unsigned char append = 0);
	char *DefaultDFL();
	
	int Import(char *fileName);
	int ParseLineFromHeader(char *data, unsigned short &id, char **format, char **text, unsigned long &flags);
	int ParseLineFromDefault(char *data, unsigned short &id, char **format, char **text, unsigned long &flags);
	void ConvertControlCharacters(char **text);

public:
	unsigned long m_sizeData;
	unsigned char *m_memData;
	unsigned long m_sizeDefaultDFL;
	char *m_memDefaultDFL;
};

#endif

