/**
 * @file  DFFileRawFirmware.h
 * @brief Schnittstelle fuer die Klasse CDFFileRawFirmware.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILERAWFIRMWARE_H_
#define _DFFILERAWFIRMWARE_H_

#pragma warning(disable : 4996)

// Basisklasse 
#include "DFFileIntelHex.h"
// Hilfsklassen
#include "../Common/ATmega128.h"

class CDFFileRawFirmware : public CDFFileIntelHex
{
public:
	CDFFileRawFirmware();
	virtual ~CDFFileRawFirmware();

	void Reset();
	inline CATmega128 *GetController() { return &m_controller; };
	inline unsigned long GetSizeData() { return m_sizeData; };

	int Load(char *fileName);
	int Save(char *fileName, unsigned char append = 0);

protected:
	unsigned long m_sizeData;
	CATmega128 m_controller;

};

#endif

