// DFFileStudio.h: Schnittstelle fr die Klasse CDFFileStudio.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DFFILESTUDIO_H__49311412_E6B3_413F_A3C7_0A3F25DF431C__INCLUDED_)
#define AFX_DFFILESTUDIO_H__49311412_E6B3_413F_A3C7_0A3F25DF431C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../Common/AES.h"
#include <stdio.h>

//#define HEADER_CHECK 0xDEDEDEDE  ///< StructAESHeader.check: Pruefwert fuer Gueltigkeit (Versionskennung) 
#define HEADER_CHECK    0x03040000
#define AESHEADER_CHECK 0xDFDFDFDF

typedef struct StructAESHeader {
	unsigned long check;             ///< muss immer mit AESHEADER_CHECK belegt werden.
	unsigned long minVersion;        ///< Mindestversion der einzusetzenden Software
	unsigned long curVersion;        ///< Version mit der die Datei zuletzt abgespeichert wurde.
	unsigned long size;              ///< groesse der Stuktur sizeof(TAESHeader)
	unsigned long crcHead;           ///< CRC ueber die grundlegenden Kopfdaten
	//...
	unsigned long crc;               ///< CRC ueber alle Kopfdaten
} TAESHeader;

class CDFFileStudio  
{
public:
	CDFFileStudio();
	virtual ~CDFFileStudio();

	void SetDefault();

	int Load(char *fileName);
	int Save(char *fileName);
	unsigned long GetFlashSetupSize();
	int NeededVersion();
	void ChangeOrderLong(unsigned char *Buf);

public:
	TAESHeader m_fileHeader;
	TConfig m_config;
	unsigned char *m_configMem;
	unsigned char *m_eep;
	unsigned char *m_flash;
	unsigned char *m_flashExtended;
	unsigned long m_flashSizeSU2;

	// Pfadangaben der Listen / Zusatzpfade
	char m_listFileName[MAX_DATENSATZ_BESCHREIBUNG][260];
	char m_listEntranceFileName[4][260];
	char m_listEntrance2FileName[MAX_DATENSATZ_BESCHREIBUNG][260];
	char m_strExtendedFilePath[MAX_DATENSATZ_BESCHREIBUNG][260];
};

#endif // !defined(AFX_DFFILESTUDIO_H__49311412_E6B3_413F_A3C7_0A3F25DF431C__INCLUDED_)
