/**
 * @file  Channel4ModuleSystem.cpp
 * @brief Implementierung der Klasse CChannel4ModuleSystem.
 */
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Channel4ModuleSystem.h"

#include <memory>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>


void CChannel4ModuleSystem::MobileMaskedSysvar(char *buf)
{
	int i;
	char lBuf[512];
	char c1, c2, c3, c4;
	memset(lBuf, 0, sizeof(lBuf));

	for (i=0; i < (int)strlen(buf); i++)
	{
		switch ((unsigned char)buf[i])
		{
		case 0x40: strcat(lBuf, "\\00"); break;
		case 0xA3: strcat(lBuf, "\\01"); break;
		case 0x24: strcat(lBuf, "\\02"); break;
		case 0xA5: strcat(lBuf, "\\03"); break;
		case 0xE8: strcat(lBuf, "\\04"); break;
		case 0xE9: strcat(lBuf, "\\05"); break;
		case 0xF9: strcat(lBuf, "\\06"); break;
		case 0xEC: strcat(lBuf, "\\07"); break;
		case 0xF2: strcat(lBuf, "\\08"); break;
		case 0xC7: strcat(lBuf, "\\09"); break;
		case 0xD8: strcat(lBuf, "\\0B"); break;
		case 0xF8: strcat(lBuf, "\\0C"); break;
		case 0xC5: strcat(lBuf, "\\0E"); break;
		case 0xE5: strcat(lBuf, "\\0F"); break;
		case 0x5F: strcat(lBuf, "\\11"); break;
		case 0x0C: strcat(lBuf, "\\1B0A"); break;
		case 0x5E: strcat(lBuf, "\\1B14"); break;
		case 0x7B: strcat(lBuf, "\\1B28"); break;
		case 0x7D: strcat(lBuf, "\\1B29"); break;
		case 0x5C: {
			int len = strlen(buf) - i;
			if ((strlen(buf) - i) > 2) {

				c1 = (char)toupper(buf[i + 1]);
				c2 = (char)toupper(buf[i + 2]);
				if ((strlen(buf) - i) > 4) {

					c3 = (char)toupper(buf[i + 3]);
					c4 = (char)toupper(buf[i + 4]);
				}
				// Handelt es sich um eine bekannte Maskierung?
				// Dann wird diese mit bernommen,
				// ansonsten wird der \ maskiert.
				if (c1 == '0')
				{
					if (c2 == '0' || c2 == '1' || c2 == '2' || c2 == '3' ||
						c2 == '4' || c2 == '5' || c2 == '6' || c2 == '7' ||
						c2 == '8' || c2 == '9' || c2 == 'B' || c2 == 'C' ||
						c2 == 'E' || c2 == 'F')
					{
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i];
						continue;
					}
				}
				else if (((strlen(buf) - i) > 4) && c1 == '1' && c2 == 'B')
				{
					if ((c3 == '0' && c4 == 'A') ||
						(c3 == '1' && c4 == '4') ||
						(c3 == '2' && c4 == '8') ||
						(c3 == '2' && c4 == '9') ||
						(c3 == '2' && c4 == 'F') ||
						(c3 == '3' && c4 == 'C') ||
						(c3 == '3' && c4 == 'D') ||
						(c3 == '3' && c4 == 'E') ||
						(c3 == '4' && c4 == '0') )
					{

						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i];
						continue;
					}

				}
				else if (c1 == '1')
				{
					if (c2 == '1' || c2 == 'C' || c2 == 'D' || c2 == 'E' || c2 == 'F')
					{
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i];
						continue;
					}
				}
				else if ((c1 == '2' && c2 == '4') ||
					(c1 == '4' && c2 == '0') ||
					(c1 == '6' && c2 == '0') )
				{
					lBuf[strlen(lBuf)] = buf[i]; i++;
					lBuf[strlen(lBuf)] = buf[i]; i++;
					lBuf[strlen(lBuf)] = buf[i];
					continue;
				}
				else if (c1 == '5')
				{
					if (c2 == 'B' || c2 == 'C' || c2 == 'D' || c2 == 'E' || c2 == 'F')
					{
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i];
						continue;
					}
				}
				else if (c1 == '7')
				{
					if (c2 == 'B' || c2 == 'C' || c2 == 'D' || c2 == 'E' || c2 == 'F')
					{
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i]; i++;
						lBuf[strlen(lBuf)] = buf[i];
						continue;
					}
				}
			}
			strcat(lBuf, "\\1B2F"); 
			break;}
		case 0x5B: strcat(lBuf, "\\1B3C"); break;
		case 0x7E: strcat(lBuf, "\\1B3D"); break;
		case 0x5D: strcat(lBuf, "\\1B3E"); break;
		case 0x7C: strcat(lBuf, "\\1B40"); break;
		case 0xC6: strcat(lBuf, "\\1C"); break;
		case 0xE6: strcat(lBuf, "\\1D"); break;
		case 0xDF: strcat(lBuf, "\\1E"); break;
		case 0xC9: strcat(lBuf, "\\1F"); break;
		case 0xA4: strcat(lBuf, "\\24"); break;
		case 0xA1: strcat(lBuf, "\\40"); break;
		case 0xC4: strcat(lBuf, "\\5B"); break;
		case 0xD6: strcat(lBuf, "\\5C"); break;
		case 0xD1: strcat(lBuf, "\\5D"); break;
		case 0xDC: strcat(lBuf, "\\5E"); break;
		case 0xA7: strcat(lBuf, "\\5F"); break;
		case 0xBF: strcat(lBuf, "\\60"); break;
		case 0xE4: strcat(lBuf, "\\7B"); break;
		case 0xF6: strcat(lBuf, "\\7C"); break;
		case 0xF1: strcat(lBuf, "\\7D"); break;
		case 0xFC: strcat(lBuf, "\\7E"); break;
		case 0xE0: strcat(lBuf, "\\7F"); break;
		default: lBuf[strlen(lBuf)] = buf[i];
		}
	}

	// Ggf. genderten Wert bernehmen
	strcpy(buf, lBuf);
}

void CChannel4ModuleSystem::MobileUnmaskedSysvar(char *buf)
{
	int i;
	char c1, c2, c3, c4;
	char lBuf[512];
	memset(lBuf, 0, sizeof(lBuf));

	for (i=0; i < (int)strlen(buf); i++)
	{
		if (((strlen(buf) - i) > 2) && buf[i] == '\\') 
		{
			c1 = (char)toupper(buf[i + 1]);
			c2 = (char)toupper(buf[i + 2]);
			if ((strlen(buf) - i) > 4) {

				c3 = (char)toupper(buf[i + 3]);
				c4 = (char)toupper(buf[i + 4]);
			}

			if(c1 == '0')
			{
				if (c2 == '0') { lBuf[strlen(lBuf)] = (char)0x40; i += 2; }
				else if (c2 == '1') {lBuf[strlen(lBuf)] = (char)0xA3; i += 2; }
				else if (c2 == '2') { lBuf[strlen(lBuf)] = (char)0x24; i += 2; }
				else if (c2 == '3') { lBuf[strlen(lBuf)] = (char)0xA5; i += 2; }
				else if (c2 == '4') { lBuf[strlen(lBuf)] = (char)0xE8; i += 2; }
				else if (c2 == '5') { lBuf[strlen(lBuf)] = (char)0xE9; i += 2; }
				else if (c2 == '6') { lBuf[strlen(lBuf)] = (char)0xF9; i += 2; }
				else if (c2 == '7') { lBuf[strlen(lBuf)] = (char)0xEC; i += 2; }
				else if (c2 == '8') { lBuf[strlen(lBuf)] = (char)0xF2; i += 2; }
				else if (c2 == '9') { lBuf[strlen(lBuf)] = (char)0xC7; i += 2; }
				else if (c2 == 'B') { lBuf[strlen(lBuf)] = (char)0xD8; i += 2; }
				else if (c2 == 'C') { lBuf[strlen(lBuf)] = (char)0xF8; i += 2; }
				else if (c2 == 'E') { lBuf[strlen(lBuf)] = (char)0xC5; i += 2; }
				else if (c2 == 'F') { lBuf[strlen(lBuf)] = (char)0xE5; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			}
			else if (c1 == '1')
			{
				if (c2 == '1') { lBuf[strlen(lBuf)] = (char)0x5F;	i += 2; }
				else if (c2 == 'B') {

					if (c3 == '0' && c4 == 'A') { lBuf[strlen(lBuf)] = (char)0x0C; i += 4; }
					else if (c3 == '1' && c4 == '4') { lBuf[strlen(lBuf)] = (char)0x5E; i += 4; }
					else if (c3 == '2' && c4 == '8') { lBuf[strlen(lBuf)] = (char)0x7B; i += 4; }
					else if (c3 == '2' && c4 == '9') { lBuf[strlen(lBuf)] = (char)0x7D; i += 4; }
					else if (c3 == '2' && c4 == 'F') { lBuf[strlen(lBuf)] = (char)0x5C; i += 4; }
					else if (c3 == '3' && c4 == 'C') { lBuf[strlen(lBuf)] = (char)0x5B; i += 4; }
					else if (c3 == '3' && c4 == 'D') { lBuf[strlen(lBuf)] = (char)0x7E; i += 4; }
					else if (c3 == '3' && c4 == 'E') { lBuf[strlen(lBuf)] = (char)0x5D; i += 4; }
					else if (c3 == '4' && c4 == '0') { lBuf[strlen(lBuf)] = (char)0x7C; i += 4; }
					else { lBuf[strlen(lBuf)] = buf[i]; }
				}
				else if (c2 == 'C') { lBuf[strlen(lBuf)] = (char)0xC6; i += 2; }
				else if (c2 == 'D') { lBuf[strlen(lBuf)] = (char)0xE6; i += 2; }
				else if (c2 == 'E') { lBuf[strlen(lBuf)] = (char)0xDF; i += 2; }
				else if (c2 == 'F') { lBuf[strlen(lBuf)] = (char)0xC9; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			}
			else if (c1 == '2')
			{
				if (c2 == '4') { lBuf[strlen(lBuf)] = (char)0xA4; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			}
			else if (c1 == '4')
			{
				if (c2 == '0') { lBuf[strlen(lBuf)] = (char)0xA1; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			}
			else if (c1 == '5')
			{
				if (c2 == 'B') { lBuf[strlen(lBuf)] = (char)0xC4; i += 2; }
				else if (c2 == 'C') { lBuf[strlen(lBuf)] = (char)0xD6; i += 2; }
				else if (c2 == 'D') { lBuf[strlen(lBuf)] = (char)0xD1; i += 2; }
				else if (c2 == 'E') { lBuf[strlen(lBuf)] = (char)0xDC; i += 2; }
				else if (c2 == 'F') { lBuf[strlen(lBuf)] = (char)0xA7; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			}
			else if (c1 == '6')
			{
				if (c2 == '0') { lBuf[strlen(lBuf)] = (char)0xBF; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			}
			else if (c1 == '7')
			{
				if (c2 == 'B') { lBuf[strlen(lBuf)] = (char)0xE4; i += 2; }
				else if (c2 == 'C') { lBuf[strlen(lBuf)] = (char)0xF6; i += 2; }
				else if (c2 == 'D') { lBuf[strlen(lBuf)] = (char)0xF1; i += 2; }
				else if (c2 == 'E') { lBuf[strlen(lBuf)] = (char)0xFC; i += 2; }
				else if (c2 == 'F') { lBuf[strlen(lBuf)] = (char)0xE0; i += 2; }
				else { lBuf[strlen(lBuf)] = buf[i]; }
			} else {

				lBuf[strlen(lBuf)] = buf[i];
			}
		} 
		else 
		{
			lBuf[strlen(lBuf)] = buf[i];
		}
	}

	// Ggf. genderten Wert bernehmen
	strcpy(buf, lBuf);
}


// ##################################################################
/**
 * @brief Initialisieren der Membervariablen.
 *
 * @param id Nummer der Kanalklasse fuer z.B. Trace.
 */
void CChannel4ModuleSystem::InitClass(short channelID, short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::InitClass [ %i, %i ]\n", __FILE__, __LINE__, channelID, deviceID);

	// Seriennummer des Geraetes
	m_serial = 0xFFFFFFFF;

	// Passwort fuer die Kommunikation
	memset(m_passwordCommunication, 0, sizeof(m_passwordCommunication));
}

// ##################################################################
/**
 * @brief Destruktor.
 *
 */
CChannel4ModuleSystem::~CChannel4ModuleSystem() 
{
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 */
void CChannel4ModuleSystem::GetErrorModule(short module, short error, char *text)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetErrorModule [ %i, %i, 0x%08X ]\n", __FILE__, __LINE__, module, error, text);

	// Ist IV_MODULE_SYSTEM ?
	if (module == IV_MODULE_SYSTEM) {

	}

	// Ermittlung des Fehlertextes an Basisklasse abgeben.
	CChannel4ModuleHardware::GetErrorModule(module, error, text);
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 */
void CChannel4ModuleSystem::GetErrorFunction(short module, short function, short error, char *text)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetErrorFunction [ %i, %i, %i, 0x%08X ]\n", __FILE__, __LINE__, module, function, error, text);

	if (module == IV_MODULE_SYSTEM) {

		// Sonderfehler fr Passwortschutz abhandeln.
		if (error == 28) {
			// Die Modulfunktionen liefern den Fehlercode 28, wenn kein oder ein falsches Passwort verwendet wurde.
			// Es ist in diesem Fall zuerst das richtige Passwort fr die Kommunikation erforderlich.
			sprintf(text, "( %i ): Korrektes Passwort fr die Kommunikation erforderlich.", error);
			return;
		} else if (error == 29) {
			// Die Modulfunktionen liefern den Fehlercode 29, wenn 3 mal ein falsches Passwort verwendet wurde.
			// Die Befehlsausfhrung ist danach fr 60 Sekunden blockiert.
			sprintf(text, "( %i ): Gert ist aufgrund von fehlerhaften Passworteingaben fr 60 Sekunden gesperrt.", error);
			return;
		}

		switch(function) {
		case IV_FUNCTION_SYSTEM_RESET:
			switch(error) {
			case 1: sprintf(text, "( %i ): Resetmodus unbekannt.", error); break;
			}
			break;
		case IV_FUNCTION_SET_SERIAL:
			switch(error) {
			case 1: sprintf(text, "( %i ): Pruefung der Seriennummer - Verschluesselung schlug fehl.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_GET_VERSION:
		case IV_FUNCTION_GET_VERSION_BOOTLOADER:
		case IV_FUNCTION_GET_SERIAL:
		case IV_FUNCTION_SET_RTC:
		case IV_FUNCTION_GET_RTC:
			switch(error) {
			case 1:sprintf(text, "( %i ): ", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_SET_SYSTEM_VARIABLE:
		case IV_FUNCTION_GET_SYSTEM_VARIABLE:
			switch(error) {
			case 1:sprintf(text, "( %i ): Der Majorbestandteil des Variablennamens ist unbekannt.", error); break;
			case 2:sprintf(text, "( %i ): Der Minorbestandteil des Variablennamens ist unbekannt.", error); break;
			case 3:sprintf(text, "( %i ): Der zu setzende Variablenwert ist zu lang.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_SET_RELAY:
		case IV_FUNCTION_GET_RELAY:
			switch(error) {
			case 1:sprintf(text, "( %i ): Bereichsname unbekannt. (INTERN, TMR, IOM ...)", error); break;
			case 2:sprintf(text, "( %i ): Busnummer (z.B. TMR) nicht bekannt oder erreichbar.", error); break;
			case 3:sprintf(text, "( %i ): Relaisnummer unbekannt.", error); break;
			case 4:sprintf(text, "( %i ): Zu setzender Zustand (Status) unbekannt oder nicht untersttzt.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_SET_MMC:
		case IV_FUNCTION_SET_FLASH:
			switch(error) {
			case 1:sprintf(text, "( %i ): Speicherseite konnte nicht geschrieben werden.", error); break;
			case 3:sprintf(text, "( %i ): Speicherplatz reicht nicht aus.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_GET_SFSMPB:
		case IV_FUNCTION_GET_MMC:
		case IV_FUNCTION_GET_FLASH:
		case IV_FUNCTION_SET_EEPROM:
		case IV_FUNCTION_GET_EEPROM:
		case IV_FUNCTION_SET_PROGRAM:
		case IV_FUNCTION_GET_PROGRAM:
		case IV_FUNCTION_GET_RAM:
		case IV_FUNCTION_SET_RAM:
			switch(error) {
			case 1:sprintf(text, "( %i ): ", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_BEGIN_SET_SEGMENT:
		case IV_FUNCTION_END_SET_SEGMENT:
			switch(error) {
			case 1:sprintf(text, "( %i ): Der Typ ist unbekannt.", error); break;
			case 2:sprintf(text, "( %i ): Die Updatesegmente sind erschpft.", error); break;
			case 3:sprintf(text, "( %i ): Der Angeforderte Speicherplatz steht nicht zur Verfgung.", error); break;
			case 4:sprintf(text, "( %i ): Es wurde kein STOP vorm START durchgefhrt.", error); break;
			case 5:sprintf(text, "( %i ): Verschachtelungsfehler von STOP und START.", error); break;
			case 6:sprintf(text, "( %i ): Prfsumme (CRC) des Updatesegmentes stimmt nicht mit gegebener berein.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_BEGIN_SET_SEGMENT_OK:
		case IV_FUNCTION_END_SET_SEGMENT_OK:
			break;
		case IV_FUNCTION_BEGIN_GET_SEGMENT:
		case IV_FUNCTION_END_GET_SEGMENT:
			switch(error) {
			case 1:sprintf(text, "( %i ): Der Typ ist unbekannt.", error); break;
			case 2:sprintf(text, "( %i ): Die Updatesegmente sind erschpft.", error); break;
			case 3:sprintf(text, "( %i ): Der Bentigte Speicherplatz steht nicht zur Verfgung.", error); break;
			case 4:sprintf(text, "( %i ): Es wurde kein STOP vorm START durchgefhrt.", error); break;
			case 5:sprintf(text, "( %i ): Verschachtelungsfehler von STOP und START.", error); break;
			case 6:sprintf(text, "( %i ): Prfsumme (CRC) des Updatesegmentes stimmt nicht mit gegebener berein.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_BEGIN_GET_SEGMENT_OK:
		case IV_FUNCTION_END_GET_SEGMENT_OK:
			break;
		case IV_FUNCTION_ENTER_BIOS:
		case IV_FUNCTION_EXIT_BIOS:
			switch(error) {
			case 1:sprintf(text, "( %i ): ", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_ENTERED_BIOS:
		case IV_FUNCTION_EXITED_BIOS:
			break;
		case IV_FUNCTION_GET_INFO:
			switch(error) {
			case 1:sprintf(text, "( %i ): Der Majorbestandteil des Modulnamens ist unbekannt.", error); break;
			case 2:sprintf(text, "( %i ): Der Minorbestandteil des Modulnamens ist unbekannt.", error); break;
			case 3: sprintf(text, "( %i ): Es wurden zu wenige Paramteter angegeben.", error); break;
			case 4: sprintf(text, "( %i ): Es wurden zu viele Paramteter angegeben.", error); break;
			case 5: sprintf(text, "( %i ): Der Wert eines Parameters liegt auserhalb seines Gltigkeitsbereichs.", error); break;
			case 6: sprintf(text, "( %i ): Die Information zur Komponente steht nicht zur Verfgung.", error); break;
			case 7: sprintf(text, "( %i ): Das Modul kann zur Zeit nicht angesprochen werden.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_OPEN_COM_SERVER_MODE:
			switch(error) {
			case 1: sprintf(text, "( %i ): Es wurden zu wenige Paramteter angegeben.", error); break;
			case 2: sprintf(text, "( %i ): Es wurden zu viele Paramteter angegeben.", error); break;
			case 3: sprintf(text, "( %i ): Die Angabe des comm Parameters wird nicht untersttzt.", error); break;
			case 4: sprintf(text, "( %i ): Die Angabe des baudRate Parameters wird nicht untersttzt.", error); break;
			case 5: sprintf(text, "( %i ): Die Angabe des byteSize Parameters wird nicht untersttzt.", error); break;
			case 6: sprintf(text, "( %i ): Die Angabe des parity Paramters wird nicht untersttzt.", error); break;
			case 7: sprintf(text, "( %i ): Die Angabe des stopBits Paramters wird nicht untersttzt.", error); break;
			case 8: sprintf(text, "( %i ): Die Angabe des flags Parameters wird nicht untersttzt.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_CLOSE_COM_SERVER_MODE:
			switch(error) {
			case 1: sprintf(text, "( %i ): Bei der bertragung ist ein Overflow eingetreten.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;
		case IV_FUNCTION_OPEN_COM_SERVER_MODE_OK:
			break;

		case IV_FUNCTION_PASSWORD_CHECK:
			switch(error) {
			case 1: sprintf(text, "( %i ): Passwort stimmt nicht mit dem bentigten berein.", error); break;
			default: sprintf(text, "( %i ): Nicht eingetragener Funktionsfehler!", error); break;
			}
			break;

		default: 
			sprintf(text, "( %i ): Nicht eingetragener Fehlerblock fr Funktion!", error); break;
		}
		
		return;
	}

	// Ermittlung des Fehlertextes an Basisklasse abgeben.
	CChannel4ModuleHardware::GetErrorFunction(module, function, error, text);
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceIDRemote Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::Execute(short context, short module, short function, unsigned char *buf, int &count, int contextValue)
// Modulbefehl senden und Antwort zurueckgeben
//  deviceIDRemote -> Adresse (Geraetenummer) des Empfaengers
//  module   -> Nummer des anzusprechenden Modules
//  function -> Nummer der Funktion im Module
//	buf	     -> Buffer fuer Funktionsparameter.
//	count    -> Anzahl der Funktionsparameter in Byte. Rueckgabewert bei Parameterempfang.
//
//  return -> <0 -> Kommunikationsfehler
//             0 -> senden und empfangen und ausfuehren erfolgreich
//			  >0 -> module-/Funktionsfehler
{
	Trace("%s(%i):INFO(3): CChannel4ModulSystem::Execute [ %i, %i, %i, 0x%08X, %i, %i ]\n", __FILE__, __LINE__, context, module, function, buf, count, contextValue);

	int res = CChannel4Protocol::Execute(context, module, function, buf, count, contextValue);

	// Bei Verwendung eines Passworts:
	// Wenn das Passwort noch nicht bertragen wurde, wird der Fehler hier abgefangen.
	// Das Passwort wird bertragen und der geforderte Befehl erneut ausgefhrt.
	if ((res & 0xFF) == 28) {

		Trace("%s(%i):INFO(1): CChannel4ModulSystem::Execute [ Passwort wird gefordert. ]\n", __FILE__, __LINE__, context, module, function, buf, count, contextValue);

		int lRes;
		// Buffer fr Folgebefehl zwischenspeichern,
		// da das hinter buf liegende Bytearray durch Aufruf von PasswordCheck verndert wird.
		unsigned char data[IV_PACKET_LENGTH_DATA];
		memset(data, 0, sizeof(data));
		memcpy(data, buf, count);

		// Passwortprfung durchfhren
		if ((lRes = PasswordCheck(GetDeviceIDRemote(), (char*)GetPasswordCommunication())) == IV_ERROR_SUCCESS) {

			// Passwortprfung erfolgreich, Parameterdaten wiederherstellen.
			memcpy(buf, data, count);
			// Befehl erneut ausfhren.
			return CChannel4Protocol::Execute(context, module, function, buf, count, contextValue);
		} else {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_CHECK);
			// Passwortprfung fehlgeschlagen, Parameterdaten wiederherstellen.
			memcpy(buf, data, count);
		}

		// Vorherigen Fehler zurckliefern.
		return res;
	}

	return res;
}

//#########################################################
//################# HARDWARE BUGFIX #######################
//#########################################################

// ##################################################################
/**
 * @brief berschreibt eine gleichnamige Funktion aus dem zugrundeliegenden Module
 *        und stellt einen Bugfix da.
 *
 */
int CChannel4ModuleSystem::GetTypeDisplay(short deviceID, unsigned char &value, int checked)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetTypeDisplay [ %i, %i ]\n", __FILE__, __LINE__, deviceID, value);

	// Impementierungswechsel: Bootloaderversionen 00.04.00.00 und 00.04.00.01 verwalten die Werte anderst:
	// - Funktionen TypeTransponder liefern <-> Displaywert
	// - Funktionen TypeDisplay liefern <-> Keypadwert
	// - Funktionen TypeKeypad liefern <-> Transponderwert
	int res;
	char version[64];
	memset(version, 0, sizeof(version));
	// Befindet sich im Bootloader?
	if (!checked && (res = GetVersion(deviceID, version)) != IV_ERROR_SUCCESS) {
		if ((res > 0) && (((res >> 8) & 0xFF) == 2)) {

			// Befehl wird nicht unterstuetzt
			// Geraet befindet sich im Bootloadermodus
			if ((res = GetVersionBootloader(deviceID, version)) != IV_ERROR_SUCCESS) {

				return res;
			}

			// Ist eine von den gesuchten Versionen?
			if (strstr(version, "00.04.00.00") || strstr(version, "00.04.00.01")) {
			
				// Auf entsprechende Funktion verzweigen
				return CChannel4ModuleHardware::GetTypeTransponder(deviceID, value, TRUE);
			}
		}
	}

	return CChannel4ModuleHardware::GetTypeDisplay(deviceID, value, TRUE);
}

// ##################################################################
/**
 * @brief berschreibt eine gleichnamige Funktion aus dem zugrundeliegenden Module
 *        und stellt einen Bugfix da.
 *
 */
int CChannel4ModuleSystem::GetTypeKeypad(short deviceID, unsigned char &value, int checked)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetTypeKeypad [ %i, %i ]\n", __FILE__, __LINE__, deviceID, value);

	// Impementierungswechsel: Bootloaderversionen 00.04.00.00 und 00.04.00.01 verwalten die Werte anderst:
	// - Funktionen TypeTransponder liefern <-> Displaywert
	// - Funktionen TypeDisplay liefern <-> Keypadwert
	// - Funktionen TypeKeypad liefern <-> Transponderwert
	int res;
	char version[64];
	memset(version, 0, sizeof(version));
	// Befindet sich im Bootloader?
	if (!checked && (res = GetVersion(deviceID, version)) != IV_ERROR_SUCCESS) {
		if ((res > 0) && (((res >> 8) & 0xFF) == 2)) {

			// Befehl wird nicht unterstuetzt
			// Geraet befindet sich im Bootloadermodus
			if ((res = GetVersionBootloader(deviceID, version)) != IV_ERROR_SUCCESS) {

				return res;
			}

			// Ist eine von den gesuchten Versionen?
			if (strstr(version, "00.04.00.00") || strstr(version, "00.04.00.01")) {
			
				// Auf entsprechende Funktion verzweigen
				return CChannel4ModuleHardware::GetTypeDisplay(deviceID, value, TRUE);
			}
		}
	}

	return CChannel4ModuleHardware::GetTypeKeypad(deviceID, value, TRUE);
}

// ##################################################################
/**
 * @brief berschreibt eine gleichnamige Funktion aus dem zugrundeliegenden Module
 *        und stellt einen Bugfix da.
 *
 */
int CChannel4ModuleSystem::GetTypeTransponder(short deviceID, unsigned char &value, int checked)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetTypeTransponder [ %i, %i ]\n", __FILE__, __LINE__, deviceID, value);

	// Impementierungswechsel: Bootloaderversionen 00.04.00.00 und 00.04.00.01 verwalten die Werte anderst:
	// - Funktionen TypeTransponder liefern <-> Displaywert
	// - Funktionen TypeDisplay liefern <-> Keypadwert
	// - Funktionen TypeKeypad liefern <-> Transponderwert
	int res;
	char version[64];
	memset(version, 0, sizeof(version));
	// Befindet sich im Bootloader?
	if (!checked && (res = GetVersion(deviceID, version)) != IV_ERROR_SUCCESS) {
		if ((res > 0) && (((res >> 8) & 0xFF) == 2)) {

			// Befehl wird nicht unterstuetzt
			// Geraet befindet sich im Bootloadermodus
			if ((res = GetVersionBootloader(deviceID, version)) != IV_ERROR_SUCCESS) {

				return res;
			}

			// Ist eine von den gesuchten Versionen?
			if (strstr(version, "00.04.00.00") || strstr(version, "00.04.00.01")) {
			
				// Auf entsprechende Funktion verzweigen
				return CChannel4ModuleHardware::GetTypeKeypad(deviceID, value, TRUE);
			}
		}
	}

	return CChannel4ModuleHardware::GetTypeTransponder(deviceID, value, TRUE);
}

// ##################################################################
/**
 * @brief berschreibt eine gleichnamige Funktion aus dem zugrundeliegenden Module
 *        und ist aufgrund eines Bugfixes hier implementiert.
 *
 */
int CChannel4ModuleSystem::GetHardwareInfo(short deviceID, TDFHardwareInfo &hwInfo)
{
	int res = IV_ERROR_SUCCESS;

	// Struktur initialisieren
	memset(&hwInfo, 0xFF, sizeof(TDFHardwareInfo));
	// Administrationsflags ruecksetzen
	hwInfo.administrationFlags = 0;

	//#####################################################
	// Version der Hardwareinfo ermitteln
	if ((res = GetHWConfig(deviceID, hwInfo.version)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {
			
			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	if (hwInfo.version == 0xFF) {
		// Es liegt keine Hardwareinfo vor.
		hwInfo.version = 0;
	}

	// Geraetetyp ermitteln
	if ((res = GetTypeDevice(deviceID, hwInfo.typeDevice)) != IV_ERROR_SUCCESS) {
		
		// Wenn der Modulfehler -Funktion unbekannt- ist,
		// dann liegt eine FW 04.01.01.<k vor.
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzten.
	if (hwInfo.typeDevice == 0xFF) {

		hwInfo.typeDevice = IV_VALUE_TYPE_DEVICE_PZE;
	}

	// Boardtyp ermitteln
	if ((res = GetTypeBoard(deviceID, hwInfo.typeBoard)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}
	
	// Wenn nicht initialisiert, dann Default setzten.
	if (hwInfo.typeBoard == 0xFF) {

		hwInfo.typeBoard = IV_VALUE_TYPE_BOARD_1_4;
	}

	// RS485 ermitteln
	if ((res = GetComponentRS485_0(deviceID, hwInfo.componentRS485_0)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}
	
	// Wenn nicht initialisiert, dann Default setzten.
	if (hwInfo.componentRS485_0 == 0xFF) {

		hwInfo.componentRS485_0 = 0;
	}

	// TCPIP ermitteln
	if ((res = GetTypeTCPIP(deviceID, hwInfo.typeTCPIP)) != IV_ERROR_SUCCESS) {		
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzten.
	if (hwInfo.typeTCPIP == 0xFF) {

		hwInfo.typeTCPIP = IV_VALUE_TYPE_TCPIP_NONE;
	}
	
	// ModemMC35i ermitteln
	if ((res = GetTypeModemMC(deviceID, hwInfo.typeModemMC)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}
	
	// Wenn nicht initialisiert, dann Default setzten.
	if (hwInfo.typeModemMC == 0xFF) {

		hwInfo.typeModemMC = IV_VALUE_TYPE_MODEM_MC_NONE;
	}

	// RS485 (intern) ermitteln
	if ((res = GetComponentRS485_1(deviceID, hwInfo.componentRS485_1)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzten.
	if (hwInfo.componentRS485_1 == 0xFF) {

		hwInfo.componentRS485_1 = 0;
	}
	
	// Typ ermitteln (erst ab 04.01.01.p / Bootloader 4.0)
	if ((res = GetTypeDisplay(deviceID, hwInfo.typeDisplay)) != IV_ERROR_SUCCESS) {
		
		// Wenn der Modulfehler -Funktion unbekannt- ist,
		// dann liegt eine FW 04.01.01.<p vor.
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeDisplay == 0xFF) {

		hwInfo.typeDisplay = IV_VALUE_TYPE_DISPLAY_SMALL;
	}

	// Typ ermitteln
	if ((res = GetTypeKeypad(deviceID, hwInfo.typeKeypad)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeKeypad == 0xFF) {

		hwInfo.typeKeypad = IV_VALUE_TYPE_KEYPAD_9;
	}

	// Typ ermitteln
	if ((res = GetTypeTransponder(deviceID, hwInfo.typeTransponder)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeTransponder == 0xFF) {

		hwInfo.typeTransponder = IV_VALUE_TYPE_TRANSPONDER_TSR32;
	}
	
	// Typ ermitteln
	if ((res = GetTypeMMC(deviceID, hwInfo.typeMMC)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeMMC == 0xFF) {

		hwInfo.typeMMC = IV_VALUE_TYPE_MMC_NONE;
	}

	// Typ ermitteln
	if ((res = GetTypeRadio(deviceID, hwInfo.typeRadio)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeRadio == 0xFF) {

		hwInfo.typeRadio = IV_VALUE_TYPE_RADIO_NONE;
	}

	// Typ ermitteln
	if ((res = GetTypeGPS(deviceID, hwInfo.typeGPS)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeGPS == 0xFF) {

		hwInfo.typeGPS = IV_VALUE_TYPE_GPS_NONE;
	}
	
	// Komponende ermitteln
	if ((res = GetComponentUSB(deviceID, hwInfo.componentUSB)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.componentUSB == 0xFF) {

		hwInfo.componentUSB = 0;
	}

	// Typ ermitteln
	if ((res = GetTypeDCF77(deviceID, hwInfo.typeDCF77)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeDCF77 == 0xFF) {

		hwInfo.typeDCF77 = IV_VALUE_TYPE_DCF77_NONE;
	}

	// Komponende ermitteln
	if ((res = GetComponentInAnalog(deviceID, hwInfo.componentInAnalog)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}
	
	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.componentInAnalog == 0xFFFFFFFF) {

		hwInfo.componentInAnalog = IV_VALUE_COMPONENT_IN_ANALOG_NONE;
	}

	// Komponende ermitteln
	if ((res = GetComponentInDigital(deviceID, hwInfo.componentInDigital)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.componentInDigital == 0xFFFFFFFF) {

		hwInfo.componentInDigital = IV_VALUE_COMPONENT_IN_DIGITAL_NONE;
	}

	// Komponende ermitteln
	if ((res = GetComponentOutDigital(deviceID, hwInfo.componentOutDigital)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.componentOutDigital == 0xFFFFFFFF) {

		hwInfo.componentOutDigital = IV_VALUE_COMPONENT_OUT_DIGITAL_NONE;
	}

	// Typ ermitteln
	if ((res = GetTypeFingerprint(deviceID, hwInfo.typeFingerprint)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn nicht initialisiert, dann Default setzen.
	if (hwInfo.typeFingerprint == 0xFF) {

		hwInfo.typeFingerprint = IV_VALUE_TYPE_FINGERPRINT_NONE;
	}

	hwInfo.typeExternalReader = 0xFF;
	// Typ ermitteln
	if ((res = GetTypeExternalReader(deviceID, hwInfo.typeExternalReader)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn ZK Option vorhanden
	if (hwInfo.componentRS485_1) {
		// aber der Externe Lesertyp undefiniert ist,
		// dann wird von TS-Lesern ausgegangen.
		if (hwInfo.typeExternalReader == 0xFF) {

			hwInfo.typeExternalReader = IV_VALUE_TYPE_EXTERNAL_READER_GIS;
		}
	} else {

		// Keine Externen leser
		hwInfo.typeExternalReader = IV_VALUE_TYPE_EXTERNAL_READER_UNDEFINED;
	}
	// BUGFIX
	// Eine Firmware die die Serien TS und Protect untersttzt setzt als untersttzte Serien
	// TS und Protect obwohl es so sein sollte, dass die angesprochene Serie eingetragen wird,
	// so dass der Wert der Hardwareinfo eindeutig ist.
	// Werden beide Flags vorgefunden wird von TS ausgegangen,
	// wird Protect alleine vorgefunden wird von PHG alleine ausgegangen.
	if (hwInfo.typeExternalReader & 0x01 && hwInfo.typeExternalReader & 0x04) {

		hwInfo.typeExternalReader = 0x01;
	} else if (hwInfo.typeExternalReader & 0x04) {

		// BUGFIX
		// Eine Firmware < 04.01.04.43 stellt fest ihre unterstuetzte Serie und verwendet 4 fuer PHG.
		hwInfo.typeExternalReader = 0x02;
	}

	// Option ermitteln
	if ((res = GetOptionIOModule(deviceID, hwInfo.optionIOModule)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn die Option undefiniert ist dann wird von deaktiviert ausgegangen.
	if (hwInfo.optionIOModule == 0xFF) {

		hwInfo.optionIOModule = IV_VALUE_OPTION_IOMODULE_NONE;
	}

	// Option ermitteln
	if ((res = GetOptionTBAdaption(deviceID, hwInfo.optionTBAdaption)) != IV_ERROR_SUCCESS) {
		
		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}
	
	// Wenn die Option undefiniert ist und ein Mobil-MasterIV vorliegt, dann aktiv ansonsten deaktiviert.
	if (hwInfo.optionTBAdaption == 0xFF) {

		if (hwInfo.typeDevice == IV_VALUE_TYPE_DEVICE_MOBIL) {

			hwInfo.optionTBAdaption = IV_VALUE_OPTION_TBADAPTION;
		} else {

			hwInfo.optionTBAdaption = IV_VALUE_OPTION_TBADAPTION_NONE;
		}
	}

	// Option ermitteln
	if ((res = GetOptionComServer(deviceID, hwInfo.optionComserver)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	} else {
	
		// BUGFIX:
		// Dieser Befehl existiert bereits in der Firmware obwohl die Option noch nicht untersttzt wird.
		// Er gehrt zur Gruppe 2 der Zusatzoptionen liegt aber per Befehl in der Gruppe 1
	}

	// Wenn die Option undefiniert ist dann wird von deaktiviert ausgegangen.
	if (hwInfo.optionComserver == 0xFF) {

		hwInfo.optionComserver = IV_VALUE_OPTION_COMSERVER_NONE;
	}

	// Option ermitteln
	if ((res = GetOptionTPWrite(deviceID, hwInfo.optionTPWrite)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	} else {

		// Fasthack um festzustellen, dass die Optionen der Gruppe 2 verfuegbar
		hwInfo.administrationFlags |= HIAF_HAS_OPTIONS2;
	}

	// Wenn die Option undefiniert ist dann wird von deaktiviert ausgegangen.
	if (hwInfo.optionTPWrite == 0xFF) {

		hwInfo.optionTPWrite = IV_VALUE_OPTION_TPWRITE_NONE;
	}

	// Option ermitteln
	if ((res = GetOptionHTTP(deviceID, hwInfo.optionHttp)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn die Option undefiniert ist dann wird von aktiviert ausgegangen.
	if (hwInfo.optionHttp == 0xFF) {

		hwInfo.optionHttp = IV_VALUE_OPTION_HTTP_NONE;

		if (hwInfo.typeModemMC) {

			hwInfo.optionHttp = IV_VALUE_OPTION_HTTP;
		}
	}

	// Option ermitteln
	if ((res = GetOptionLanguage(deviceID, hwInfo.optionLanguage)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn die Option undefiniert ist dann wird von aktiviert ausgegangen.
	if (hwInfo.optionLanguage == 0xFF) {

		hwInfo.optionLanguage = IV_VALUE_OPTION_LANGUAGE;
	}


	// Option ermitteln
	if ((res = GetOptionBiokeyUpdate(deviceID, hwInfo.optionBiokeyUpdate)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	}

	// Wenn die Option undefiniert ist dann wird von deaktiviert ausgegangen.
	if (hwInfo.optionBiokeyUpdate == 0xFF) {

		hwInfo.optionBiokeyUpdate = IV_VALUE_OPTION_BIOKEY_UPDATE_NONE;
	}

	unsigned short mask = 0;
	// Option ermitteln
	if ((res = GetSetupOptions(deviceID, mask, hwInfo.optionsSetup)) != IV_ERROR_SUCCESS) {

		// Nicht der Modulfehler -Funktion unbekannt-
		if (!(((res >> 8) & 0xFF) == 2)) {

			return res;
		}
		// Fehlerobjekt zurueck setzen
		res = IV_ERROR_SUCCESS;
	} else {

		// Fasthack um festzustellen, dass die Optionen der Gruppe 3 verfuegbar
		hwInfo.administrationFlags |= HIAF_HAS_OPTIONS3;
	}

	// Wenn die Option undefiniert ist dann wird von maximal moeglich ausgegangen.
//	if (hwInfo.optionsSetup == 0xFFFF) {
#ifdef _DEBUG
		hwInfo.optionsSetup = (mask & hwInfo.optionsSetup);
#endif
//	}

	return res;
}

// ##################################################################
/**
 * @brief berschreibt eine gleichnamige Funktion aus dem zugrundeliegenden Module
 *        und ist aufgrund eines Bugfixes hier implementiert.
 *
 */
int CChannel4ModuleSystem::GetInfos(TDFHardwareInfo hwInfo, char *info)
{
	char tmp[0x100];
	unsigned long bit;
	int res = 1;

	memset(tmp, 0, sizeof(tmp));
	strcpy(tmp, "Enthaltene Optionen/Module\r\n");
	strcat(tmp, "------------------------------------------\r\n");
	strcat(info, tmp);

	memset(tmp, 0, sizeof(tmp));
	strcat(tmp, "\r\nBasis\r\n----------\r\n");
	strcat(info, tmp);

	strcat(info, "Geraete: ");
	memset(tmp, 0, sizeof(tmp));
	// Moegliche Geraetetypen
	switch(hwInfo.typeDevice) {
	case IV_VALUE_TYPE_DEVICE_PZE:     strcat(tmp, "PZE-MasterIV"); break;
	case IV_VALUE_TYPE_DEVICE_ZK:      strcat(tmp, "ZK-MasterIV");  break;
	case IV_VALUE_TYPE_DEVICE_BDE:     strcat(tmp, "BDE-MasterIV"); break;
	case IV_VALUE_TYPE_DEVICE_MOBIL:   strcat(tmp, "Mobil-MasterIV"); break;
	case IV_VALUE_TYPE_DEVICE_MDE:     strcat(tmp, "MDE-BoxIV"); break;
	case IV_VALUE_TYPE_DEVICE_AE:      strcat(tmp, "AE-MasterIV"); break;
	case IV_VALUE_TYPE_DEVICE_TIMEBOY: strcat(tmp, "Timeboy-MasterIV"); break;
	default:                           strcat(tmp, "Undefiniert"); break;
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	strcat(info, "Platinen: ");
	memset(tmp, 0, sizeof(tmp));
	// Boardtyp pruefen
	switch(hwInfo.typeBoard) {
	case IV_VALUE_TYPE_BOARD_1_0: strcat(tmp, "1.0"); break;
	case IV_VALUE_TYPE_BOARD_1_1: strcat(tmp, "1.1"); break;
	case IV_VALUE_TYPE_BOARD_1_2: strcat(tmp, "1.2"); break;
	case IV_VALUE_TYPE_BOARD_1_3: strcat(tmp, "1.3"); break;
	case IV_VALUE_TYPE_BOARD_1_4: strcat(tmp, "1.4"); break;
	case IV_VALUE_TYPE_BOARD_2_0: strcat(tmp, "2.0"); break;
	case IV_VALUE_TYPE_BOARD_2_1: strcat(tmp, "2.1"); break;
	case IV_VALUE_TYPE_BOARD_3_0: strcat(tmp, "3.0"); break;
	default:                      strcat(tmp, "Undefiniert"); break;
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	/////////////////////////////////////////////
	// Hauptkommunikationen
	memset(tmp, 0, sizeof(tmp));
	strcat(tmp, "\r\nHauptkommunikationen\r\n------------------------------\r\n");
	strcat(info, tmp);
	
	// Funk pruefen
	strcat(info, "Bluetooth: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeRadio) {

		switch(hwInfo.typeRadio) {
		case IV_VALUE_TYPE_RADIO_WRAPTHOR: strcat(tmp, "Ja"); break;
		default:                           strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// ModemMCxx pruefen
	strcat(info, "Mobil-Funkmodem: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeModemMC) {

		switch(hwInfo.typeModemMC) {
		case IV_VALUE_TYPE_MODEM_MC_39: strcat(tmp, "Siemens MC39"); break;
		case IV_VALUE_TYPE_MODEM_MC_55: strcat(tmp, "Siemens MC55"); break;
		default:         strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// RS485 pruefen
	sprintf(tmp, "RS485 Kommunikation: %s\r\n", hwInfo.componentRS485_0 ? "Ja" : "Nein");
	strcat(info, tmp);

	// TCPIP pruefen
	strcat(info, "TCPIP: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeTCPIP) {

		switch(hwInfo.typeTCPIP) {
		case IV_VALUE_TYPE_TCPIP_XPORT:     strcat(tmp, "Ja"); break;
		case IV_VALUE_TYPE_TCPIP_MATCHPORT: strcat(tmp, "Ja, ber WLAN"); break;
		default:         strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// USB pruefen
	sprintf(tmp, "USB Kommunikation: %s\r\n", hwInfo.componentUSB ? "Ja" : "Nein");
	strcat(info, tmp);

	/////////////////////////////////////////////
	// Zusatzoptionen
	memset(tmp, 0, sizeof(tmp));
	strcat(tmp, "\r\nZustzliche Optionen der Firmware\r\n------------------------------\r\n");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "IO-Modul: %s\r\n", hwInfo.optionIOModule ? "Ja" : "Nein");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "Timeboyanbindung: %s\r\n", hwInfo.optionTBAdaption ? "Ja" : "Nein");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "Com-Server: %s\r\n", hwInfo.optionComserver ? "Ja" : "Nein");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "HTTP: %s\r\n", hwInfo.optionHttp ? "Ja" : "Nein");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "Transponder schreiben: %s\r\n", hwInfo.optionTPWrite ? "Ja" : "Nein");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "Textdaten bentigt: %s\r\n", hwInfo.optionLanguage ? "Ja" : "Nein");
	strcat(info, tmp);

	// Zusatzoption eingestellt?
	sprintf(tmp, "Biokey update mglich: %s\r\n", hwInfo.optionBiokeyUpdate ? "Ja" : "Nein");
	strcat(info, tmp);


	/////////////////////////////////////////////
	// Zusatzbaugruppen
	memset(tmp, 0, sizeof(tmp));
	strcat(tmp, "\r\nZusatzbaugruppen\r\n------------------------------\r\n");
	strcat(info, tmp);

	// Display pruefen
	strcat(info, "Anzeige: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeDisplay) {

		switch(hwInfo.typeDisplay) {
		case IV_VALUE_TYPE_DISPLAY_SMALL:   strcat(tmp, "4 Zoll Monochrome"); break;
		case IV_VALUE_TYPE_DISPLAY_BIG:     strcat(tmp, "6 Zoll Monochrome"); break;
		case IV_VALUE_TYPE_DISPLAY_SMALLER: strcat(tmp, "1,9 Zoll Color"); break;
		default:                            strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// DigitalOut pruefen
	strcat(info, "Ausgaenge Digital: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.componentOutDigital) {

		for (bit=1;; bit <<= 1) {

			if (bit & hwInfo.componentOutDigital) {

				if (strlen(tmp)) {
					strcat(tmp, ", ");
				}

				switch(bit) { // Digitale Ausgaenge
				case 0x01: strcat(tmp, "dO1"); break;
				case 0x02: strcat(tmp, "dO2"); break;
				case 0x04: strcat(tmp, "dO3"); break;
				case 0x08: strcat(tmp, "dO4"); break;
				default:   strcat(tmp, "Undefiniert"); break;
				}
			}

			if (bit == 0x8000000) break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// AnalogIn pruefen
	strcat(info, "Eingaenge Analog: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.componentInAnalog) {

		for (bit=1;; bit <<= 1) {

			if (bit & hwInfo.componentInAnalog) {

				if (strlen(tmp)) {
					strcat(tmp, ", ");
				}

				switch(bit) { // Analoge Eingaenge
				case 0x01: strcat(tmp, "aI1"); break;
				case 0x02: strcat(tmp, "aI2"); break;
				default:   strcat(tmp, "Undefiniert"); break;
				}
			}

			if (bit == 0x8000000) break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// DigitalIn pruefen
	strcat(info, "Eingaenge Digital: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.componentInDigital) {

		for (bit=1;; bit <<= 1) {

			if (bit & hwInfo.componentInDigital) {

				if (strlen(tmp)) {
					strcat(tmp, ", ");
				}

				switch(bit) { // Digitale Eingaenge
				case 0x01: strcat(tmp, "dI1"); break;
				case 0x02: strcat(tmp, "dI2"); break;
				case 0x04: strcat(tmp, "dI3"); break;
				case 0x08: strcat(tmp, "dI4"); break;
				case 0x10: strcat(tmp, "dI5"); break;
				case 0x20: strcat(tmp, "dI6"); break;
				case 0x40: strcat(tmp, "dI7"); break;
				case 0x80: strcat(tmp, "dI8"); break;
				default:   strcat(tmp, "Undefiniert"); break;
				}
			}

			if (bit == 0x8000000) break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// Fingerprint pruefen
	strcat(info, "Fingerprint: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeFingerprint) {

		switch(hwInfo.typeFingerprint) {
		case IV_VALUE_TYPE_FINGERPRINT_BIOKEY_3000: strcat(tmp, "Ja"); break;
		default:                                    strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);
	
	// DCF77 pruefen
	strcat(info, "Funkuhr: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeDCF77) {

		switch(hwInfo.typeDCF77) {
		case IV_VALUE_TYPE_DCF77_HKW:  strcat(tmp, "Ja"); break;
		default:                       strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// GPS pruefen
	strcat(info, "GPS: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeGPS) {

		switch(hwInfo.typeGPS) {
		case IV_VALUE_TYPE_GPS_GN80: strcat(tmp, "Ja"); break;
		case IV_VALUE_TYPE_GPS_5H:   strcat(tmp, "Ja"); break;
		default:                     strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// MMC pruefen
	strcat(info, "MM Card: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeMMC) {

		switch(hwInfo.typeMMC) {
		case IV_VALUE_TYPE_MMC_EXTENSION: strcat(tmp, "Speichererweiterung"); break;
		case IV_VALUE_TYPE_MMC_DISK:      strcat(tmp, "Wechseldatentrger"); break;
		case IV_VALUE_TYPE_MMC_USB:       strcat(tmp, "USB-Host Wechseldatentrger"); break;
		default:                          strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// Tastatur pruefen
	strcat(info, "Tastatur: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeKeypad) {

		switch(hwInfo.typeKeypad) {
		case IV_VALUE_TYPE_KEYPAD_9:  strcat(tmp, "9 Tasten"); break;
		case IV_VALUE_TYPE_KEYPAD_58: strcat(tmp, "58 Tasten"); break;
		case IV_VALUE_TYPE_KEYPAD_29: strcat(tmp, "29 Tasten"); break;
		case IV_VALUE_TYPE_KEYPAD_7:  strcat(tmp, "7 Tasten"); break;
		case IV_VALUE_TYPE_KEYPAD_25: strcat(tmp, "25 Tasten"); break;
		default:                      strcat(tmp, "Undefiniert"); break;
		}

	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	// Transponder pruefen
	strcat(info, "Transponderleser: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.typeTransponder) {

		switch(hwInfo.typeTransponder) {
		case IV_VALUE_TYPE_TRANSPONDER_TSR30:          strcat(tmp, "[EM4102, Hitag2]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_TSR32:          strcat(tmp, "[EM4102, EM4450, Hitag]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_PRIMO100:       strcat(tmp, "[Legic]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_MIFARE:         strcat(tmp, "[Mifare]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_IBUTTON_EXTERN: strcat(tmp, "[IButton (Extern)]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_SMARTRELAIS:    strcat(tmp, "[SimonsVoss]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_NEDAP:          strcat(tmp, "[Nedap]"); break;
		case IV_VALUE_TYPE_TRANSPONDER_IBUTTON_INTERN: strcat(tmp, "[IButton (Intern)]"); break;
		default:                                       strcat(tmp, "[Undefiniert]"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);
	
	// RS485 (intern) ermitteln
	strcat(info, "Zutrittskontrolle: ");
	memset(tmp, 0, sizeof(tmp));
	if (hwInfo.componentRS485_1) {

		switch(hwInfo.typeExternalReader) {
		case IV_VALUE_TYPE_EXTERNAL_READER_GIS:     strcat(tmp, "TS-Serie"); break;
		case IV_VALUE_TYPE_EXTERNAL_READER_PHG:     strcat(tmp, "PHG-Serie"); break;
		case IV_VALUE_TYPE_EXTERNAL_READER_PROTECT: strcat(tmp, "Protect-Serie"); break;
		case 0xFF:                                  strcat(tmp, "Unbekannt"); break;
		default:                                    strcat(tmp, "Undefiniert"); break;
		}
	} else {
		strcat(tmp, "Nein");
	}
	strcat(tmp, "\r\n");
	strcat(info, tmp);

	return res;
}

//#########################################################
//####################### SYSTEM ##########################
//#########################################################

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::Call(short module, short function, unsigned char *data, int &count)
{
	if (module == IV_MODULE_SYSTEM) {
		
		int res = IV_ERROR_SUCCESS;

		switch(function) {
		// Ermitteln der Firmwareversion
		case IV_FUNCTION_GET_VERSION: return GetVersion(GetDeviceID(), (char*)data);

		// Setzen/Ermitteln von: SerialNum
		case IV_FUNCTION_SET_SERIAL: return SetSerial(GetDeviceID(), *(unsigned long*)data, *(unsigned long*)&data[4]);
		case IV_FUNCTION_GET_SERIAL: return GetSerial(GetDeviceID(), (unsigned long&)data);
	
		// Setzen/Ermitteln von: DateTime (YYYY-MM-DD HH:MM:SS\0)
		case IV_FUNCTION_SET_RTC: return SetRTC(GetDeviceID(), (char*)data);
		case IV_FUNCTION_GET_RTC: return GetRTC(GetDeviceID(), (char*)data);

		// Setzen/Ermitteln von: Variable (Systemvariablen GPRS) 
		case IV_FUNCTION_SET_SYSTEM_VARIABLE: {
			char *name = (char*)data;
			char *value = (char*)&data[strlen(name) + 1];
			return SetSystemVariable(GetDeviceID(), name, value);
											  }
		case IV_FUNCTION_GET_SYSTEM_VARIABLE: {
			char *name = (char*)data;
			char *value = (char*)&data[strlen(name) + 1];
			int res = GetSystemVariable(GetDeviceID(), name, value);
			if (res == IV_ERROR_SUCCESS) {
				count += strlen(value) + 1;
			}
			return res;
											  }

		// Setzen/Ermitteln von: Relaiszustand 
//		case IV_FUNCTION_SET_RELAY: return CallSetRelay(data, count);
//		case IV_FUNCTION_GET_RELAY: return CallGetRelay(data, count);

		// Schreiben/Lesen von: Externen Flash
//		case IV_FUNCTION_SET_FLASH: return CallSetFlash(data, count);
//		case IV_FUNCTION_GET_FLASH: return CallGetFlash(data, count);

		// Schreiben/Lesen von: EEPROM
//		case IV_FUNCTION_SET_EEPROM: return CallSetEEPROM(data, count);
//		case IV_FUNCTION_GET_EEPROM: return CallGetEEPROM(data, count);

		// Schreiben/Lesen von: Program-Flash schreiben/lesen
//		case IV_FUNCTION_SET_PROGRAM: return CallSetProgram(data, count);
//		case IV_FUNCTION_GET_PROGRAM: return CallGetProgram(data, count);

		// Starten/Beenden von: Segmentuebertragung (inklusive aktiver Antwort)
//		case IV_FUNCTION_BEGIN_SET_SEGMENT: return BeginSetSegment();
		case IV_FUNCTION_BEGIN_SET_SEGMENT_OK: return BeginSetSegmentOK(GetDeviceID());
		
//		case IV_FUNCTION_END_SET_SEGMENT: return CallEndSetSegment(data, count);
		case IV_FUNCTION_END_SET_SEGMENT_OK: return EndSetSegmentOK(GetDeviceID());

		// Ermitteln von: Bootloaderversion
		case IV_FUNCTION_GET_VERSION_BOOTLOADER: return GetVersionBootloader(GetDeviceID(), (char*)data);

		// Durchfuehren eines Resets der Speicherbereiche
//		case IV_FUNCTION_SYSTEM_RESET: return CallSystemReset(data, count);

		// Ins Bios wechseln
		case IV_FUNCTION_ENTER_BIOS: return EnterBios(GetDeviceID());
		// Bioswechsel erfolgt
		case IV_FUNCTION_ENTERED_BIOS: return EnteredBios(GetDeviceID());

		// Bios verlassen (aenderungen uebernehmen
		case IV_FUNCTION_EXIT_BIOS: return ExitBios(GetDeviceID());
		// Biosverlassen erfolgt
		case IV_FUNCTION_EXITED_BIOS: return ExitedBios(GetDeviceID());

		// Setzt/liest das zu verwendende Interface
//		case IV_FUNCTION_SET_INTERFACE: return CallSetInterface(data, count);
//		case IV_FUNCTION_GET_INTERFACE: return CallGetInterface(data, count);

		// Setzt/liest die zu verwendende BaudRate
//		case IV_FUNCTION_SET_BAUD: return CallSetBaud(data, count);
//		case IV_FUNCTION_GET_BAUD: return CallGetBaud(data, count);

		// Setzt/liest die zu verwendende DeviceID
//		case IV_FUNCTION_SET_DEVICE_ID: return CallSetDeviceIDBios(data, count);
//		case IV_FUNCTION_GET_DEVICE_ID: return CallGetDeviceIDBios(data, count);

		// Befehl der beim Geraetestart den Bootloader des ZK - Master IV wiederherstellt.
//		case IV_FUNCTION_ENTER_BOOTLOADER: return CallEnterBootloader(data, count);

		// In Monitor Mode von XPort wechselt
//		case IV_FUNCTION_ENTER_XPORT_MONITOR: return CallEnterXPortMonitor(data, count);
		// Antwort in Monitor Mode gewechselt
		case IV_FUNCTION_ENTER_XPORT_MONITOR_OK: return EnterXPortMonitorOK(GetDeviceID());

		// Monitorbefehl an XPort und Antwort erhalten.
//		case IV_FUNCTION_CMD_XPORT: return CallCommandXPort(data, count);

		// In Monitor Mode von XPort wechselt
//		case IV_FUNCTION_EXIT_XPORT_MONITOR: return CallExitXPortMonitor(data, count);
		// Antwort in Monitor Mode gewechselt
		case IV_FUNCTION_EXIT_XPORT_MONITOR_OK: return ExitXPortMonitorOK(GetDeviceID());


//		case IV_FUNCTION_BEGIN_GET_SEGMENT: return CallBeginGetSegment(data, count);
		case IV_FUNCTION_BEGIN_GET_SEGMENT_OK: return BeginGetSegmentOK(GetDeviceID());

//		case IV_FUNCTION_END_GET_SEGMENT: return CallEndGetSegment(data, count);

		case IV_FUNCTION_END_GET_SEGMENT_OK: return EndGetSegmentOK(GetDeviceID());
		case IV_FUNCTION_SYSTEM_RESET_OK: return SystemResetOK(GetDeviceID());
//		case IV_FUNCTION_OPEN_COM_SERVER_MODE:  return OpenComServerMode(GetDeviceID());
//		case IV_FUNCTION_CLOSE_COM_SERVER_MODE: return CloseComServerMode(GetDeviceID()=);
//		case IV_FUNCTION_GET_INFO:
		case IV_FUNCTION_OPEN_COM_SERVER_MODE_OK: return OpenComServerModeOK(GetDeviceID());
//		case IV_FUNCTION_SET_NOTIFY:
//		case IV_FUNCTION_GET_NOTIFY:
//		case IV_FUNCTION_GET_SOFTWARE_INFO:
//		case IV_FUNCTION_GET_FLASH_PAGE:

		default: return 0x0200; // Funktion nicht definiert
		}

	}

	return CChannel4ModuleHardware::Call(module, function, data, count);
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SystemReset(short deviceID, unsigned short modus)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SystemReset [ %i, %i ]\n", __FILE__, __LINE__, deviceID, modus);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		count = sizeof(unsigned short);

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Den Resetmodus uebernehmen.
		*(unsigned short*)m_data = modus;

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM , IV_FUNCTION_SYSTEM_RESET, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SYSTEM_RESET);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SystemReset [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}

		// Aktive Antwort abwarten
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_SYSTEM_RESET_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_SYSTEM_RESET_OK);
			return m_result;
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SYSTEM_RESET, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemReset [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		// Aktive Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SYSTEM_RESET_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemReset [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SystemResetOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SystemResetOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemResetOK\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SYSTEM_RESET_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemResetOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Leited einen zu bertragenden Datenblock ein. Z. B. Listen.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::BeginSetSegment(short deviceID, unsigned short art, unsigned long &address, unsigned long size, unsigned long crc)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginSetSegment [ %i, %i, %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, art, address, size, crc);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Meberpuffer aufbereiten
		*(unsigned short*)m_data = art;
		count = sizeof(unsigned short);

		// addresse wegen wohlgeformtem Paket mitgeben
		*(unsigned long*)&m_data[count] = address;
		count += sizeof(unsigned long);

		// geforderte Speichergroesze mitgeben
		*(unsigned long*)&m_data[count] = size;
		count += sizeof(unsigned long);

		// CRC32 fuer Datenblock mitgeben
		*(unsigned long*)&m_data[count] = crc;
		count += sizeof(unsigned long);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT);
			return m_result;
		}

		// OK
		
		// Ausgeben der empfangenen Werte

		if (count == 14) {

			if (art != *(unsigned short*)m_data) {
				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::BeginSetSegment [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);
			}
			
			address = *(unsigned long*)&m_data[sizeof(unsigned short)];

			if (size != *(unsigned long*)&m_data[sizeof(unsigned short) + sizeof(unsigned long)]) {
				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::BeginSetSegment [ Size ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned long*)&m_data[sizeof(unsigned short) + sizeof(unsigned long)], size);
			}

			if (crc != *(unsigned long*)&m_data[sizeof(unsigned short) + sizeof(unsigned long)*2]) {
				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::BeginSetSegment [ CRC ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned long*)&m_data[sizeof(unsigned short) + sizeof(unsigned long)*2], crc);
			}

			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginSetSegment (0x%04X)(0x%08X)(0x%08X)(0x%08X)\n", __FILE__, __LINE__, art, address, size, crc);
		} else {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}

		// Bei (den einzelnen innenliegenden) Systemstopps,
		// werden die erfolgreich berechneten CRC - Pruefungen zurueckgemeldet.
		if ((art == IV_VALUE_SEGMENT_UPDATE) || (art == IV_VALUE_SEGMENT_UPDATE_BG) ||
			(art == IV_VALUE_SEGMENT_LIST_ACCESS)) {
	/*
			short module, function, error = IV_ERROR_SUCCESS;
			// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
			// dieses muss hier seperat abgegriffen werden.
			if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {

				Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ Quittierungsprfantwort - CRC schlug fehl. ]\n", __FILE__, __LINE__);
				return m_result;
			}

			if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_BEGIN_SET_SEGMENT_OK)) {

				Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginSetSegment [ Antwort von CRC OK. ]\n", __FILE__, __LINE__);
			}

			// evntl. aktiven Fehler auswerten
			if (error != IV_ERROR_SUCCESS) {

				m_result = error;
				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT_OK);
				return m_result;
			}

			if (*(unsigned short*)m_data != art) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::BeginSetSegment [ Die Art der Quittierung ist ungleich. ]\n", __FILE__, __LINE__);
			} 
			
			if (count > sizeof(unsigned short)) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::BeginSetSegment [ Datenmenge ist mit (%i) grsser als erwartet. ]\n", __FILE__, __LINE__, count);
			}
	*/
			if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

				Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ Quittierungsprfantwort - CRC schlug fehl. ]\n", __FILE__, __LINE__);
				return m_result;
			}

			if (*(unsigned short*)m_data != art) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::BeginSetSegment [ Die Art der Quittierung ist ungleich. ]\n", __FILE__, __LINE__);
			} 
		}
	} else {

		unsigned char tmp[16];
		count = 0;

		// Adresse wird gesetzt, rest bleibt gleich
		// Meberpuffer aufbereiten
		*(unsigned short*)tmp = art;
		count = sizeof(unsigned short);

		// addresse wegen wohlgeformtem Paket mitgeben
		*(unsigned long*)&tmp[count] = 0;
		count += sizeof(unsigned long);

		// geforderte Speichergroesze mitgeben
		*(unsigned long*)&tmp[count] = size;
		count += sizeof(unsigned long);

		// CRC32 fuer Datenblock mitgeben
		*(unsigned long*)&tmp[count] = crc;
		count += sizeof(unsigned long);
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem:: [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		count = 0;
		// Aktive Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem:: [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::BeginSetSegmentOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginSetSegmentOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegmentOK\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegmentOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EndSetSegment(short deviceID, unsigned short art, unsigned long crc)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EndSetSegment [ %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, art, crc);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		count = sizeof(unsigned short);
		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Meberpuffer aufbereiten
		*(unsigned short*)m_data = art;

		// Beendigung einer Uebertragung eines Datanblocks
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT);
			return m_result;
		}

		// OK
		if (art != *(unsigned short*)m_data) {
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);
		}
		
		// Bei (den einzelnen innenliegenden) Systemstopps,
		// werden die erfolgreich berechneten CRC - Pruefungen zurueckgemeldet.
	/*	
		short module, function, error = IV_ERROR_SUCCESS;
		// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
		// dieses musz hier seperat abgegriffen werden.
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ Quittierungsprfantwort - CRC schlug fehl (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_END_SET_SEGMENT_OK)) {
			
			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginSetSegment [ Antwort von CRC OK ]\n", __FILE__, __LINE__);
		}

		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT_OK);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT_OK);
			return m_result;
		}

		if (*(unsigned short*)m_data != art) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);
		} else if (*(unsigned long*)&m_data[sizeof(unsigned short)] != crc) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginSetSegment [ CRC ist (0x%08X) soll (0x%08X) ]\n", __FILE__, __LINE__, *(unsigned long*)&m_data[sizeof(unsigned short)], crc);
			return -IV_ERROR_CRC_SEGMENT;
		}	
	
	} else {

		unsigned char tmp[4];
		count = sizeof(unsigned short);

		// Meberpuffer aufbereiten
		*(unsigned short*)tmp = art;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem:: [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		// Aktive Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem:: [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}

	
	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EndSetSegmentOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EndSetSegmentOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		count = sizeof(unsigned short);
		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);
	
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT_OK, m_data, count)) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT_OK);
			return m_result;
		}

	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_END_SET_SEGMENT_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EndSetSegmentOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Leited einen zu bertragenden Datenblock ein. Z. B. Listen.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::BeginGetSegment(short deviceID, unsigned short art, unsigned long &address, unsigned long &size, unsigned long &crc)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginGetSegment [ %i, %i, %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, art, address, size, crc);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		count = sizeof(unsigned short);

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Meberpuffer aufbereiten
		*(unsigned short*)m_data = art;

		// addresse wegen wohlgeformtem Paket mitgeben
		*(unsigned long*)&m_data[sizeof(unsigned short)] = address;
		count += sizeof(unsigned long);

		// geforderte Speichergroesze mitgeben
		*(unsigned long*)&m_data[sizeof(unsigned short) + sizeof(unsigned long)] = size;
		count += sizeof(unsigned long);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_GET_SEGMENT, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_GET_SEGMENT);
			return m_result;
		}

		// OK
		
		// Ausgeben der empfangenen Werte

		if (count == 10) {

			if (art != *(unsigned short*)m_data) {
				Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegment [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);
			}
			
			address = *(unsigned long*)&m_data[sizeof(unsigned short)];
			size    = *(unsigned long*)&m_data[sizeof(unsigned short) + sizeof(unsigned long)];

			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginGetSegment [ (0x%04X)(0x%08X)(0x%08X) ]\n", __FILE__, __LINE__, art, address, size);
		} else {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegment [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}
	/*
		short module, function, error = IV_ERROR_SUCCESS;
		// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
		// dieses musz hier seperat abgegriffen werden.
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegment.Pending [ Quittierungsprfantwort - CRC schlug fehl (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_BEGIN_SET_SEGMENT_OK)) {

			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginGetSegment.Pending [ Antwort von CRC OK ]\n", __FILE__, __LINE__);
		}

		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_SET_SEGMENT_OK);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_GET_SEGMENT_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_GET_SEGMENT_OK);
			return m_result;
		}

		if (count == (sizeof(unsigned short) + sizeof(unsigned long))) {

			if (*(unsigned short*)m_data != art) {

				Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegment.Pending [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);

			}
			
			// CRC uebernehmen
			crc = *(unsigned long*)&m_data[sizeof(unsigned short)];

		} else {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegment.Pending [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}	
	
	} else {

		unsigned char tmp[4];
		count = sizeof(unsigned short);

		// Adresse und Size werden zurueckgegeben.

		// Meberpuffer aufbereiten
		*(unsigned short*)tmp = art;

		// addresse wegen wohlgeformtem Paket mitgeben
		*(unsigned long*)&tmp[sizeof(unsigned short)] = address;
		count += sizeof(unsigned long);

		// geforderte Speichergroesze mitgeben
		*(unsigned long*)&tmp[sizeof(unsigned short) + sizeof(unsigned long)] = size;
		count += sizeof(unsigned long);
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_GET_SEGMENT, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegment [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	
	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::BeginGetSegmentOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::BeginGetSegmentOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegmentOK\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_BEGIN_GET_SEGMENT_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::BeginGetSegmentOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EndGetSegment(short deviceID, unsigned short art)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EndGetSegment [ %i, %i ]\n", __FILE__, __LINE__, deviceID, art);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		count = sizeof(unsigned short);

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Meberpuffer aufbereiten
		*(unsigned short*)m_data = art;

		// Beendigung einer Uebertragung eines Datanblocks
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT);
			return m_result;
		}

		// OK
		if (art != *(unsigned short*)m_data) {
			Trace("%s(%i):ERROR: BeginSetSegment [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);
		}
		
		// Bei (den einzelnen innenliegenden) Systemstopps,
		// werden die erfolgreich berechneten CRC - Pruefungen zurueckgemeldet.
	/*
		short module, function, error = IV_ERROR_SUCCESS;
		// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
		// dieses musz hier seperat abgegriffen werden.
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR: EndGetSegment.Pending [ Quittierungsprfantwort - CRC schlug fehl (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_END_GET_SEGMENT_OK)) {
			
			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EndGetSegment.Pending [ Antwort von CRC OK ]\n", __FILE__, __LINE__);
		}
		
		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT_OK);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT_OK);
			return m_result;
		}

		if (*(unsigned short*)m_data != art) {
			
			Trace("%s(%i):ERROR: EndGetSegment.Pending [ Art ist (%i) soll (%i) ]\n", __FILE__, __LINE__, *(unsigned short*)m_data, art);
		}

		if (count != sizeof(unsigned short)) {
		
			Trace("%s(%i):ERROR: EndGetSegment.Pending [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = sizeof(unsigned short);

		// Meberpuffer aufbereiten
		*(unsigned short*)m_data = art;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EndGetSegment [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	
	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EndGetSegmentOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EndGetSegmentOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EndGetSegmentOK\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_END_GET_SEGMENT_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EndGetSegmentOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// Wegen Bootloader nicht vergroesserbar!!
#define IV_FLASH_SIZE_DATA      512

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetFlash(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetFlash [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_FLASH_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_FLASH_SIZE_DATA) > count) ? count - addressOffset : IV_FLASH_SIZE_DATA;

			// Memberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Zu setzende Daten uebernehmen
			for (i=0; i < sizeData; i++) {

				m_data[sizeof(unsigned long) + i] = buf[addressOffset + i];
			}

			// Variable aufbereiten
			sizeData += sizeof(unsigned long);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_FLASH, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_FLASH);
				return m_result;
			}

			// Keine Antwortdaten erwartet
			if (sizeData) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetFlash [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, sizeData);
			}
			
			//Trace("%s(%i):Address: 0x%08X, wrote: 0x%04X Byte\n", __FILE__, __LINE__, *(unsigned long*)m_data, *(unsigned short*)&m_data[sizeof(unsigned long)]);
			/*if (m_callBack1) {
				if (!m_callBack1()) {
					
					m_result = -IV_ERROR_BREAK;
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);
					
					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetFlash ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
				}
			} else*/ if (m_callBack2) {
				if (!m_callBack2(count, addressOffset + sizeData)) {
					
					m_result = -IV_ERROR_BREAK;
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);
					
					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetFlash ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
					break;
				}
			}
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_FLASH, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetFlash [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetFlash(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetFlash [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_FLASH_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_FLASH_SIZE_DATA) > count) ? count - addressOffset : IV_FLASH_SIZE_DATA;

			// Meberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Angeforderte Laenge eintragen
			*(unsigned short*)&m_data[sizeof(unsigned long)] = sizeData;

			// Variable aufbereiten
			sizeData = sizeof(unsigned long) + sizeof(unsigned short);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_FLASH, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_FLASH);
				return m_result;
			}

			// OK
			
			// Empfangene Daten uebernehmen
			for (i=0; i < (sizeData - (signed)sizeof(unsigned long)); i++) {
				
				buf[addressOffset + i] = m_data[sizeof(unsigned long) + i];
			}
			
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_FLASH, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetFlash [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

#define IV_EEPROM_SIZE_DATA   256

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetEEPROM(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetEEPROM [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_EEPROM_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_EEPROM_SIZE_DATA) > count) ? count - addressOffset : IV_EEPROM_SIZE_DATA;

			// Memberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Zu setzende Daten uebernehmen
			for (i=0; i < sizeData; i++) {

				m_data[sizeof(unsigned long) + i] = buf[addressOffset + i];
			}

			// Variable aufbereiten
			sizeData += sizeof(unsigned long);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_EEPROM, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_EEPROM);
				return m_result;
			}

			// Keine Antwortdaten erwartet
			if (sizeData) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetEEPROM [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, sizeData);
			}
			
			//Trace("%s(%i):Address: 0x%08X, wrote: 0x%04X Byte\n", __FILE__, __LINE__, *(unsigned long*)m_data, *(unsigned short*)&m_data[sizeof(unsigned long)]);
			/*if (m_callBack1) {
				if (!m_callBack1()) {
					
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);
					
					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetEEPROM ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
				}
			} else*/ if (m_callBack2) {
				if (!m_callBack2(count, addressOffset + sizeData)) {
					
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);
					
					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetEEPROM ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
				}
			}
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_EEPROM, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetEEPROM [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetEEPROM(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetEEPROM [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_EEPROM_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_EEPROM_SIZE_DATA) > count) ? count - addressOffset : IV_EEPROM_SIZE_DATA;

			// Meberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Angeforderte Laenge eintragen
			*(unsigned short*)&m_data[sizeof(unsigned long)] = sizeData;

			// Variable aufbereiten
			sizeData = sizeof(unsigned long) + sizeof(unsigned short);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_EEPROM, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_EEPROM);
				return m_result;
			}

			// OK
			
			// Empfangene Daten uebernehmen
			for (i=0; i < (sizeData - (signed)sizeof(unsigned long)); i++) {
				
				buf[addressOffset + i] = m_data[sizeof(unsigned long) + i];
			}
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_EEPROM, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetEEPROM [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}


#define IV_RAM_SIZE_DATA   256

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetRAM(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetRAM [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_RAM_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_RAM_SIZE_DATA) > count) ? count - addressOffset : IV_RAM_SIZE_DATA;

			// Memberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Zu setzende Daten uebernehmen
			for (i=0; i < sizeData; i++) {

				m_data[sizeof(unsigned long) + i] = buf[addressOffset + i];
			}

			// Variable aufbereiten
			sizeData += sizeof(unsigned long);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RAM, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RAM);
				return m_result;
			}

			// Keine Antwortdaten erwartet
			if (sizeData) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetRAM [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, sizeData);
			}
			
			//Trace("%s(%i):Address: 0x%08X, wrote: 0x%04X Byte\n", __FILE__, __LINE__, *(unsigned long*)m_data, *(unsigned short*)&m_data[sizeof(unsigned long)]);
			/*if (m_callBack1) {
				if (!m_callBack1()) {
					
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);
					
					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetRAM ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
				}
			} else*/ if (m_callBack2) {
				if (!m_callBack2(count, addressOffset + sizeData)) {
					
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);
					
					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetRAM ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
				}
			}
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RAM, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetRAM [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetRAM(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetRAM [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_EEPROM_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_EEPROM_SIZE_DATA) > count) ? count - addressOffset : IV_RAM_SIZE_DATA;

			// Meberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Angeforderte Laenge eintragen
			*(unsigned short*)&m_data[sizeof(unsigned long)] = sizeData;

			// Variable aufbereiten
			sizeData = sizeof(unsigned long) + sizeof(unsigned short);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RAM, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RAM);
				return m_result;
			}

			// OK
			
			// Empfangene Daten uebernehmen
			for (i=0; i < (sizeData - (signed)sizeof(unsigned long)); i++) {
				
				buf[addressOffset + i] = m_data[sizeof(unsigned long) + i];
			}
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RAM, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetRAM [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetFlashPage(short deviceID, unsigned short pageNum, unsigned char *buf, int &count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetFlashPage [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, pageNum, buf, count);

	int i;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		// Meberpuffer aufbereiten
		*(unsigned short*)m_data = pageNum;
		// Offset in die Seite
		*(unsigned short*)&m_data[sizeof(unsigned short)] = 0;
		// Angeforderte Laenge eintragen
		*(unsigned short*)&m_data[sizeof(unsigned short) * 2] = 528;

		// Variable aufbereiten
		count = sizeof(unsigned short) * 3;

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_FLASH_PAGE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_FLASH_PAGE);
			return m_result;
		}

		// OK
		if (count != 532) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetFlashPage [ Antwort ist ungleich 532. ]\n", __FILE__, __LINE__);
		}
		
		// Empfangene Daten uebernehmen
		for (i=0; i < (count - (signed)(sizeof(unsigned short) * 2)); i++) {
			
			buf[i] = m_data[sizeof(unsigned short) * 2 + i];
		}
		count -= sizeof(unsigned short) * 2;
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_FLASH_PAGE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetFlashPage [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// Groesse fuer Datenblock
#define IV_MMC_SIZE_DATA      512

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::SetMMC(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetMMC [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_MMC_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_MMC_SIZE_DATA) > count) ? count - addressOffset : IV_MMC_SIZE_DATA;

			// Memberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Zu setzende Daten uebernehmen
			for (i=0; i < sizeData; i++) {

				m_data[sizeof(unsigned long) + i] = buf[addressOffset + i];
			}

			// Variable aufbereiten
			sizeData += sizeof(unsigned long);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_MMC, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_MMC);
				return m_result;
			}

			// Keine Antwortdaten erwartet
			if (sizeData) {

				Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetMMC [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, sizeData);
			}

			//Trace("%s(%i):Address: 0x%08X, wrote: 0x%04X Byte\n", __FILE__, __LINE__, *(unsigned long*)m_data, *(unsigned short*)&m_data[sizeof(unsigned long)]);
			/*if (m_callBack1) {
			if (!m_callBack1()) {

			m_result = -IV_ERROR_BREAK;
			// Fehlernummern setzen
			m_errorCommunicationNum = IV_ERROR_BREAK;
			// Fehlertext ermitteln und eintragen.
			GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetFlash ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
			}
			} else*/ if (m_callBack2) {
				if (!m_callBack2(count, addressOffset + sizeData)) {

					m_result = -IV_ERROR_BREAK;
					// Fehlernummern setzen
					m_errorCommunicationNum = IV_ERROR_BREAK;
					// Fehlertext ermitteln und eintragen.
					GetErrorCommunication(m_errorCommunicationNum, m_errorCommunication);

					Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetMMC ( %04X )[%s]\n", __FILE__, __LINE__, -m_result & 0xFFFF, m_errorCommunication);
					break;
				}
			}
		}	

	} else {

		unsigned char tmp[4];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_MMC, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetMMC [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

	}


	return m_result;
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::GetMMC(short deviceID, unsigned long address, unsigned char *buf, int count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetMMC [ %i, %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, address, buf, count);

	int addressOffset;
	int i, sizeData;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Gesamten Datenblock aufteilen
		for (addressOffset=0; addressOffset < count; addressOffset += IV_MMC_SIZE_DATA) {

			// Datengroesze 
			sizeData = ((addressOffset + IV_MMC_SIZE_DATA) > count) ? count - addressOffset : IV_MMC_SIZE_DATA;

			// Meberpuffer aufbereiten
			*(unsigned long*)m_data = address + addressOffset;
			// Angeforderte Laenge eintragen
			*(unsigned short*)&m_data[sizeof(unsigned long)] = sizeData;

			// Variable aufbereiten
			sizeData = sizeof(unsigned long) + sizeof(unsigned short);

			if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_MMC, m_data, sizeData)) != IV_ERROR_SUCCESS) {

				// Fehler ausgeben
				TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_MMC);
				return m_result;
			}

			// OK

			// Empfangene Daten uebernehmen
			for (i=0; i < (sizeData - (signed)sizeof(unsigned long)); i++) {

				buf[addressOffset + i] = m_data[sizeof(unsigned long) + i];
			}

		}
	} else {

		unsigned char tmp[4];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_MMC, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetMMC [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

	}


	return m_result;
}

// ##################################################################
/**
* @brief Ermittelt die Struktur zum SFS.
*
* @param deviceID Anzusprechende Geraetenummer.
* @param serial Variable die die ermittelte Seriennummer erhaehlt.
*/
int CChannel4ModuleSystem::GetSFSMPB(short deviceID, unsigned char &type, SFSMPB &sfs)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetSFSMPB [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {
		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SFSMPB, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SFSMPB);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count != (sizeof(unsigned char) + sizeof(SFSMPB))) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetSFSMPB [ SFS ungleich der erwarteten Gre ]\n", __FILE__, __LINE__);
			type = 0;
			memset(&sfs, 0, sizeof(SFSMPB));
		} else {

			type = *m_data;
			sfs = *(SFSMPB*)&m_data[1];
		}
	} else {

		unsigned char tmp[64];
		count = sizeof(unsigned char) + sizeof(SFSMPB);
		memset(tmp, 0, sizeof(tmp));

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SFSMPB, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetSFSMPB [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}
	return m_result;
}

// ##################################################################
/**
 * @brief Ermittelt die Firmwareversion.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param version Zeiger Variable fuer den Versionsstring.
 *                Format: XX.XX.XX.XX ?...
 */
int CChannel4ModuleSystem::GetVersion(short deviceID, char *version)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetVersion [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, version);

	int i, count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {
		
		// Umgebung zuruecksetzen
		Reset();
		
		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);
		
		
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_VERSION, m_data, count)) != IV_ERROR_SUCCESS) {
			
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_VERSION);
			return m_result;
		}
		
		// OK
		for (i=0; i < count; i++) {
			
			version[i] = m_data[i];
		}
	} else {

		unsigned char tmp[64];
		count = sprintf((char*)tmp, "04.01.05.00.DLL") + 1;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_VERSION, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetVersion [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Ermittelt die Bootloaderversion.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param version Zeiger auf Variable fuer Versionsstring. 
 *                Format: XX.XX.XX.XX ?...
 */
int CChannel4ModuleSystem::GetVersionBootloader(short deviceID, char *version)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetVersionBootloader [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, version);

	int i, count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_VERSION_BOOTLOADER, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_VERSION_BOOTLOADER);
			return m_result;
		}

		// OK
		for (i=0; i < count; i++) {

			version[i] = m_data[i];
		}
	} else {

		unsigned char tmp[64];
		count = sprintf((char*)tmp, "04.01.04.99") + 1;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_VERSION_BOOTLOADER, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1):CChannel4ModuleSystem::GetVersionBootloader [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Ermittelt die Seriennummer des Geraets.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param serial Variable die die ermittelte Seriennummer erhaehlt.
 */
int CChannel4ModuleSystem::GetSerial(short deviceID, unsigned long &serial)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetSerial [ %i, %i ]\n", __FILE__, __LINE__, deviceID, serial);

	int count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {
		// Umgebung zuruecksetzen
		Reset();
		
		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);
		
		
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SERIAL, m_data, count)) != IV_ERROR_SUCCESS) {
			
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SERIAL);
			return m_result;
		}
		
		// Keine Antwortdaten erwartet
		if (count > sizeof(unsigned long)) {
			
			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetSerial [ Seriennummer mit %i Byte, laenger als erwartete 32bit ]\n", __FILE__, __LINE__, count - 4);
		}
		
		serial = *(unsigned long*)m_data;
	} else {
		
		unsigned char tmp[64];
		count = sizeof(unsigned long);
		*(unsigned long*)tmp = m_serial;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SERIAL, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetSerial [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}
	return m_result;
}

// ##################################################################
/**
 * @brief Setzten der RTC (RealTimeClock) im Geraet.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param time Zeitstring im Format: "JJJJ-MM-DD hh:mm:ss"
 */
int CChannel4ModuleSystem::SetRTC(short deviceID, char *time)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetRTC [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, time);

	int i, count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		count = 20;
		// Puffer loeschen
		memset(m_data, 0, sizeof(m_data));
		for (i=0; i < (count - 1); i++) {

			m_data[i] = time[i];
		}

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RTC, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RTC);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetRTC [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RTC, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetRTC [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Lesen der RTC (RealTimeClock) aus Geraet.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param time Zeiger auf Zeichenkette fuer Zeitstring. 
 *             Format: "JJJJ-MM-DD hh:mm:ss"
 */
int CChannel4ModuleSystem::GetRTC(short deviceID, char *time)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetRTC [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, time);

	int i, count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RTC, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RTC);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count > 20) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetRTC [ Uhrzeitstring ist mit %i Byte laenger als erwartet. ]\n", __FILE__, __LINE__, count - 20);
		}

		// OK
		for (i=0; i < count; i++) {

			time[i] = m_data[i];
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RTC, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetRTC [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

unsigned char CChannel4ModuleSystem::HexToUINT8(char *data)
{
	int i;
	unsigned char val = 0;

	for (i=0; i < 2; i++) {

		val = (val << 4);

		if (data[i] >= '0' && data[i] <= '9') {

			val += data[i] - '0';

		} else if (data[i] >= 'a' && data[i] <='f') {

			val += data[i] - 'a' + 10;

		} else {

			val += data[i] - 'A' + 10;
		}
	}

	return val;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetSystemVariable(short deviceID, char *name, char *value)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetSystemVariable [ %i, 0x%08X, 0x%08X ]\n", __FILE__, __LINE__, deviceID, name, value);

	int i, j, count = 0;
	char lName[100];
	char lValue[100];
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		// Wert fr ggf. Anpassungen bernehmen
		memset(lValue, 0, sizeof(lValue));
		strcpy(lValue, value);
		// Name fr Vergleich bernehmen
		memset(lName, 0, sizeof(lName));
		strcpy(lName, name);
		for (i=0; i < (int)strlen(lName); i++)
		{
			lName[i] = (char)toupper(lName[i]);
		}
		if ((strstr(lName, "MOBILE") == lName || strstr(lName, "_MODEM_MC35I") == lName) && strstr(lName, "HTTPSEND") == NULL)
		{
			unsigned char type = 0;
			char version[64];
			if ((m_result = GetTypeModemMC(deviceID, type)) != IV_ERROR_SUCCESS)
			{
				return m_result;
			}
			if (type == IV_VALUE_TYPE_MODEM_MC_55)
			{
				memset(version, 0, sizeof(version));
				if ((m_result = GetVersion(deviceID, version)) != IV_ERROR_SUCCESS)
				{
					return m_result;
				}
				// Format prfen
				if (isxdigit(version[0]) &&
					isxdigit(version[1]) &&
					version[2] == '.' &&
					isxdigit(version[3]) &&
					isxdigit(version[4]) &&
					version[5] == '.' && 
					isxdigit(version[6]) &&
					isxdigit(version[7]) &&
					version[8] == '.' &&
					isxdigit(version[9]) &&
					isxdigit(version[10]) &&
					version[11] == '.')
				{
					unsigned long ver = (HexToUINT8(version) << 24);
					ver += (HexToUINT8(&version[3]) << 16);
					ver += (HexToUINT8(&version[6]) << 8);
					ver += HexToUINT8(&version[9]);

					if (ver >= 0x04010600)
					{
						MobileMaskedSysvar(lValue);
					}
				}
			}
		}

		// Puffer loeschen
		memset(m_data, 0, sizeof(m_data));
		// Namen uebernehmen
		count = strlen(name) + 1;
		for (i=0; i < count; i++) {

			m_data[i] = name[i];
		}
		// Wert uebernehmen
		count += strlen(lValue) + 1;
		for (j=i; i < count; i++) {

			m_data[i] = lValue[i - j];
		}

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYSTEM_VARIABLE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYSTEM_VARIABLE);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetSystemVariable [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYSTEM_VARIABLE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetSystemVariable [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetSystemVariable(short deviceID, char *name, char *value)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetSystemVariable [ %i, 0x%08X, 0x%08X ]\n", __FILE__, __LINE__, deviceID, name, value);

	int i, count = 0;
	char lName[100];
	char lValue[520]; // Gre aufgrund von SYSTEM.STATUS ntig.
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Puffer loeschen
		memset(m_data, 0, sizeof(m_data));
		// Namen uebernehmen
		count = strlen(name) + 1;
		for (i=0; i < count; i++) {

			m_data[i] = name[i];
		}

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYSTEM_VARIABLE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYSTEM_VARIABLE);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count > 80) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetSystemVariable [ Laenge der Variablen mit %i Byte ist fragwuerdig ]\n", __FILE__, __LINE__, count);
		}

		// Namen uebergehen
		count = strlen(name) + 1;

		// Wert fr ggf. Anpassungen bernehmen
		memset(lValue, 0, sizeof(lValue));

		// Wert uebernehmen
		strcpy(lValue, (char*)&m_data[count]);	
	
		// Name fr Vergleich bernehmen
		memset(lName, 0, sizeof(lName));
		strcpy(lName, name);
		for (i=0; i < (int)strlen(lName); i++)
		{
			lName[i] = (char)toupper(lName[i]);
		}
		if ((strstr(lName, "MOBILE") == lName || strstr(lName, "_MODEM_MC35I") == lName) && strstr(lName, "HTTPSEND") == NULL)
		{
			MobileUnmaskedSysvar(lValue);
		}

		// Wert uebernehmen
		strcpy(value, lValue);	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYSTEM_VARIABLE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetSystemVariable [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetRelay(short deviceID, char *name, unsigned char busNum, unsigned char relayNum, unsigned char status, unsigned short time)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetRelay [ %i, 0x%08X, %i, %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, name, busNum, relayNum, status, time);

	int count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Parameter uebernehmen
		count = sprintf((char*)m_data, "%s", name) + 1;

		// Weitere Parameter als String uebergehen
		count += sprintf((char*)&m_data[count], "%i", busNum) + 1;
		count += sprintf((char*)&m_data[count], "%i", relayNum) + 1;
		count += sprintf((char*)&m_data[count], "%i", status) + 1;
		count += sprintf((char*)&m_data[count], "%i", time) + 1;
	/*
		// Busnummer
		m_data[count] = busNum;
		count += sizeof(unsigned char);

		// Relaisnummer
		m_data[count] = relayNum;
		count += sizeof(unsigned char);

		// Status
		m_data[count] = status;
		count += sizeof(unsigned char);

		// Time
		*(unsigned short*)&m_data[count] = status;
		count += sizeof(unsigned short);
	*/

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RELAY, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RELAY);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetRelay [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_RELAY, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetRelay [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetRelay(short deviceID, char *name, unsigned char busNum, unsigned char relayNum, unsigned char &status, unsigned short &time)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetRelay [ %i, 0x%08X, %i, %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, name, busNum, relayNum, status, time);

	int count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Namen uebernehmen
		count = sprintf((char*)m_data, "%s", name) + 1;

		// Weitere Parameter als String uebernehmen
		count += sprintf((char*)&m_data[count], "%i", busNum) + 1;
		count += sprintf((char*)&m_data[count], "%i", relayNum) + 1;
	/*
		// Busnummer
		m_data[count] = busNum;
		count += sizeof(unsigned char);

		// Relaisnummer
		m_data[count] = relayNum;
		count += sizeof(unsigned char);
	*/	
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RELAY, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RELAY);
			return m_result;
		}

		// Name
		count = strlen((char*)m_data) + 1;

		// Weitere Parameter als String uebergehen
		// busNum, relayNum
		count += strlen((char*)&m_data[count]) + 1;
		count += strlen((char*)&m_data[count]) + 1;

		// Status uebernehmen
		status = atoi((char*)&m_data[count]);
		count += strlen((char*)&m_data[count]) + 1;

		// Zeit uebernehmen
		time = atoi((char*)&m_data[count]);
	/*
		// Keine Antwortdaten erwartet
		if (count != (sizeof(unsigned char) + sizeof(unsigned short))) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetRelay [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}

		// Status
		status = m_data[0];
		// Time
		time = *(unsigned short*)&m_data[sizeof(unsigned char)];
	*/	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_RELAY, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetRelay [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EnterBios(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterBios [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_BIOS, m_data, count, 1)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_BIOS);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::EnterBios [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	/*	
		// Nach dem Wechsel ins Bios wird eine Bestaetigung gesendet.
		short module, function, error = IV_ERROR_SUCCESS;
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):Quittierungsantwort - schlug fehl.\n", __FILE__, __LINE__);
			return m_result;
		}
		
		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_ENTERED_BIOS)) {
			
			Trace("%s(%i):Antwort OK.\n", __FILE__, __LINE__);
		}
		
		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTERED_BIOS);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_ENTERED_BIOS, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_ENTERED_BIOS);
			return m_result;
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_BIOS, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterBios [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EnteredBios(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnteredBios [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnteredBios\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTERED_BIOS, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnteredBios [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::ExitBios(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::ExitBios [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Beendigung einer Uebertragung eines Datanblocks
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_BIOS, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_BIOS);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::ExitBios [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}

	/*	
		// Nach dem Verlassen des Bios kommt eine Bestaetigungsanfrage.
		short module, function, error = IV_ERROR_SUCCESS;
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitBios [ Quittierungsantwort - schlug fehl (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_EXITED_BIOS)) {
			
			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::ExitBios [ Antwort OK ]\n", __FILE__, __LINE__);
		}
		
		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_EXITED_BIOS);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_EXITED_BIOS, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_EXITED_BIOS);
			return m_result;
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_BIOS, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitBios [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::ExitedBios(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::ExitedBios [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitedBios\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_EXITED_BIOS, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitedBios [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetInterface(short deviceID, unsigned char type)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetInterface [ %i, %i ]\n", __FILE__, __LINE__, deviceID, type);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Den Geraetetyp uebernehmen.
		m_data[0] = type;
		count += sizeof(unsigned char);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_INTERFACE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_INTERFACE);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetInterface [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_INTERFACE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetInterface [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetInterface(short deviceID, unsigned char &type)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetInterface [ %i, %i ]\n", __FILE__, __LINE__, deviceID, type);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_INTERFACE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_INTERFACE);
			return m_result;
		}

		// OK
		if (count != sizeof(unsigned char)) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetInterface [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}

		type = (m_data[0] != 0xFF) ? m_data[0] : 0;
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_INTERFACE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetInterface [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetBaud(short deviceID, unsigned long br)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetBaud [ %i, %i ]\n", __FILE__, __LINE__, deviceID, br);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Den Geraetetyp uebernehmen.
		*(unsigned long*)&m_data[0] = br;
		count += sizeof(unsigned long);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_BAUD, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_BAUD);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetBaud [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_BAUD, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetBaud [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetBaud(short deviceID, unsigned long &br)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetBaud [ %i, %i ]\n", __FILE__, __LINE__, deviceID, br);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_BAUD, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_BAUD);
			return m_result;
		}

		// OK
		if (count != sizeof(unsigned long)) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetBaud [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}

		br = *(unsigned long*)m_data;
		switch(br) { // Bereich pruefen
		case 9600:
		case 14400:
		case 19200:
		case 38400:
		case 57600:
		case 115200:
			break;
		default:
			br = 38400;
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_BAUD, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetBaud [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::SetDeviceIDBios(short deviceID, unsigned short id)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetDeviceIDBios [ %i, %i ]\n", __FILE__, __LINE__, deviceID, id);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Den Geraetetyp uebernehmen.
		*(unsigned short*)&m_data[0] = id;
		count += sizeof(unsigned short);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_DEVICE_ID, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_DEVICE_ID);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetDeviceIDBios [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_DEVICE_ID, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetDeviceIDBios [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::GetDeviceIDBios(short deviceID, unsigned short &id)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetDeviceIDBios [ %i, %i ]\n", __FILE__, __LINE__, deviceID, id);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_DEVICE_ID, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_DEVICE_ID);
			return m_result;
		}

		// OK
		if (count != sizeof(unsigned short)) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetDeviceIDBios [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}

		id = *(unsigned short*)m_data;
		if (!((id >= 1 && id <= 31) && id != 254)) {

			id = 254;
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_DEVICE_ID, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetDeviceIDBios [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EnterBootloader(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterBootloader [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_BOOTLOADER, m_data, count, 1)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_BOOTLOADER);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::EnterBootloader [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_BOOTLOADER, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterBootloader [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EnterXPortMonitor(short deviceID, char *data)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterXPortMonitor [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, data);

	int count = 0, i;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::EnterXPortMonitor [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
		
		// Bei (den einzelnen innenliegenden) Systemstopps,
		// werden die erfolgreich berechneten CRC - Pruefungen zurueckgemeldet.
	/*
		short module, function, error = IV_ERROR_SUCCESS;
		// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
		// dieses musz hier seperat abgegriffen werden.
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitor [ Quittierungsprfantwort - CRC schlug fehl ]\n", __FILE__, __LINE__);
			return m_result;
		}
		
		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_ENTER_XPORT_MONITOR_OK)) {
			
			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterXPortMonitor [ Antwort von CRC OK ]\n", __FILE__, __LINE__);
		}
		
		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_OK);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_OK);
			return m_result;
		}

		// Daten uebernehmen
		for (i=0; i < count; i++) {
			
			data[i] = m_data[i];
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitor [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	
	return m_result;
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::EnterXPortMonitorExt(short deviceID, char *data)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterXPortMonitorExt [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, data);

	int count = 0, i;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_EXT, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_EXT);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::EnterXPortMonitorExt [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}

		// Bei (den einzelnen innenliegenden) Systemstopps,
		// werden die erfolgreich berechneten CRC - Pruefungen zurueckgemeldet.
		/*
		short module, function, error = IV_ERROR_SUCCESS;
		// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
		// dieses musz hier seperat abgegriffen werden.
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitor [ Quittierungsprfantwort - CRC schlug fehl ]\n", __FILE__, __LINE__);
		return m_result;
		}

		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_ENTER_XPORT_MONITOR_OK)) {

		Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterXPortMonitor [ Antwort von CRC OK ]\n", __FILE__, __LINE__);
		}

		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

		m_result = error;
		// Fehler ausgeben
		TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_OK);
		return m_result;
		}
		*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_EXT_OK, m_data, count, (IV_PENDING_TIMEOUT/* / GetTimeout()*/))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_EXT_OK);
			return m_result;
		}

		// Daten uebernehmen
		for (i=0; i < count; i++) {

			data[i] = m_data[i];
		}	

	} else {

		unsigned char tmp[4];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_EXT, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitorExt [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

	}


	return m_result;
}


// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::EnterXPortMonitorOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterXPortMonitorOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitorOK\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitorOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::EnterXPortMonitorExtOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::EnterXPortMonitorExtOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitorExtOK\n", __FILE__, __LINE__);

	} else {

		unsigned char tmp[4];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_ENTER_XPORT_MONITOR_EXT_OK, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::EnterXPortMonitorExtOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::CommandXPort(short deviceID, char *buf, int &count)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::CommandXPort [ %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, buf, count);

	int i;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Daten fuer senden uebernehmen
		for (i=0; i < count; i++) {

			m_data[i] = buf[i];
		}

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_CMD_XPORT, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_CMD_XPORT);
			return m_result;
		}

		// OK

		// Daten von XPort uebernehmen
		for (i=0; i < count; i++) {

			buf[i] = m_data[i];
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_CMD_XPORT, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::CommandXPort [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::ExitXPortMonitor(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::ExitXPortMonitor [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		// Beendigung einer Uebertragung eines Datanblocks
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::ExitXPortMonitor [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
		
		// Bei (den einzelnen innenliegenden) Systemstopps,
		// werden die erfolgreich berechneten CRC - Pruefungen zurueckgemeldet.
		//		if (art != SS_UPDATE) {
	/*
		short module, function, error = IV_ERROR_SUCCESS;
		// nachdem der CRC geprueft wurde, kommt ein Bestaetigungspaket,
		// dieses musz hier seperat abgegriffen werden.
		if ((m_result = Pending(deviceID, module, function, error, m_data, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitXPortMonitor [ Quittierungsprfantwort - CRC schlug fehl (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
		if ((module == IV_MODULE_SYSTEM) && (function == IV_FUNCTION_EXIT_XPORT_MONITOR_OK)) {
			
			Trace("%s(%i):INFO(3): CChannel4ModuleSystem::ExitXPortMonitor [ Antwort von CRC OK ]\n", __FILE__, __LINE__);
		}
		
		// evntl. aktiven Fehler auswerten
		if (error != IV_ERROR_SUCCESS) {

			m_result = error;
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR_OK);
			return m_result;
		}
	*/
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR_OK);
			return m_result;
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitXPortMonitor [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}



// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::MatchPortSetFactoryDefault(short deviceID, char *buf, int &count)
{

	// Execute ...

	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::ExitXPortMonitorOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::ExitXPortMonitorOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitXPortMonitorOK\n", __FILE__, __LINE__);
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_EXIT_XPORT_MONITOR_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::ExitXPortMonitorOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}


// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::OpenComServerMode(short deviceID, char *comm, unsigned long baudRate, unsigned char byteSize, unsigned char parity, unsigned char stopBits, unsigned short flags, unsigned short timeoutToClose)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::OpenComServerMode [ %i, %s, %i, %i, %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, comm, baudRate, byteSize, parity, stopBits, timeoutToClose);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		// Alle Zusatzparameter uebernehmen
		count += sprintf((char*)&m_data[count], "%s", comm) + 1;
		*(unsigned long*)&m_data[count] = baudRate;
		count += sizeof(unsigned long);
		m_data[count] = byteSize;
		count += sizeof(unsigned char);
		m_data[count] = parity;
		count += sizeof(unsigned char);
		m_data[count] = stopBits;
		count += sizeof(unsigned char);
		*(unsigned short*)&m_data[count] = flags;
		count += sizeof(unsigned short);
		*(unsigned short*)&m_data[count] = timeoutToClose;
		count += sizeof(unsigned short);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_OPEN_COM_SERVER_MODE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_OPEN_COM_SERVER_MODE);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::OpenComServerMode [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}

		// Aktive Antwort abwarten
		if ((m_result = Execute(IV_CONTEXT_SLAVE, IV_MODULE_SYSTEM, IV_FUNCTION_OPEN_COM_SERVER_MODE_OK, m_data, count, (IV_PENDING_TIMEOUT / GetTimeout()))) != IV_ERROR_SUCCESS ) {

			// Fehler ausgeben
			TraceError(GetDeviceIDRemote(), IV_MODULE_SYSTEM, IV_FUNCTION_OPEN_COM_SERVER_MODE_OK);
			return m_result;
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_OPEN_COM_SERVER_MODE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::OpenComServerMode [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::OpenComServerModeOK(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::OpenComServerModeOK [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::OpenComServerModeOK\n", __FILE__, __LINE__);
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_OPEN_COM_SERVER_MODE_OK, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::OpenComServerModeOK [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}
// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::CloseComServerMode(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::CloseComServerMode [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_CLOSE_COM_SERVER_MODE, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_CLOSE_COM_SERVER_MODE);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::CloseComServerMode [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_CLOSE_COM_SERVER_MODE, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::CloseComServerMode [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Ermittelt die Information zu einem Modultyp
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param name Das anzusprechende Modul. (ACCESS.MODULE fuer Zutrittskontrollmodul)
 * @param param Abhaengig vom verwendeten Namen. (Bei ACCESS.MODULE gibt es die TM-Nummer des Moduls )
 * @param info Zeiger auf Zeichenkettenpuffer fuer Rueckgabe.
 * @param infoLength Laenge des Zeichenkettenpuffers fuer Rueckgabe
 */
int CChannel4ModuleSystem::GetInfo(short deviceID, char *name, char *param, char *info, int &infoLength)

{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetInfo [ %i, %s, %s, %s, %i ]\n", __FILE__, __LINE__, deviceID, name, param, info, infoLength);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		count = sprintf((char*)m_data, name) + 1;
		count += sprintf((char*)&m_data[count], param) + 1;

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_INFO, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_INFO);
			return m_result;
		}


		// Antwortdaten erwartet
		if ((unsigned)count < (strlen(name) + 1 + strlen(param) + 1)) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetInfo [ Antwort ist zu kurz. ]\n", __FILE__, __LINE__);
		}

		int i, offs;
		// Name uebergehen
		offs = strlen((char*)m_data) + 1;
		// Parameter uebergehen
		offs += strlen((char*)&m_data[offs]) + 1;

		// Wert uebernehmen
		for (i=0; (i < (count - offs)) && (i < infoLength); i++) {
		
			info[i] = m_data[offs + i];
		}
		// Uebergebene Laenge mitteilen
		infoLength = i - 1;	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_INFO, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetInfo [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

// ##################################################################
/**
 * @brief Aktivieren oder Deaktivieren einer Benachrichtigung.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param type Benachrichtigungstyp
 * @param state Zu setzender Zustand.
 */
int CChannel4ModuleSystem::SetNotify(short deviceID, unsigned char type, unsigned char state)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetNotify [ %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, type, state);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		m_data[count] = type;
		count += sizeof(unsigned char);
		m_data[count] = state;
		count += sizeof(unsigned char);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_NOTIFY, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_NOTIFY);
			return m_result;
		}


		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetNotify [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_NOTIFY, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetNotify [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}

	return m_result;
}


// ##################################################################
/**
 * @brief Aktivieren oder Deaktivieren einer Benachrichtigung.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param type Benachrichtigungstyp
 * @param state Aktuell gesetzter Zustand.
 */
int CChannel4ModuleSystem::GetNotify(short deviceID, unsigned char type, unsigned char &state)

{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetNotify [ %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, type, state);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		m_data[count] = type;
		count += sizeof(unsigned char);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_NOTIFY, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_NOTIFY);
			return m_result;
		}


		// Antwortdaten erwartet
		if (count != sizeof(unsigned char)) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetNotify [ Antwort ist zu lang oder kurz. ]\n", __FILE__, __LINE__);
		} else {

			// Gemeldeten Zustand uebernehmen
			state = m_data[0];
		}

	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_NOTIFY, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetNotify [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
 * @brief Abfragen der Softwareinfo der eingespielten Anwendungsfirmware.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 * @param swi Puffer fr die Softwareinfo.
 * @param infoLength Lnge des Puffers und bergebene Anzahl daten.
 */
int CChannel4ModuleSystem::GetSoftwareInfo(short deviceID, unsigned char *swi, int &infoLength)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetSoftwareInfo [ %i, 0x%08X, %i ]\n", __FILE__, __LINE__, deviceID, swi, infoLength);

	int i, count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SOFTWARE_INFO, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SOFTWARE_INFO);
			return m_result;
		}

		// Antwortdaten erwartet
		for (i=0; i < count && i < infoLength; i++) {

			swi[i] = m_data[i];
		}
		infoLength = i;
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SOFTWARE_INFO, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetSoftwareInfo [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceIDRemote Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::SetSystemFlags(short deviceID, unsigned long flags)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SetSystemFlags [ %i, %i ]\n", __FILE__, __LINE__, deviceID, flags);
	
	int count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();
		
		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);
		
		
		// Den Geraetetyp uebernehmen.
		*(unsigned long*)&m_data[0] = flags;
		count += sizeof(unsigned long);
		
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYSTEM_FLAGS, m_data, count)) != IV_ERROR_SUCCESS) {
			
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYSTEM_FLAGS);
			return m_result;
		}
		
		// Keine Antwortdaten erwartet
		if (count) {
			
			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SetSystemFlags [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {
		
		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYSTEM_FLAGS, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SetSystemFlags [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceIDRemote Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::GetSystemFlags(short deviceID, unsigned long &flags)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::GetSystemFlags [ %i, %i ]\n", __FILE__, __LINE__, deviceID, flags);
	
	int count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();
		
		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);
		
		
		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYSTEM_FLAGS, m_data, count)) != IV_ERROR_SUCCESS) {
			
			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYSTEM_FLAGS);
			return m_result;
		}
		
		// OK
		if (count != sizeof(unsigned long)) {
			
			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::GetSystemFlags [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}
		
		flags = *(unsigned long*)m_data;
	} else {
		
		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYSTEM_FLAGS, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetSystemFlags [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}

	return m_result;
}


// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::SystemReadRecord(short deviceID, unsigned char *buf, int &count, unsigned char &status)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SystemReadRecord [ %i, 0x08X, %i, %i ]\n", __FILE__, __LINE__, deviceID, buf, count, status);

	int i;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYS_RECORD, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYS_RECORD);
			return m_result;
		}

		// OK
		switch(m_data[0]) {
		case IV_ANSW_NO_SYS_RECORD:         // kein Datensatz vorhanden
			status = 0;
			break;
		case IV_ANSW_ONE_SYS_RECORD:        // ein Systemdatensatz 
			status = 1;
			break;
		default:
			status = 0;
			break;
		}
		if (((status == 0) && (count == 0)) || (count > IV_SYS_RECORDS_MAX)) {

			return -IV_ERROR_SYS_RECORD_DATA_SIZE;
		}

		for (i=0; i < count; i++) {

			buf[i] = m_data[i];
		}

	} else {

		unsigned char data[IV_SYS_RECORDS_MAX];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_GET_SYS_RECORD, data, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemReadRecord [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}
	return m_result;
}

int CChannel4ModuleSystem::SystemQuitRecord(short deviceID, unsigned char &status)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SystemQuitRecord [ %i, %i ]\n", __FILE__, __LINE__, deviceID, status);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYS_RECORD, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYS_RECORD);
			return m_result;
		}

		// OK
		if (count > sizeof(unsigned char)) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SystemQuitRecord [ Antwortparameter (%i Byte) ]\n", __FILE__, __LINE__, count);
		}

		switch(m_data[0]) {
		case 0:
			status = 0;
			break;
		case IV_ANSW_ACK_ON_SYS_RECORD:        // Quittung erhalten (fuer Online-Datensatz) 
			status = 1;
			break;
		}
	} else {

		unsigned char data[1];

		////if (m_records.size()) {

		////	CRecord &record = m_records.front();

		////	switch(record.m_data[0]) {
		////	case MB_ANSW_NO_RECORD:             // kein Datensatz vorhanden
		////		data[0] = 0;
		////		break;
		////	case MB_ANSW_ONLINE_RECORD:         // Online Datensatz 
		////	case MB_ANSW_OLD_ONLINE_RECORD:     // wiederholt gesendeter Online Datensatz 
		////		data[0] = MB_ANSW_ACK_ON_RECORD;
		////		break;
		////	case MB_ANSW_OFFLINE_RECORD:        // Offline Datensatz 
		////	case MB_ANSW_OLD_OFFLINE_RECORD:    // wiederholt gesendeter Offline Datensatz
		////		data[0] = MB_ANSW_ACK_OFF_RECORD;
		////		break;
		////	}

		////	count = sizeof(unsigned char);

		////	// Datensatz loeschen
		////	m_records.pop();
		////} else {

		////	data[0] = 0;
		////	count = sizeof(unsigned char);
		////}

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_SET_SYS_RECORD, data, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemQuitRecord [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}

	return m_result;

}

int CChannel4ModuleSystem::SystemRestoreRecords(short deviceID)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::SystemRestoreRecords [ %i ]\n", __FILE__, __LINE__, deviceID);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);


		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_RESTORE_ALLSYS_RECORDS, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_RESTORE_ALLSYS_RECORDS);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::SystemRestoreRecords [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}
	} else {

		unsigned char tmp[4];
		count = 0;

		//		while (m_records.size()) {
		//			m_records.pop();
		//		}

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_RESTORE_ALLSYS_RECORDS, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::SystemRestoreRecords [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
	}

	return m_result;

}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::PasswordCheck(short deviceID, char *password)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::PasswordCheck [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, password);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		// Ob der Befehl untersttzt wird und das Gert geschtzt ist, intern halten.
		SetFlagPasswordProtection(FALSE);
		SetFlagPasswordProtected(FALSE);

		// Puffer loeschen
		memset(m_data, 0, sizeof(m_data));
		// Der Passwortpuffer wird mit 17 Zeichen verschluesselt
		count = 17;

		// Initialisieren der Verschluesselung
		DF4LoadCryptKey();
		DF4Init(TRUE);

		// Nur wenn Passwort angegeben wurde.
		if (strlen(password)) {

			// Passwort uebernehmen
			strncpy((char*)m_data, password, 16);
		}

		// Verschluesseln
		DF4(m_data, count);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_CHECK, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_CHECK);

			// Fehler auswerten
			if (((m_result >> 8) & 0xFF) == 2) {

				// Funktion unbekannt

			} else if ((m_result & 0xFF) == 1) {

				// Funktionsfehler, passwort falsch
				// Passwortschutz ist mglich.
				SetFlagPasswordProtection(TRUE);
			}

			return m_result;
		}

		// Befehl erfolgreich, also wird Passwortschutz voll genutzt.
		SetFlagPasswordProtection(TRUE);
		SetFlagPasswordProtected(TRUE);

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::PasswordCheck [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}	

	} else {

		unsigned char tmp[4];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_CHECK, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::PasswordCheck [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

	}


	return m_result;
}

// ##################################################################
/**
* @brief Beschreibung fehlt noch.
*
* @param deviceID Anzusprechende Geraetenummer.
*/
int CChannel4ModuleSystem::PasswordKey(short deviceID, char *key)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::PasswordKey [ %i, 0x%08X ]\n", __FILE__, __LINE__, deviceID, key);

	int count = 0;

	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		// Keine Daten zu senden
		count = 0;

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_KEY, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_KEY);
			return m_result;
		}

		// n Antwortdaten erwartet
		if (count != 17) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::PasswordKey [ Laenge des Passwortschlssels mit %i Byte ist fragwuerdig ]\n", __FILE__, __LINE__, count);
		}

		// Wert uebernehmen
		strcpy(key, (char*)m_data);	

	} else {

		unsigned char tmp[4];
		count = 0;

		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_PASSWORD_KEY, tmp, count)) != IV_ERROR_SUCCESS) {

			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::GetSystemVariable [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}

	}


	return m_result;
}

// ##################################################################
/**
 * @brief Beschreibung fehlt noch.
 *
 * @param deviceID Anzusprechende Geraetenummer.
 */
int CChannel4ModuleSystem::PressVirtualKey(short deviceID, unsigned char vk, unsigned char flags)
{
	Trace("%s(%i):INFO(3): CChannel4ModuleSystem::PressVirtualKey [ %i, %i, %i ]\n", __FILE__, __LINE__, deviceID, vk, flags);

	int count = 0;
	
	// Funktion in Remoteklasse aufrufen?
	if (GetDeviceID() != deviceID) {

		// Umgebung zuruecksetzen
		Reset();

		// Remoteadresse setzen.
		SetDeviceIDRemote(deviceID);

		// Keycode
		m_data[count] = vk;
		count += sizeof(unsigned char);

		// Flags
		m_data[count] = flags;
		count += sizeof(unsigned char);

		if ((m_result = Execute(IV_CONTEXT_MASTER, IV_MODULE_SYSTEM, IV_FUNCTION_PRESS_VIRTUAL_KEY, m_data, count)) != IV_ERROR_SUCCESS) {

			// Fehler ausgeben
			TraceError(deviceID, IV_MODULE_SYSTEM, IV_FUNCTION_PRESS_VIRTUAL_KEY);
			return m_result;
		}

		// Keine Antwortdaten erwartet
		if (count) {

			Trace("%s(%i):WARNING(1): CChannel4ModuleSystem::PressVirtualKey [ Antwort enhaelt %i Byte an unntze Daten. ]\n", __FILE__, __LINE__, count);
		}	
	
	} else {

		unsigned char tmp[4];
		count = 0;
		
		// Antwort des Befehls senden.
		if ((m_result = Execute(IV_CONTEXT_TRANSMIT_ANSWER, IV_MODULE_SYSTEM, IV_FUNCTION_PRESS_VIRTUAL_KEY, tmp, count)) != IV_ERROR_SUCCESS) {
			
			Trace("%s(%i):ERROR(1): CChannel4ModuleSystem::PressVirtualKey [ Execute (%i) ]\n", __FILE__, __LINE__, m_result);
			return m_result;
		}
		
	}


	return m_result;
}

#ifndef DATAFOX_STUDIO_IV

// Funktions-Stumps

// MODULE_HARDWARE
int CChannel4ModuleSystem::SetTypeDisplay(short deviceID, unsigned char value, unsigned short value2, int checked)     { if (GetDeviceID() != deviceID) return -IV_ERROR_FUNCTION_UNAVAILABLE; else return 0x0200; }
int CChannel4ModuleSystem::SetTypeKeypad(short deviceID, unsigned char value, unsigned short value2, int checked)      { if (GetDeviceID() != deviceID) return -IV_ERROR_FUNCTION_UNAVAILABLE; else return 0x0200; }
int CChannel4ModuleSystem::SetTypeTransponder(short deviceID, unsigned char value, unsigned short value2, int checked) { if (GetDeviceID() != deviceID) return -IV_ERROR_FUNCTION_UNAVAILABLE; else return 0x0200; }

int CChannel4ModuleSystem::SetSerial(short deviceID, unsigned long serial, unsigned long value2)	                   { if (GetDeviceID() != deviceID) return -IV_ERROR_FUNCTION_UNAVAILABLE; else return 0x0200; }

#endif
